// 
// File:          gov_cca_ports_ConnectionEventListener.hxx
// Symbol:        gov.cca.ports.ConnectionEventListener-v0.8.5
// Symbol Type:   interface
// Babel Version: 1.4.0
// Description:   Client-side glue code for gov.cca.ports.ConnectionEventListener
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_gov_cca_ports_ConnectionEventListener_hxx
#define included_gov_cca_ports_ConnectionEventListener_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace gov { 
  namespace cca { 
    namespace ports { 

      class ConnectionEventListener;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::gov::cca::ports::ConnectionEventListener >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 
    namespace ports { 

      class ConnectionEvent;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_gov_cca_ports_ConnectionEventListener_IOR_h
#include "gov_cca_ports_ConnectionEventListener_IOR.h"
#endif
#ifndef included_sidl_BaseInterface_hxx
#include "sidl_BaseInterface.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace gov { 
  namespace cca { 
    namespace ports { 

      /**
       * Symbol "gov.cca.ports.ConnectionEventListener" (version 0.8.5)
       * 
       * This is the interface that a component must provide in order to 
       * be notified of <code>ConnectEvents</code>.
       */
      class ConnectionEventListener: public virtual ::sidl::BaseInterface {

        //////////////////////////////////////////////////
        // 
        // Special methods for throwing exceptions
        // 

      private:
        static 
        void
        throwException0(
          const char* methodName,
          struct sidl_BaseInterface__object *_exception
        )
          // throws:
        ;

        //////////////////////////////////////////////////
        // 
        // User Defined Methods
        // 

      public:

        /**
         *  
         * Called on all listeners when a connection is made or broken. 
         */
        void
        connectionActivity (
          /* in */const ::gov::cca::ports::ConnectionEvent& ce
        )
        ;



        //////////////////////////////////////////////////
        // 
        // End User Defined Methods
        // (everything else in this file is specific to
        //  Babel's C++ bindings)
        // 

      public:
        typedef struct gov_cca_ports_ConnectionEventListener__object ior_t;
        typedef struct gov_cca_ports_ConnectionEventListener__external ext_t;
        typedef struct gov_cca_ports_ConnectionEventListener__sepv sepv_t;

        // default constructor
        ConnectionEventListener()  : 
          gov_cca_ports_ConnectionEventListener_IORCache((ior_t*) NULL){ }

#ifdef WITH_RMI

        // RMI connect
        static inline ::gov::cca::ports::ConnectionEventListener _connect( 
          /*in*/ const std::string& url ) { 
          return _connect(url, true);
        }

        // RMI connect 2
        static ::gov::cca::ports::ConnectionEventListener _connect( /*in*/ 
          const std::string& url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

        // default destructor
        virtual ~ConnectionEventListener () { }

        // copy constructor
        ConnectionEventListener ( const ConnectionEventListener& original );

        // assignment operator
        ConnectionEventListener& operator= ( const ConnectionEventListener& rhs 
          );

        // conversion from ior to C++ class
        ConnectionEventListener ( ConnectionEventListener::ior_t* ior );

        // Alternate constructor: does not call addRef()
        // (sets d_weak_reference=isWeak)
        // For internal use by Impls (fixes bug#275)
        ConnectionEventListener ( ConnectionEventListener::ior_t* ior, bool 
          isWeak );

        inline ior_t* _get_ior() const throw() {
          if(!gov_cca_ports_ConnectionEventListener_IORCache) { 
            gov_cca_ports_ConnectionEventListener_IORCache = 
              ::gov::cca::ports::ConnectionEventListener::_cast((void*)d_self);
            if (gov_cca_ports_ConnectionEventListener_IORCache) {
              struct sidl_BaseInterface__object *throwaway_exception;
              (gov_cca_ports_ConnectionEventListener_IORCache->d_epv->f_deleteRef)
                (gov_cca_ports_ConnectionEventListener_IORCache->d_object, 
                &throwaway_exception);  
            }  
          }
          return gov_cca_ports_ConnectionEventListener_IORCache;
        }

        inline void _set_ior( ior_t* ptr ) throw () { 
          d_self = reinterpret_cast< void*>(ptr);
          gov_cca_ports_ConnectionEventListener_IORCache = (ior_t*) ptr;

        }

        virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                       const ::std::type_info &argtype );

        bool _is_nil() const throw () { return (d_self==0); }

        bool _not_nil() const throw () { return (d_self!=0); }

        bool operator !() const throw () { return (d_self==0); }

        static inline const char * type_name() throw () { return 
          "gov.cca.ports.ConnectionEventListener";}

        static struct gov_cca_ports_ConnectionEventListener__object* _cast(
          const void* src);

        // execute member function by name
        void _exec(const std::string& methodName,
                   ::sidl::rmi::Call& inArgs,
                   ::sidl::rmi::Return& outArgs);

        /**
         * Get the URL of the Implementation of this object (for RMI)
         */
        ::std::string
        _getURL() // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable method hooks invocation.
         */
        void
        _set_hooks (
          /* in */bool enable
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable interface contract enforcement.
         */
        void
        _set_contracts (
          /* in */bool enable,
          /* in */const ::std::string& enfFilename,
          /* in */bool resetCounters
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to dump contract enforcement statistics.
         */
        void
        _dump_stats (
          /* in */const ::std::string& filename,
          /* in */const ::std::string& prefix
        )
        // throws:
        //    ::sidl::RuntimeException
        ;

        // return true iff object is remote
        bool _isRemote() const { 
          ior_t* self = const_cast<ior_t*>(_get_ior() );
          struct sidl_BaseInterface__object *throwaway_exception;
          return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == 
            TRUE;
        }

        // return true iff object is local
        bool _isLocal() const {
          return !_isRemote();
        }

      protected:
        // Pointer to external (DLL loadable) symbols (shared among instances)
        static const ext_t * s_ext;

      public:
        static const ext_t * _get_ext() throw ( ::sidl::NullIORException );


        //////////////////////////////////////////////////
        // 
        // Locally Cached IOR pointer
        // 

      protected:
        mutable ior_t* gov_cca_ports_ConnectionEventListener_IORCache;
      }; // end class ConnectionEventListener
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

extern "C" {


#pragma weak gov_cca_ports_ConnectionEventListener__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct gov_cca_ports_ConnectionEventListener__object*
  gov_cca_ports_ConnectionEventListener__connectI(const char * url, sidl_bool 
    ar, struct sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::gov::cca::ports::ConnectionEventListener > {
    typedef array< ::gov::cca::ports::ConnectionEventListener > cxx_array_t;
    typedef ::gov::cca::ports::ConnectionEventListener cxx_item_t;
    typedef struct gov_cca_ports_ConnectionEventListener__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct gov_cca_ports_ConnectionEventListener__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< 
      ::gov::cca::ports::ConnectionEventListener > > iterator;
    typedef const_array_iter< array_traits< 
      ::gov::cca::ports::ConnectionEventListener > > const_iterator;
  };

  // array specialization
  template<>
  class array< ::gov::cca::ports::ConnectionEventListener >: public 
    interface_array< array_traits< ::gov::cca::ports::ConnectionEventListener > 
    > {
  public:
    typedef interface_array< array_traits< 
      ::gov::cca::ports::ConnectionEventListener > > Base;
    typedef array_traits< ::gov::cca::ports::ConnectionEventListener 
      >::cxx_array_t          cxx_array_t;
    typedef array_traits< ::gov::cca::ports::ConnectionEventListener 
      >::cxx_item_t           cxx_item_t;
    typedef array_traits< ::gov::cca::ports::ConnectionEventListener 
      >::ior_array_t          ior_array_t;
    typedef array_traits< ::gov::cca::ports::ConnectionEventListener 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::gov::cca::ports::ConnectionEventListener 
      >::ior_item_t           ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct gov_cca_ports_ConnectionEventListener__array* src = 0) : Base(
      src) {}

    /**
     * copy constructor
     */
    array( const array< ::gov::cca::ports::ConnectionEventListener >&src) : 
      Base(src) {}

    /**
     * assignment
     */
    array< ::gov::cca::ports::ConnectionEventListener >&
    operator =( const array< ::gov::cca::ports::ConnectionEventListener >&rhs ) 
      { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_gov_cca_ports_ConnectionEvent_hxx
#include "gov_cca_ports_ConnectionEvent.hxx"
#endif
#endif
