// 
// File:          gov_cca_ports_MPIServer.hxx
// Symbol:        gov.cca.ports.MPIServer-v0.8.5
// Symbol Type:   interface
// Babel Version: 1.4.0
// Description:   Client-side glue code for gov.cca.ports.MPIServer
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_gov_cca_ports_MPIServer_hxx
#define included_gov_cca_ports_MPIServer_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace gov { 
  namespace cca { 
    namespace ports { 

      class MPIServer;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::gov::cca::ports::MPIServer >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class AbstractFramework;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class CCAException;
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_gov_cca_ports_MPIServer_IOR_h
#include "gov_cca_ports_MPIServer_IOR.h"
#endif
#ifndef included_gov_cca_Port_hxx
#include "gov_cca_Port.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace gov { 
  namespace cca { 
    namespace ports { 

      /**
       * Symbol "gov.cca.ports.MPIServer" (version 0.8.5)
       */
      class MPIServer: public virtual ::gov::cca::Port {

        //////////////////////////////////////////////////
        // 
        // Special methods for throwing exceptions
        // 

      private:
        static 
        void
        throwException0(
          const char* methodName,
          struct sidl_BaseInterface__object *_exception
        )
          // throws:
        ;
        static 
        void
        throwException1(
          const char* methodName,
          struct sidl_BaseInterface__object *_exception
        )
          // throws:
          //    ::gov::cca::CCAException
          //    ::sidl::RuntimeException
        ;

        //////////////////////////////////////////////////
        // 
        // User Defined Methods
        // 

      public:

        /**
         *  Check instance status. Only one init call per instance is allowed.
         * @return true if initAsService or initComponent already done.
         */
        bool
        isInitialized() ;


        /**
         *  Create and add to the framework MPIService and MPIBorrow
         * support services. This will appear in the frame as an
         * MPISetup component. MPI_Init must have been called before
         * this is called.
         * This entry point should work for any cca framework bootstrapping
         * in commworld or otherwise scoped communicator via the standard
         * ServiceRegistry interface. This will not automatically
         * cause the component class providing this interface to appear in the
         * list of classes the user may instantiate.
         * The borrowComm and dupComm may be identical.
         * In the MPI sense, this call must be collective on the scopes of both
         * borrowComm and dupComm.
         * 
         * @param borrowComm  the (valid) shared communicator 
         * for those using MPIBorrow (in fortran form).
         * @param dupComm  the (valid) communicator (in fortran form) to duplicate 
         * for those using MPIService.
         * @param af The frame into which the server will add itself.
         * In principle, the caller should be able to forget about the class object
         * they are holding to make this call.
         */
        void
        initAsService (
          /* in */int64_t borrowComm,
          /* in */int64_t dupComm,
          /* inout */::gov::cca::AbstractFramework& af
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Set the communicators on an uninitialized mpi support component
         * instance created like any other.
         * This does NOT cause the component being initialized to register itself
         * as a service for all comers.
         * 
         * The borrowComm and dupComm may be identical.
         * In the MPI sense, this call must be collective on the scopes of both
         * borrowComm and dupComm.
         * 
         * @param borrowComm  the (valid) shared communicator 
         * for those using MPIBorrow (in fortran form).
         * @param dupComm  the (valid) communicator (in fortran form) to duplicate 
         * for those using MPIService.
         * @param af The frame into which the server will add itself.
         * In principle, the caller should be able to forget about the class object
         * they are holding to make this call.
         */
        void
        initComponent (
          /* in */int64_t borrowComm,
          /* in */int64_t dupComm
        )
        ;



        /**
         * Shutdown the previous mpi-related services.
         * @param reclaim if reclaim true, try to release communicator
         * resources allocated in MPIService support.
         * Otherwise, lose them.
         */
        void
        finalize (
          /* in */bool reclaim
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        //////////////////////////////////////////////////
        // 
        // End User Defined Methods
        // (everything else in this file is specific to
        //  Babel's C++ bindings)
        // 

      public:
        typedef struct gov_cca_ports_MPIServer__object ior_t;
        typedef struct gov_cca_ports_MPIServer__external ext_t;
        typedef struct gov_cca_ports_MPIServer__sepv sepv_t;

        // default constructor
        MPIServer()  : gov_cca_ports_MPIServer_IORCache((ior_t*) NULL){ }

#ifdef WITH_RMI

        // RMI connect
        static inline ::gov::cca::ports::MPIServer _connect( /*in*/ const 
          std::string& url ) { 
          return _connect(url, true);
        }

        // RMI connect 2
        static ::gov::cca::ports::MPIServer _connect( /*in*/ const std::string& 
          url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

        // default destructor
        virtual ~MPIServer () { }

        // copy constructor
        MPIServer ( const MPIServer& original );

        // assignment operator
        MPIServer& operator= ( const MPIServer& rhs );

        // conversion from ior to C++ class
        MPIServer ( MPIServer::ior_t* ior );

        // Alternate constructor: does not call addRef()
        // (sets d_weak_reference=isWeak)
        // For internal use by Impls (fixes bug#275)
        MPIServer ( MPIServer::ior_t* ior, bool isWeak );

        inline ior_t* _get_ior() const throw() {
          if(!gov_cca_ports_MPIServer_IORCache) { 
            gov_cca_ports_MPIServer_IORCache = 
              ::gov::cca::ports::MPIServer::_cast((void*)d_self);
            if (gov_cca_ports_MPIServer_IORCache) {
              struct sidl_BaseInterface__object *throwaway_exception;
              (gov_cca_ports_MPIServer_IORCache->d_epv->f_deleteRef)(
                gov_cca_ports_MPIServer_IORCache->d_object, 
                &throwaway_exception);  
            }  
          }
          return gov_cca_ports_MPIServer_IORCache;
        }

        inline void _set_ior( ior_t* ptr ) throw () { 
          d_self = reinterpret_cast< void*>(ptr);
          gov_cca_ports_MPIServer_IORCache = (ior_t*) ptr;

          gov_cca_Port_IORCache = NULL;
        }

        virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                       const ::std::type_info &argtype );

        bool _is_nil() const throw () { return (d_self==0); }

        bool _not_nil() const throw () { return (d_self!=0); }

        bool operator !() const throw () { return (d_self==0); }

        static inline const char * type_name() throw () { return 
          "gov.cca.ports.MPIServer";}

        static struct gov_cca_ports_MPIServer__object* _cast(const void* src);

        // execute member function by name
        void _exec(const std::string& methodName,
                   ::sidl::rmi::Call& inArgs,
                   ::sidl::rmi::Return& outArgs);

        /**
         * Get the URL of the Implementation of this object (for RMI)
         */
        ::std::string
        _getURL() // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable method hooks invocation.
         */
        void
        _set_hooks (
          /* in */bool enable
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable interface contract enforcement.
         */
        void
        _set_contracts (
          /* in */bool enable,
          /* in */const ::std::string& enfFilename,
          /* in */bool resetCounters
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to dump contract enforcement statistics.
         */
        void
        _dump_stats (
          /* in */const ::std::string& filename,
          /* in */const ::std::string& prefix
        )
        // throws:
        //    ::sidl::RuntimeException
        ;

        // return true iff object is remote
        bool _isRemote() const { 
          ior_t* self = const_cast<ior_t*>(_get_ior() );
          struct sidl_BaseInterface__object *throwaway_exception;
          return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == 
            TRUE;
        }

        // return true iff object is local
        bool _isLocal() const {
          return !_isRemote();
        }

      protected:
        // Pointer to external (DLL loadable) symbols (shared among instances)
        static const ext_t * s_ext;

      public:
        static const ext_t * _get_ext() throw ( ::sidl::NullIORException );


        //////////////////////////////////////////////////
        // 
        // Locally Cached IOR pointer
        // 

      protected:
        mutable ior_t* gov_cca_ports_MPIServer_IORCache;
      }; // end class MPIServer
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

extern "C" {


#pragma weak gov_cca_ports_MPIServer__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct gov_cca_ports_MPIServer__object*
  gov_cca_ports_MPIServer__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::gov::cca::ports::MPIServer > {
    typedef array< ::gov::cca::ports::MPIServer > cxx_array_t;
    typedef ::gov::cca::ports::MPIServer cxx_item_t;
    typedef struct gov_cca_ports_MPIServer__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct gov_cca_ports_MPIServer__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::gov::cca::ports::MPIServer > > iterator;
    typedef const_array_iter< array_traits< ::gov::cca::ports::MPIServer > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::gov::cca::ports::MPIServer >: public interface_array< 
    array_traits< ::gov::cca::ports::MPIServer > > {
  public:
    typedef interface_array< array_traits< ::gov::cca::ports::MPIServer > > 
      Base;
    typedef array_traits< ::gov::cca::ports::MPIServer >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::gov::cca::ports::MPIServer >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::gov::cca::ports::MPIServer >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::gov::cca::ports::MPIServer >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::gov::cca::ports::MPIServer >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct gov_cca_ports_MPIServer__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::gov::cca::ports::MPIServer >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::gov::cca::ports::MPIServer >&
    operator =( const array< ::gov::cca::ports::MPIServer >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
