// 
// File:          gov_cca_ports_ParameterGetListener.hxx
// Symbol:        gov.cca.ports.ParameterGetListener-v0.8.5
// Symbol Type:   interface
// Babel Version: 1.4.0
// Description:   Client-side glue code for gov.cca.ports.ParameterGetListener
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_gov_cca_ports_ParameterGetListener_hxx
#define included_gov_cca_ports_ParameterGetListener_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace gov { 
  namespace cca { 
    namespace ports { 

      class ParameterGetListener;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::gov::cca::ports::ParameterGetListener >;
}
// 
// Forward declarations for method dependencies.
// 
namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_gov_cca_ports_ParameterGetListener_IOR_h
#include "gov_cca_ports_ParameterGetListener_IOR.h"
#endif
#ifndef included_sidl_BaseInterface_hxx
#include "sidl_BaseInterface.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace gov { 
  namespace cca { 
    namespace ports { 

      /**
       * Symbol "gov.cca.ports.ParameterGetListener" (version 0.8.5)
       * 
       *  This interface is typically implemented by a 
       * component writer using the ParameterPortFactory
       * in a very dynamic fashion. Most component writers don't
       * need it.
       * 
       * The ParameterGet listeners are called when
       * the readMap function is called on
       * the ParameterPort interface. 
       * The listener (usually the component owning the typemap) can change the 
       * contents (title, groups, parameters) of the ParameterPort
       * in their updateParameterPort function. These changed
       * values will be returned to the caller (framework/gui).
       * 
       * This is handy when the contents of one ParameterPort depend
       * on values already set in another ParameterPort
       * on the same component. E.g. selection of a particular chemical
       * reaction mechanism in the first ParameterPort defines the
       * set of chemical species that need initial-concentrations defined
       * in the second ParameterPort.
       * 
       * The fact that looking at a ParameterPort
       * gives an opportunity for it to change will lead to Heisenbugs
       * in the hands of an inept programmer.
       * 
       * The name of the parameter port which is being used is passed
       * so the component using the ParameterPortFactory to manage more 
       * than one Parameter port can tell which one is being updated.
       * 
       * The component should return TRUE if the contents of the
       * parameter port were changed (cleared or added to) in the
       * update function or if the component wants to receive all fresh input
       * for current values.
       * 
       * @see ParameterSetListener
       */
      class ParameterGetListener: public virtual ::sidl::BaseInterface {

        //////////////////////////////////////////////////
        // 
        // Special methods for throwing exceptions
        // 

      private:
        static 
        void
        throwException0(
          const char* methodName,
          struct sidl_BaseInterface__object *_exception
        )
          // throws:
        ;

        //////////////////////////////////////////////////
        // 
        // User Defined Methods
        // 

      public:

        /**
         *  Inform the listener that someone is about to fetch their 
         * typemap. The return should be true if the listener
         * has changed the ParameterPort definitions.
         */
        bool
        updateParameterPort (
          /* in */const ::std::string& portName
        )
        ;



        //////////////////////////////////////////////////
        // 
        // End User Defined Methods
        // (everything else in this file is specific to
        //  Babel's C++ bindings)
        // 

      public:
        typedef struct gov_cca_ports_ParameterGetListener__object ior_t;
        typedef struct gov_cca_ports_ParameterGetListener__external ext_t;
        typedef struct gov_cca_ports_ParameterGetListener__sepv sepv_t;

        // default constructor
        ParameterGetListener()  : gov_cca_ports_ParameterGetListener_IORCache((
          ior_t*) NULL){ }

#ifdef WITH_RMI

        // RMI connect
        static inline ::gov::cca::ports::ParameterGetListener _connect( /*in*/ 
          const std::string& url ) { 
          return _connect(url, true);
        }

        // RMI connect 2
        static ::gov::cca::ports::ParameterGetListener _connect( /*in*/ const 
          std::string& url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

        // default destructor
        virtual ~ParameterGetListener () { }

        // copy constructor
        ParameterGetListener ( const ParameterGetListener& original );

        // assignment operator
        ParameterGetListener& operator= ( const ParameterGetListener& rhs );

        // conversion from ior to C++ class
        ParameterGetListener ( ParameterGetListener::ior_t* ior );

        // Alternate constructor: does not call addRef()
        // (sets d_weak_reference=isWeak)
        // For internal use by Impls (fixes bug#275)
        ParameterGetListener ( ParameterGetListener::ior_t* ior, bool isWeak );

        inline ior_t* _get_ior() const throw() {
          if(!gov_cca_ports_ParameterGetListener_IORCache) { 
            gov_cca_ports_ParameterGetListener_IORCache = 
              ::gov::cca::ports::ParameterGetListener::_cast((void*)d_self);
            if (gov_cca_ports_ParameterGetListener_IORCache) {
              struct sidl_BaseInterface__object *throwaway_exception;
              (gov_cca_ports_ParameterGetListener_IORCache->d_epv->f_deleteRef)(
                gov_cca_ports_ParameterGetListener_IORCache->d_object, 
                &throwaway_exception);  
            }  
          }
          return gov_cca_ports_ParameterGetListener_IORCache;
        }

        inline void _set_ior( ior_t* ptr ) throw () { 
          d_self = reinterpret_cast< void*>(ptr);
          gov_cca_ports_ParameterGetListener_IORCache = (ior_t*) ptr;

        }

        virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                       const ::std::type_info &argtype );

        bool _is_nil() const throw () { return (d_self==0); }

        bool _not_nil() const throw () { return (d_self!=0); }

        bool operator !() const throw () { return (d_self==0); }

        static inline const char * type_name() throw () { return 
          "gov.cca.ports.ParameterGetListener";}

        static struct gov_cca_ports_ParameterGetListener__object* _cast(const 
          void* src);

        // execute member function by name
        void _exec(const std::string& methodName,
                   ::sidl::rmi::Call& inArgs,
                   ::sidl::rmi::Return& outArgs);

        /**
         * Get the URL of the Implementation of this object (for RMI)
         */
        ::std::string
        _getURL() // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable method hooks invocation.
         */
        void
        _set_hooks (
          /* in */bool enable
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable interface contract enforcement.
         */
        void
        _set_contracts (
          /* in */bool enable,
          /* in */const ::std::string& enfFilename,
          /* in */bool resetCounters
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to dump contract enforcement statistics.
         */
        void
        _dump_stats (
          /* in */const ::std::string& filename,
          /* in */const ::std::string& prefix
        )
        // throws:
        //    ::sidl::RuntimeException
        ;

        // return true iff object is remote
        bool _isRemote() const { 
          ior_t* self = const_cast<ior_t*>(_get_ior() );
          struct sidl_BaseInterface__object *throwaway_exception;
          return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == 
            TRUE;
        }

        // return true iff object is local
        bool _isLocal() const {
          return !_isRemote();
        }

      protected:
        // Pointer to external (DLL loadable) symbols (shared among instances)
        static const ext_t * s_ext;

      public:
        static const ext_t * _get_ext() throw ( ::sidl::NullIORException );


        //////////////////////////////////////////////////
        // 
        // Locally Cached IOR pointer
        // 

      protected:
        mutable ior_t* gov_cca_ports_ParameterGetListener_IORCache;
      }; // end class ParameterGetListener
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

extern "C" {


#pragma weak gov_cca_ports_ParameterGetListener__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct gov_cca_ports_ParameterGetListener__object*
  gov_cca_ports_ParameterGetListener__connectI(const char * url, sidl_bool ar, 
    struct sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::gov::cca::ports::ParameterGetListener > {
    typedef array< ::gov::cca::ports::ParameterGetListener > cxx_array_t;
    typedef ::gov::cca::ports::ParameterGetListener cxx_item_t;
    typedef struct gov_cca_ports_ParameterGetListener__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct gov_cca_ports_ParameterGetListener__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::gov::cca::ports::ParameterGetListener > 
      > iterator;
    typedef const_array_iter< array_traits< 
      ::gov::cca::ports::ParameterGetListener > > const_iterator;
  };

  // array specialization
  template<>
  class array< ::gov::cca::ports::ParameterGetListener >: public 
    interface_array< array_traits< ::gov::cca::ports::ParameterGetListener > > {
  public:
    typedef interface_array< array_traits< 
      ::gov::cca::ports::ParameterGetListener > > Base;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener 
      >::cxx_array_t          cxx_array_t;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener >::cxx_item_t 
      cxx_item_t;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener 
      >::ior_array_t          ior_array_t;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener >::ior_item_t 
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct gov_cca_ports_ParameterGetListener__array* src = 0) : Base(
      src) {}

    /**
     * copy constructor
     */
    array( const array< ::gov::cca::ports::ParameterGetListener >&src) : Base(
      src) {}

    /**
     * assignment
     */
    array< ::gov::cca::ports::ParameterGetListener >&
    operator =( const array< ::gov::cca::ports::ParameterGetListener >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
