/*
 * File:          gov_cca_ports_BuilderService_fStub.c
 * Symbol:        gov.cca.ports.BuilderService-v0.8.5
 * Symbol Type:   interface
 * Babel Version: 1.4.0
 * Description:   Client-side glue code for gov.cca.ports.BuilderService
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

/*
 * Symbol "gov.cca.ports.BuilderService" (version 0.8.5)
 * 
 *  
 * BuilderService is a Port implemented by a CCA compliant framework for
 * the purpose of composing components into applications in a standard way.
 * It is meant to expose the Component creation and composition functionality
 * without the specific framework implementation. This interface is expected 
 * to be useful for rapid application development in a scripting language. 
 * Other uses are generic application development environments for CCA 
 * applications. 
 * <p>Each of the fundamental component architecture pieces
 * (instances of Component, Port, and Connection) may have
 * an associated TypeMap of properties managed by the framework.
 * The standardized keys in the properties of a Port are documented
 * in Services.getPortProperties().
 * The standardized keys in the properties of a Component and Connection
 * are documented below.
 * </p>
 * <p>For connection, thus far:
 * <pre>
 * Key         value           meaning
 * cca.isInUse boolean         true if there have been more successful
 * getPort than releasePort calls for the
 * connection at the the time 
 * properties were fetched.
 * </pre>
 * </p>
 * <P>For component, thus far:
 * <pre>
 * Key                 value           meaning
 * cca.className       string          component type
 * </pre>
 * </p>
 */

#ifndef included_gov_cca_ports_BuilderService_fStub_h
#include "gov_cca_ports_BuilderService_fStub.h"
#endif
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "sidlfortran.h"
#ifndef included_sidl_io_Serializer_h
#include "sidl_io_Serializer.h"
#endif
#ifndef included_sidl_io_Deserializer_h
#include "sidl_io_Deserializer.h"
#endif
#include <stdio.h>
#include "sidl_header.h"
#ifndef included_sidl_interface_IOR_h
#include "sidl_interface_IOR.h"
#endif
#ifndef included_sidl_Exception_h
#include "sidl_Exception.h"
#endif
#include "babel_config.h"
#ifdef SIDL_DYNAMIC_LIBRARY
#include "sidl_Loader.h"
#endif
#include "gov_cca_ports_BuilderService_IOR.h"
#include "gov_cca_CCAException_IOR.h"
#include "gov_cca_ComponentID_IOR.h"
#include "gov_cca_ConnectionID_IOR.h"
#include "gov_cca_TypeMap_IOR.h"
#include "sidl_BaseException_IOR.h"
#include "sidl_BaseInterface_IOR.h"
#include "sidl_ClassInfo_IOR.h"
#include "sidl_RuntimeException_IOR.h"
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidlOps_h
#include "sidlOps.h"
#endif
/*
 * Includes for all method dependencies.
 */

#ifndef included_gov_cca_CCAException_fStub_h
#include "gov_cca_CCAException_fStub.h"
#endif
#ifndef included_gov_cca_ComponentID_fStub_h
#include "gov_cca_ComponentID_fStub.h"
#endif
#ifndef included_gov_cca_ConnectionID_fStub_h
#include "gov_cca_ConnectionID_fStub.h"
#endif
#ifndef included_gov_cca_Port_fStub_h
#include "gov_cca_Port_fStub.h"
#endif
#ifndef included_gov_cca_TypeMap_fStub_h
#include "gov_cca_TypeMap_fStub.h"
#endif
#ifndef included_gov_cca_ports_BuilderService_fStub_h
#include "gov_cca_ports_BuilderService_fStub.h"
#endif
#ifndef included_sidl_BaseInterface_fStub_h
#include "sidl_BaseInterface_fStub.h"
#endif
#ifndef included_sidl_ClassInfo_fStub_h
#include "sidl_ClassInfo_fStub.h"
#endif
#ifndef included_sidl_RuntimeException_fStub_h
#include "sidl_RuntimeException_fStub.h"
#endif

#define LANG_SPECIFIC_INIT()
#ifdef WITH_RMI
static struct gov_cca_ports_BuilderService__object* 
  gov_cca_ports_BuilderService__remoteConnect(const char* url, sidl_bool ar, 
  sidl_BaseInterface *_ex);
static struct gov_cca_ports_BuilderService__object* 
  gov_cca_ports_BuilderService__IHConnect(struct 
  sidl_rmi_InstanceHandle__object *instance, struct sidl_BaseInterface__object 
  **_ex);
#endif /*WITH_RMI*/
/*
 * Remote Connector for the class.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__connect_f,GOV_CCA_PORTS_BUILDERSERVICE__CONNECT_F,gov_cca_ports_BuilderService__connect_f)
(
  int64_t *self,
  SIDL_F77_String url
  SIDL_F77_STR_NEAR_LEN_DECL(url),
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(url)
)
{
#ifdef WITH_RMI
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  char* _proxy_url = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_url =
    sidl_copy_fortran_str(SIDL_F77_STR(url),(ptrdiff_t)
      SIDL_F77_STR_LEN(url));
  _proxy_self = gov_cca_ports_BuilderService__remoteConnect(_proxy_url, 1, 
    &_proxy_exception);
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *self = (ptrdiff_t)_proxy_self;
  }
  free((void *)_proxy_url);
#endif /*WITH_RMI*/
}
/*
 * Cast method for interface and type conversions.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__cast_f,GOV_CCA_PORTS_BUILDERSERVICE__CAST_F,gov_cca_ports_BuilderService__cast_f)
(
  int64_t *ref,
  int64_t *retval,
  int64_t *exception
)
{
#ifdef WITH_RMI
  static int connect_loaded = 0;
#endif /*WITH_RMI*/
  struct sidl_BaseInterface__object  *_base =
    (struct sidl_BaseInterface__object *)(ptrdiff_t)*ref;
  struct sidl_BaseInterface__object *proxy_exception;

  *retval = 0;

#ifdef WITH_RMI

  if(!connect_loaded) {
    sidl_rmi_ConnectRegistry_registerConnect("gov.cca.ports.BuilderService", (
      void*)gov_cca_ports_BuilderService__IHConnect, &proxy_exception);
    SIDL_CHECK(proxy_exception);
    connect_loaded = 1;
  }

#endif /*WITH_RMI*/

  if (_base) {
    *retval = (ptrdiff_t)(
      *_base->d_epv->f__cast)(
      _base->d_object,
      "gov.cca.ports.BuilderService", &proxy_exception);
  } else {
    *retval = 0;
    proxy_exception = 0;
  }
#ifdef WITH_RMI
  EXIT:
#endif /*WITH_RMI*/
  *exception = (ptrdiff_t)proxy_exception;
}

/*
 * Cast method for interface and class type conversions.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__cast2_f,GOV_CCA_PORTS_BUILDERSERVICE__CAST2_F,gov_cca_ports_BuilderService__cast2_f)
(
  int64_t *self,
  SIDL_F77_String name
  SIDL_F77_STR_NEAR_LEN_DECL(name),
  int64_t *retval,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(name)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  char* _proxy_name = NULL;
  void* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_name =
    sidl_copy_fortran_str(SIDL_F77_STR(name),(ptrdiff_t)
      SIDL_F77_STR_LEN(name));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__cast))(
      _proxy_self->d_object,
      _proxy_name,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_name);
}


/*
 * Select and execute a method by name
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__exec_f,GOV_CCA_PORTS_BUILDERSERVICE__EXEC_F,gov_cca_ports_BuilderService__exec_f)
(
  int64_t *self,
  SIDL_F77_String methodName
  SIDL_F77_STR_NEAR_LEN_DECL(methodName),
  int64_t *inArgs,
  int64_t *outArgs,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(methodName)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  char* _proxy_methodName = NULL;
  struct sidl_rmi_Call__object* _proxy_inArgs = NULL;
  struct sidl_rmi_Return__object* _proxy_outArgs = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_methodName =
    sidl_copy_fortran_str(SIDL_F77_STR(methodName),(ptrdiff_t)
      SIDL_F77_STR_LEN(methodName));
  _proxy_inArgs =
    (struct sidl_rmi_Call__object*)
    (ptrdiff_t)(*inArgs);
  _proxy_outArgs =
    (struct sidl_rmi_Return__object*)
    (ptrdiff_t)(*outArgs);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__exec))(
    _proxy_self->d_object,
    _proxy_methodName,
    _proxy_inArgs,
    _proxy_outArgs,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_methodName);
}


/*
 * Get the URL of the Implementation of this object (for RMI)
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__geturl_f,GOV_CCA_PORTS_BUILDERSERVICE__GETURL_F,gov_cca_ports_BuilderService__getURL_f)
(
  int64_t *self,
  SIDL_F77_String retval
  SIDL_F77_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(retval)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__getURL))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F77_STR(retval),(size_t)
      SIDL_F77_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
}


/*
 * TRUE if this object is remote, false if local
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__isremote_f,GOV_CCA_PORTS_BUILDERSERVICE__ISREMOTE_F,gov_cca_ports_BuilderService__isRemote_f)
(
  int64_t *self,
  SIDL_F77_Bool *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__isRemote))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F77_TRUE : SIDL_F77_FALSE);
  }
}


/*
 * TRUE if this object is remote, false if local
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__islocal_f,GOV_CCA_PORTS_BUILDERSERVICE__ISLOCAL_F,gov_cca_ports_BuilderService__isLocal_f)
(
  int64_t *self,
  SIDL_F77_Bool *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    !(*(_epv->f__isRemote))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F77_TRUE : SIDL_F77_FALSE);
  }
}


/*
 * Method to enable/disable method hooks invocation.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__set_hooks_f,GOV_CCA_PORTS_BUILDERSERVICE__SET_HOOKS_F,gov_cca_ports_BuilderService__set_hooks_f)
(
  int64_t *self,
  SIDL_F77_Bool *enable,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  sidl_bool _proxy_enable;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_enable = ((*enable == SIDL_F77_TRUE) ? TRUE : FALSE);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__set_hooks))(
    _proxy_self->d_object,
    _proxy_enable,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}


/*
 * Method to enable/disable interface contract enforcement.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__set_contracts_f,GOV_CCA_PORTS_BUILDERSERVICE__SET_CONTRACTS_F,gov_cca_ports_BuilderService__set_contracts_f)
(
  int64_t *self,
  SIDL_F77_Bool *enable,
  SIDL_F77_String enfFilename
  SIDL_F77_STR_NEAR_LEN_DECL(enfFilename),
  SIDL_F77_Bool *resetCounters,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(enfFilename)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  sidl_bool _proxy_enable;
  char* _proxy_enfFilename = NULL;
  sidl_bool _proxy_resetCounters;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_enable = ((*enable == SIDL_F77_TRUE) ? TRUE : FALSE);
  _proxy_enfFilename =
    sidl_copy_fortran_str(SIDL_F77_STR(enfFilename),(ptrdiff_t)
      SIDL_F77_STR_LEN(enfFilename));
  _proxy_resetCounters = ((*resetCounters == SIDL_F77_TRUE) ? TRUE : FALSE);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__set_contracts))(
    _proxy_self->d_object,
    _proxy_enable,
    _proxy_enfFilename,
    _proxy_resetCounters,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_enfFilename);
}


/*
 * Method to dump contract enforcement statistics.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__dump_stats_f,GOV_CCA_PORTS_BUILDERSERVICE__DUMP_STATS_F,gov_cca_ports_BuilderService__dump_stats_f)
(
  int64_t *self,
  SIDL_F77_String filename
  SIDL_F77_STR_NEAR_LEN_DECL(filename),
  SIDL_F77_String prefix
  SIDL_F77_STR_NEAR_LEN_DECL(prefix),
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(filename)
  SIDL_F77_STR_FAR_LEN_DECL(prefix)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  char* _proxy_filename = NULL;
  char* _proxy_prefix = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_filename =
    sidl_copy_fortran_str(SIDL_F77_STR(filename),(ptrdiff_t)
      SIDL_F77_STR_LEN(filename));
  _proxy_prefix =
    sidl_copy_fortran_str(SIDL_F77_STR(prefix),(ptrdiff_t)
      SIDL_F77_STR_LEN(prefix));
  _epv = _proxy_self->d_epv;
  (*(_epv->f__dump_stats))(
    _proxy_self->d_object,
    _proxy_filename,
    _proxy_prefix,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_filename);
  free((void *)_proxy_prefix);
}

/*
 * Creates an instance of a CCA component of the type defined by the 
 * string className.  The string classname uniquely defines the
 * "type" of the component, e.g.
 * doe.cca.Library.GaussianElmination. 
 * It has an instance name given by the string instanceName.
 * The instanceName may be empty (zero length) in which case
 * the instanceName will be assigned to the component automatically.
 * @throws CCAException If the Component className is unknown, or if the
 * instanceName has already been used, a CCAException is thrown.
 * @return A ComponentID corresponding to the created component. Destroying
 * the returned ID does not destroy the component; 
 * see destroyInstance instead.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_createinstance_f,GOV_CCA_PORTS_BUILDERSERVICE_CREATEINSTANCE_F,gov_cca_ports_BuilderService_createInstance_f)
(
  int64_t *self,
  SIDL_F77_String instanceName
  SIDL_F77_STR_NEAR_LEN_DECL(instanceName),
  SIDL_F77_String className
  SIDL_F77_STR_NEAR_LEN_DECL(className),
  int64_t *properties,
  int64_t *retval,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(instanceName)
  SIDL_F77_STR_FAR_LEN_DECL(className)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  char* _proxy_instanceName = NULL;
  char* _proxy_className = NULL;
  struct gov_cca_TypeMap__object* _proxy_properties = NULL;
  struct gov_cca_ComponentID__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_instanceName =
    sidl_copy_fortran_str(SIDL_F77_STR(instanceName),(ptrdiff_t)
      SIDL_F77_STR_LEN(instanceName));
  _proxy_className =
    sidl_copy_fortran_str(SIDL_F77_STR(className),(ptrdiff_t)
      SIDL_F77_STR_LEN(className));
  _proxy_properties =
    (struct gov_cca_TypeMap__object*)
    (ptrdiff_t)(*properties);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_createInstance))(
      _proxy_self->d_object,
      _proxy_instanceName,
      _proxy_className,
      _proxy_properties,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_instanceName);
  free((void *)_proxy_className);
}

/*
 *  
 * Get component list.
 * @return a ComponentID for each component currently created.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getcomponentids_f,GOV_CCA_PORTS_BUILDERSERVICE_GETCOMPONENTIDS_F,gov_cca_ports_BuilderService_getComponentIDs_f)
(
  int64_t *self,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getComponentIDs))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 *  
 * Get property map for component.
 * @return the public properties associated with the component referred to by
 * ComponentID. 
 * @throws a CCAException if the ComponentID is invalid.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getcomponentproperties_f,GOV_CCA_PORTS_BUILDERSERVICE_GETCOMPONENTPROPERTIES_F,gov_cca_ports_BuilderService_getComponentProperties_f)
(
  int64_t *self,
  int64_t *cid,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__object* _proxy_cid = NULL;
  struct gov_cca_TypeMap__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_cid =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*cid);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getComponentProperties))(
      _proxy_self->d_object,
      _proxy_cid,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 * Causes the framework implementation to associate the given properties 
 * with the component designated by cid. 
 * @throws CCAException if cid is invalid or if there is an attempted
 * change to a property locked by the framework implementation.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_setcomponentproperties_f,GOV_CCA_PORTS_BUILDERSERVICE_SETCOMPONENTPROPERTIES_F,gov_cca_ports_BuilderService_setComponentProperties_f)
(
  int64_t *self,
  int64_t *cid,
  int64_t *map,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__object* _proxy_cid = NULL;
  struct gov_cca_TypeMap__object* _proxy_map = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_cid =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*cid);
  _proxy_map =
    (struct gov_cca_TypeMap__object*)
    (ptrdiff_t)(*map);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_setComponentProperties))(
    _proxy_self->d_object,
    _proxy_cid,
    _proxy_map,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 *  Get component id from stringified reference.
 * @return a ComponentID from the string produced by 
 * ComponentID.getSerialization(). 
 * @throws CCAException if the string does not represent the appropriate 
 * serialization of a ComponentID for the underlying framework.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getdeserialization_f,GOV_CCA_PORTS_BUILDERSERVICE_GETDESERIALIZATION_F,gov_cca_ports_BuilderService_getDeserialization_f)
(
  int64_t *self,
  SIDL_F77_String s
  SIDL_F77_STR_NEAR_LEN_DECL(s),
  int64_t *retval,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(s)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  char* _proxy_s = NULL;
  struct gov_cca_ComponentID__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_s =
    sidl_copy_fortran_str(SIDL_F77_STR(s),(ptrdiff_t)
      SIDL_F77_STR_LEN(s));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getDeserialization))(
      _proxy_self->d_object,
      _proxy_s,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_s);
}

/*
 *  Get id from name by which it was created.
 * @return a ComponentID from the instance name of the component
 * produced by ComponentID.getInstanceName().
 * @throws CCAException if there is no component matching the 
 * given componentInstanceName.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getcomponentid_f,GOV_CCA_PORTS_BUILDERSERVICE_GETCOMPONENTID_F,gov_cca_ports_BuilderService_getComponentID_f)
(
  int64_t *self,
  SIDL_F77_String componentInstanceName
  SIDL_F77_STR_NEAR_LEN_DECL(componentInstanceName),
  int64_t *retval,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(componentInstanceName)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  char* _proxy_componentInstanceName = NULL;
  struct gov_cca_ComponentID__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_componentInstanceName =
    sidl_copy_fortran_str(SIDL_F77_STR(componentInstanceName),(ptrdiff_t)
      SIDL_F77_STR_LEN(componentInstanceName));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getComponentID))(
      _proxy_self->d_object,
      _proxy_componentInstanceName,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_componentInstanceName);
}

/*
 *  
 * Eliminate the Component instance, from the scope of the framework.
 * @param toDie the component to be removed.
 * @param timeout the allowable wait; 0 means up to the framework.
 * @throws CCAException if toDie refers to an invalid component, or
 * if the operation takes longer than timeout seconds.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_destroyinstance_f,GOV_CCA_PORTS_BUILDERSERVICE_DESTROYINSTANCE_F,gov_cca_ports_BuilderService_destroyInstance_f)
(
  int64_t *self,
  int64_t *toDie,
  float *timeout,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__object* _proxy_toDie = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_toDie =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*toDie);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_destroyInstance))(
    _proxy_self->d_object,
    _proxy_toDie,
    *timeout,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 *  
 * Get the names of Port instances provided by the identified component.
 * @param cid the component.
 * @throws CCAException if cid refers to an invalid component.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getprovidedportnames_f,GOV_CCA_PORTS_BUILDERSERVICE_GETPROVIDEDPORTNAMES_F,gov_cca_ports_BuilderService_getProvidedPortNames_f)
(
  int64_t *self,
  int64_t *cid,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__object* _proxy_cid = NULL;
  struct sidl_string__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_cid =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*cid);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getProvidedPortNames))(
      _proxy_self->d_object,
      _proxy_cid,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 *  
 * Get the names of Port instances used by the identified component.
 * @param cid the component.
 * @throws CCAException if cid refers to an invalid component. 
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getusedportnames_f,GOV_CCA_PORTS_BUILDERSERVICE_GETUSEDPORTNAMES_F,gov_cca_ports_BuilderService_getUsedPortNames_f)
(
  int64_t *self,
  int64_t *cid,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__object* _proxy_cid = NULL;
  struct sidl_string__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_cid =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*cid);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getUsedPortNames))(
      _proxy_self->d_object,
      _proxy_cid,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 *  
 * Fetch map of Port properties exposed by the framework.
 * @return the public properties pertaining to the Port instance 
 * portname on the component referred to by cid. 
 * @throws CCAException when any one of the following conditions occur:<ul>
 * <li>portname is not a registered Port on the component indicated by cid,
 * <li>cid refers to an invalid component. </ul>
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getportproperties_f,GOV_CCA_PORTS_BUILDERSERVICE_GETPORTPROPERTIES_F,gov_cca_ports_BuilderService_getPortProperties_f)
(
  int64_t *self,
  int64_t *cid,
  SIDL_F77_String portName
  SIDL_F77_STR_NEAR_LEN_DECL(portName),
  int64_t *retval,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(portName)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__object* _proxy_cid = NULL;
  char* _proxy_portName = NULL;
  struct gov_cca_TypeMap__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_cid =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*cid);
  _proxy_portName =
    sidl_copy_fortran_str(SIDL_F77_STR(portName),(ptrdiff_t)
      SIDL_F77_STR_LEN(portName));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getPortProperties))(
      _proxy_self->d_object,
      _proxy_cid,
      _proxy_portName,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_portName);
}

/*
 *  
 * Associates the properties given in map with the Port indicated by 
 * portname. The component must have a Port known by portname.
 * @throws CCAException if either cid or portname are
 * invalid, or if this a changed property is locked by 
 * the underlying framework or component.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_setportproperties_f,GOV_CCA_PORTS_BUILDERSERVICE_SETPORTPROPERTIES_F,gov_cca_ports_BuilderService_setPortProperties_f)
(
  int64_t *self,
  int64_t *cid,
  SIDL_F77_String portName
  SIDL_F77_STR_NEAR_LEN_DECL(portName),
  int64_t *map,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(portName)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__object* _proxy_cid = NULL;
  char* _proxy_portName = NULL;
  struct gov_cca_TypeMap__object* _proxy_map = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_cid =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*cid);
  _proxy_portName =
    sidl_copy_fortran_str(SIDL_F77_STR(portName),(ptrdiff_t)
      SIDL_F77_STR_LEN(portName));
  _proxy_map =
    (struct gov_cca_TypeMap__object*)
    (ptrdiff_t)(*map);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_setPortProperties))(
    _proxy_self->d_object,
    _proxy_cid,
    _proxy_portName,
    _proxy_map,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_portName);
}

/*
 * Creates a connection between ports on component user and 
 * component provider. Destroying the ConnectionID does not
 * cause a disconnection; for that, see disconnect().
 * @throws CCAException when any one of the following conditions occur:<ul>
 * <li>If either user or provider refer to an invalid component,
 * <li>If either usingPortName or providingPortName refer to a 
 * nonexistent Port on their respective component,
 * <li>If other-- In reality there are a lot of things that can go wrong 
 * with this operation, especially if the underlying connections 
 * involve networking.</ul>
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_connect_f,GOV_CCA_PORTS_BUILDERSERVICE_CONNECT_F,gov_cca_ports_BuilderService_connect_f)
(
  int64_t *self,
  int64_t *user,
  SIDL_F77_String usingPortName
  SIDL_F77_STR_NEAR_LEN_DECL(usingPortName),
  int64_t *provider,
  SIDL_F77_String providingPortName
  SIDL_F77_STR_NEAR_LEN_DECL(providingPortName),
  int64_t *retval,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(usingPortName)
  SIDL_F77_STR_FAR_LEN_DECL(providingPortName)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__object* _proxy_user = NULL;
  char* _proxy_usingPortName = NULL;
  struct gov_cca_ComponentID__object* _proxy_provider = NULL;
  char* _proxy_providingPortName = NULL;
  struct gov_cca_ConnectionID__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_user =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*user);
  _proxy_usingPortName =
    sidl_copy_fortran_str(SIDL_F77_STR(usingPortName),(ptrdiff_t)
      SIDL_F77_STR_LEN(usingPortName));
  _proxy_provider =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*provider);
  _proxy_providingPortName =
    sidl_copy_fortran_str(SIDL_F77_STR(providingPortName),(ptrdiff_t)
      SIDL_F77_STR_LEN(providingPortName));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_connect))(
      _proxy_self->d_object,
      _proxy_user,
      _proxy_usingPortName,
      _proxy_provider,
      _proxy_providingPortName,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_usingPortName);
  free((void *)_proxy_providingPortName);
}

/*
 *  Returns a list of connections as an array of 
 * handles. This will return all connections involving components 
 * in the given componentList of ComponentIDs. This
 * means that ConnectionID's will be returned even if only one 
 * of the participants in the connection appears in componentList.
 * 
 * @throws CCAException if any component in componentList is invalid.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getconnectionids_f,GOV_CCA_PORTS_BUILDERSERVICE_GETCONNECTIONIDS_F,gov_cca_ports_BuilderService_getConnectionIDs_f)
(
  int64_t *self,
  int64_t *componentList,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__array* _proxy_componentList = NULL;
  struct gov_cca_ConnectionID__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_componentList =
    (struct gov_cca_ComponentID__array*)
    (ptrdiff_t)(*componentList);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getConnectionIDs))(
      _proxy_self->d_object,
      _proxy_componentList,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 * Fetch property map of a connection.
 * @returns the properties for the given connection.
 * @throws CCAException if connID is invalid.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getconnectionproperties_f,GOV_CCA_PORTS_BUILDERSERVICE_GETCONNECTIONPROPERTIES_F,gov_cca_ports_BuilderService_getConnectionProperties_f)
(
  int64_t *self,
  int64_t *connID,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ConnectionID__object* _proxy_connID = NULL;
  struct gov_cca_TypeMap__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_connID =
    (struct gov_cca_ConnectionID__object*)
    (ptrdiff_t)(*connID);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getConnectionProperties))(
      _proxy_self->d_object,
      _proxy_connID,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 *  Associates the properties with the connection.
 * @param map the source of the properties.
 * @param connID connection to receive property values.
 * @throws CCAException if connID is invalid, or if this changes 
 * a property locked by the underlying framework.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_setconnectionproperties_f,GOV_CCA_PORTS_BUILDERSERVICE_SETCONNECTIONPROPERTIES_F,gov_cca_ports_BuilderService_setConnectionProperties_f)
(
  int64_t *self,
  int64_t *connID,
  int64_t *map,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ConnectionID__object* _proxy_connID = NULL;
  struct gov_cca_TypeMap__object* _proxy_map = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_connID =
    (struct gov_cca_ConnectionID__object*)
    (ptrdiff_t)(*connID);
  _proxy_map =
    (struct gov_cca_TypeMap__object*)
    (ptrdiff_t)(*map);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_setConnectionProperties))(
    _proxy_self->d_object,
    _proxy_connID,
    _proxy_map,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 *  Disconnect the connection indicated by connID before the indicated
 * timeout in secs. Upon successful completion, connID and the connection
 * it represents become invalid. 
 * @param timeout the time in seconds to wait for a connection to close; 0
 * means to use the framework implementation default.
 * @param connID the connection to be broken.
 * @throws CCAException when any one of the following conditions occur: <ul>
 * <li>id refers to an invalid ConnectionID,
 * <li>timeout is exceeded, after which, if id was valid before 
 * disconnect() was invoked, it remains valid
 * </ul>
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_disconnect_f,GOV_CCA_PORTS_BUILDERSERVICE_DISCONNECT_F,gov_cca_ports_BuilderService_disconnect_f)
(
  int64_t *self,
  int64_t *connID,
  float *timeout,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ConnectionID__object* _proxy_connID = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_connID =
    (struct gov_cca_ConnectionID__object*)
    (ptrdiff_t)(*connID);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_disconnect))(
    _proxy_self->d_object,
    _proxy_connID,
    *timeout,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 *  Remove all connections between components id1 and id2 within 
 * the period of timeout secs. If id2 is null, then all connections 
 * to id1 are removed (within the period of timeout secs).
 * @throws CCAException when any one of the following conditions occur:<ul>
 * <li>id1 or id2 refer to an invalid ComponentID (other than id2 == null),
 * <li>The timeout period is exceeded before the disconnections can be made. 
 * </ul>
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_disconnectall_f,GOV_CCA_PORTS_BUILDERSERVICE_DISCONNECTALL_F,gov_cca_ports_BuilderService_disconnectAll_f)
(
  int64_t *self,
  int64_t *id1,
  int64_t *id2,
  float *timeout,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct gov_cca_ComponentID__object* _proxy_id1 = NULL;
  struct gov_cca_ComponentID__object* _proxy_id2 = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_id1 =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*id1);
  _proxy_id2 =
    (struct gov_cca_ComponentID__object*)
    (ptrdiff_t)(*id2);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_disconnectAll))(
    _proxy_self->d_object,
    _proxy_id1,
    _proxy_id2,
    *timeout,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>sidl</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_addref_f,GOV_CCA_PORTS_BUILDERSERVICE_ADDREF_F,gov_cca_ports_BuilderService_addRef_f)
(
  int64_t *self,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_addRef))(
    _proxy_self->d_object,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>sidl</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_deleteref_f,GOV_CCA_PORTS_BUILDERSERVICE_DELETEREF_F,gov_cca_ports_BuilderService_deleteRef_f)
(
  int64_t *self,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_deleteRef))(
    _proxy_self->d_object,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_issame_f,GOV_CCA_PORTS_BUILDERSERVICE_ISSAME_F,gov_cca_ports_BuilderService_isSame_f)
(
  int64_t *self,
  int64_t *iobj,
  SIDL_F77_Bool *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_iobj = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_iobj =
    (struct sidl_BaseInterface__object*)
    (ptrdiff_t)(*iobj);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_isSame))(
      _proxy_self->d_object,
      _proxy_iobj,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F77_TRUE : SIDL_F77_FALSE);
  }
}

/*
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_istype_f,GOV_CCA_PORTS_BUILDERSERVICE_ISTYPE_F,gov_cca_ports_BuilderService_isType_f)
(
  int64_t *self,
  SIDL_F77_String name
  SIDL_F77_STR_NEAR_LEN_DECL(name),
  SIDL_F77_Bool *retval,
  int64_t *exception
  SIDL_F77_STR_FAR_LEN_DECL(name)
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  char* _proxy_name = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _proxy_name =
    sidl_copy_fortran_str(SIDL_F77_STR(name),(ptrdiff_t)
      SIDL_F77_STR_LEN(name));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_isType))(
      _proxy_self->d_object,
      _proxy_name,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F77_TRUE : SIDL_F77_FALSE);
  }
  free((void *)_proxy_name);
}

/*
 * Return the meta-data about the class implementing this interface.
 */

void
SIDLFortran77Symbol(gov_cca_ports_builderservice_getclassinfo_f,GOV_CCA_PORTS_BUILDERSERVICE_GETCLASSINFO_F,gov_cca_ports_BuilderService_getClassInfo_f)
(
  int64_t *self,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_BuilderService__epv *_epv = NULL;
  struct gov_cca_ports_BuilderService__object* _proxy_self = NULL;
  struct sidl_ClassInfo__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_BuilderService__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getClassInfo))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_createcol_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_CREATECOL_F,
                  gov_cca_ports_BuilderService__array_createCol_f)
  (int32_t *dimen,
   int32_t lower[],
   int32_t upper[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_createCol(*dimen, lower, upper);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_createrow_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_CREATEROW_F,
                  gov_cca_ports_BuilderService__array_createRow_f)
  (int32_t *dimen,
   int32_t lower[],
   int32_t upper[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_createRow(*dimen, lower, upper);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_create1d_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_CREATE1D_F,
                  gov_cca_ports_BuilderService__array_create1d_f)
  (int32_t *len, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create1d(*len);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_create2dcol_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_CREATE2DCOL_F,
                  gov_cca_ports_BuilderService__array_create2dCol_f)
  (int32_t *m, int32_t *n, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create2dCol(*m, *n);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_create2drow_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_CREATE2DROW_F,
                  gov_cca_ports_BuilderService__array_create2dRow_f)
  (int32_t *m, int32_t *n, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create2dRow(*m, *n);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_addref_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_ADDREF_F,
                  gov_cca_ports_BuilderService__array_addRef_f)
  (int64_t *array)
{
  sidl_interface__array_addRef((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_deleteref_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_DELETEREF_F,
                  gov_cca_ports_BuilderService__array_deleteRef_f)
  (int64_t *array)
{
  sidl_interface__array_deleteRef((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_get1_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_GET1_F,
                  gov_cca_ports_BuilderService__array_get1_f)
  (int64_t *array, 
   int32_t *i1, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get1((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_get2_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_GET2_F,
                  gov_cca_ports_BuilderService__array_get2_f)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get2((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_get3_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_GET3_F,
                  gov_cca_ports_BuilderService__array_get3_f)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get3((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_get4_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_GET4_F,
                  gov_cca_ports_BuilderService__array_get4_f)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get4((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_get5_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_GET5_F,
                  gov_cca_ports_BuilderService__array_get5_f)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get5((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_get6_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_GET6_F,
                  gov_cca_ports_BuilderService__array_get6_f)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int32_t *i6, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get6((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5, *i6);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_get7_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_GET7_F,
                  gov_cca_ports_BuilderService__array_get7_f)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int32_t *i6, 
   int32_t *i7, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get7((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5, *i6, *i7);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_get_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_GET_F,
                  gov_cca_ports_BuilderService__array_get_f)
  (int64_t *array,
   int32_t indices[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get((const struct sidl_interface__array *)(
      ptrdiff_t)*array, indices);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_set1_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SET1_F,
                  gov_cca_ports_BuilderService__array_set1_f)
  (int64_t *array,
   int32_t *i1,
   int64_t *value)
{
  sidl_interface__array_set1((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_set2_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SET2_F,
                  gov_cca_ports_BuilderService__array_set2_f)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int64_t *value)
{
  sidl_interface__array_set2((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_set3_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SET3_F,
                  gov_cca_ports_BuilderService__array_set3_f)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int64_t *value)
{
  sidl_interface__array_set3((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_set4_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SET4_F,
                  gov_cca_ports_BuilderService__array_set4_f)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int64_t *value)
{
  sidl_interface__array_set4((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_set5_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SET5_F,
                  gov_cca_ports_BuilderService__array_set5_f)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int64_t *value)
{
  sidl_interface__array_set5((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_set6_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SET6_F,
                  gov_cca_ports_BuilderService__array_set6_f)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int32_t *i6,
   int64_t *value)
{
  sidl_interface__array_set6((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, *i6, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_set7_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SET7_F,
                  gov_cca_ports_BuilderService__array_set7_f)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int32_t *i6,
   int32_t *i7,
   int64_t *value)
{
  sidl_interface__array_set7((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, *i6, *i7, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_set_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SET_F,
                  gov_cca_ports_BuilderService__array_set_f)
  (int64_t *array,
  int32_t indices[],
  int64_t *value)
{
  sidl_interface__array_set((struct sidl_interface__array *)(ptrdiff_t)*array, 
    indices, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_dimen_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_DIMEN_F,
                  gov_cca_ports_BuilderService__array_dimen_f)
  (int64_t *array, int32_t *result)
{
  *result =
    sidl_interface__array_dimen((struct sidl_interface__array *)(
      ptrdiff_t)*array);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_lower_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_LOWER_F,
                  gov_cca_ports_BuilderService__array_lower_f)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_lower((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_upper_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_UPPER_F,
                  gov_cca_ports_BuilderService__array_upper_f)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_upper((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_length_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_LENGTH_F,
                  gov_cca_ports_BuilderService__array_length_f)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_length((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_stride_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_STRIDE_F,
                  gov_cca_ports_BuilderService__array_stride_f)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_stride((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_iscolumnorder_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_ISCOLUMNORDER_F,
                  gov_cca_ports_BuilderService__array_isColumnOrder_f)
  (int64_t *array,
   SIDL_F77_Bool *result)
{
  *result = sidl_interface__array_isColumnOrder((struct sidl_interface__array 
    *)(ptrdiff_t)*array);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_isroworder_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_ISROWORDER_F,
                  gov_cca_ports_BuilderService__array_isRowOrder_f)
  (int64_t *array,
   SIDL_F77_Bool *result)
{
  *result = sidl_interface__array_isRowOrder((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_copy_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_COPY_F,
                  gov_cca_ports_BuilderService__array_copy_f)
  (int64_t *src,
   int64_t *dest)
{
  sidl_interface__array_copy((const struct sidl_interface__array *)(
    ptrdiff_t)*src,
                             (struct sidl_interface__array *)(ptrdiff_t)*dest);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_smartcopy_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SMARTCOPY_F,
                  gov_cca_ports_BuilderService__array_smartCopy_f)
  (int64_t *src)
{
  sidl_interface__array_smartCopy((struct sidl_interface__array *)(
    ptrdiff_t)*src);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_slice_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_SLICE_F,
                  gov_cca_ports_BuilderService__array_slice_f)
  (int64_t *src,
   int32_t *dimen,
   int32_t numElem[],
   int32_t srcStart[],
   int32_t srcStride[],
   int32_t newStart[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_slice((struct sidl_interface__array *)(ptrdiff_t)*src,
      *dimen, numElem, srcStart, srcStride, newStart);
}

void
SIDLFortran77Symbol(gov_cca_ports_builderservice__array_ensure_f,
                  GOV_CCA_PORTS_BUILDERSERVICE__ARRAY_ENSURE_F,
                  gov_cca_ports_BuilderService__array_ensure_f)
  (int64_t *src,
   int32_t *dimen,
   int     *ordering,
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_ensure((struct sidl_interface__array *)(
      ptrdiff_t)*src,
    *dimen, *ordering);
}

#ifdef WITH_RMI

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#ifndef included_sidl_BaseClass_h
#include "sidl_BaseClass.h"
#endif
#ifndef included_sidl_ClassInfo_h
#include "sidl_ClassInfo.h"
#endif
#ifndef included_sidl_rmi_ProtocolFactory_h
#include "sidl_rmi_ProtocolFactory.h"
#endif
#ifndef included_sidl_rmi_InstanceRegistry_h
#include "sidl_rmi_InstanceRegistry.h"
#endif
#ifndef included_sidl_rmi_InstanceHandle_h
#include "sidl_rmi_InstanceHandle.h"
#endif
#ifndef included_sidl_rmi_Invocation_h
#include "sidl_rmi_Invocation.h"
#endif
#ifndef included_sidl_rmi_Response_h
#include "sidl_rmi_Response.h"
#endif
#ifndef included_sidl_rmi_ServerRegistry_h
#include "sidl_rmi_ServerRegistry.h"
#endif
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidl_io_Serializable_h
#include "sidl_io_Serializable.h"
#endif
#ifndef included_sidl_MemAllocException_h
#include "sidl_MemAllocException.h"
#endif
#ifndef included_sidl_NotImplementedException_h
#include "sidl_NotImplementedException.h"
#endif
#include "sidl_Exception.h"

#ifndef NULL
#define NULL 0
#endif

#include "sidl_thread.h"
#ifdef HAVE_PTHREAD
static struct sidl_recursive_mutex_t gov_cca_ports__BuilderService__mutex= SIDL_RECURSIVE_MUTEX_INITIALIZER;
#define LOCK_STATIC_GLOBALS sidl_recursive_mutex_lock( &gov_cca_ports__BuilderService__mutex )
#define UNLOCK_STATIC_GLOBALS sidl_recursive_mutex_unlock( &gov_cca_ports__BuilderService__mutex )
/* #define HAVE_LOCKED_STATIC_GLOBALS (sidl_recursive_mutex_trylock( &gov_cca_ports__BuilderService__mutex )==EDEADLOCK) */
#else
#define LOCK_STATIC_GLOBALS
#define UNLOCK_STATIC_GLOBALS
/* #define HAVE_LOCKED_STATIC_GLOBALS (1) */
#endif

/* Static variables to hold version of IOR */
static const int32_t s_IOR_MAJOR_VERSION = 2;
static const int32_t s_IOR_MINOR_VERSION = 0;

/* Static variables for managing EPV initialization. */
static int s_remote_initialized = 0;

static struct gov_cca_ports__BuilderService__epv 
  s_rem_epv__gov_cca_ports__builderservice;

static struct gov_cca_Port__epv s_rem_epv__gov_cca_port;

static struct gov_cca_ports_BuilderService__epv 
  s_rem_epv__gov_cca_ports_builderservice;

static struct sidl_BaseInterface__epv s_rem_epv__sidl_baseinterface;


/* REMOTE CAST: dynamic type casting for remote objects. */
static void* remote_gov_cca_ports__BuilderService__cast(
  struct gov_cca_ports__BuilderService__object* self,
  const char* name, sidl_BaseInterface* _ex)
{
  int cmp;
  void* cast = NULL;
  *_ex = NULL; /* default to no exception */
  cmp = strcmp(name, "gov.cca.ports._BuilderService");
  if (!cmp) {
    (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
    cast = ((struct gov_cca_ports__BuilderService__object*)self);
    return cast;
  }
  else if (cmp < 0) {
    cmp = strcmp(name, "gov.cca.ports.BuilderService");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = &((*self).d_gov_cca_ports_builderservice);
      return cast;
    }
    else if (cmp < 0) {
      cmp = strcmp(name, "gov.cca.Port");
      if (!cmp) {
        (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
        cast = &((*self).d_gov_cca_port);
        return cast;
      }
    }
  }
  else if (cmp > 0) {
    cmp = strcmp(name, "sidl.BaseInterface");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = &((*self).d_sidl_baseinterface);
      return cast;
    }
  }
  if ((*self->d_epv->f_isType)(self,name, _ex)) {
    void* (*func)(struct sidl_rmi_InstanceHandle__object*, struct 
      sidl_BaseInterface__object**) = 
      (void* (*)(struct sidl_rmi_InstanceHandle__object*, struct 
        sidl_BaseInterface__object**)) 
      sidl_rmi_ConnectRegistry_getConnect(name, _ex);SIDL_CHECK(*_ex);
    cast =  (*func)(((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih, _ex);
  }

  return cast;
  EXIT:
  return NULL;
}

/* REMOTE DELETE: call the remote destructor for the object. */
static void remote_gov_cca_ports__BuilderService__delete(
  struct gov_cca_ports__BuilderService__object* self,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
  free((void*) self);
}

/* REMOTE GETURL: call the getURL function for the object. */
static char* remote_gov_cca_ports__BuilderService__getURL(
  struct gov_cca_ports__BuilderService__object* self, struct 
    sidl_BaseInterface__object* *_ex)
{
  struct sidl_rmi_InstanceHandle__object *conn = ((struct 
    gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
  *_ex = NULL;
  if(conn != NULL) {
    return sidl_rmi_InstanceHandle_getObjectURL(conn, _ex);
  }
  return NULL;
}

/* REMOTE ADDREF: For internal babel use only! Remote addRef. */
static void remote_gov_cca_ports__BuilderService__raddRef(
  struct gov_cca_ports__BuilderService__object* self,struct 
    sidl_BaseInterface__object* *_ex)
{
  struct sidl_BaseException__object* netex = NULL;
  /* initialize a new invocation */
  struct sidl_BaseInterface__object* _throwaway = NULL;
  struct sidl_rmi_InstanceHandle__object *_conn = ((struct 
    gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
  sidl_rmi_Response _rsvp = NULL;
  sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
    "addRef", _ex ); SIDL_CHECK(*_ex);
  /* send actual RMI request */
  _rsvp = sidl_rmi_Invocation_invokeMethod(_inv,_ex);SIDL_CHECK(*_ex);
  /* Check for exceptions */
  netex = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);
  if(netex != NULL) {
    *_ex = (struct sidl_BaseInterface__object*)netex;
    return;
  }

  /* cleanup and return */
  EXIT:
  if(_inv) { sidl_rmi_Invocation_deleteRef(_inv,&_throwaway); }
  if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp,&_throwaway); }
  return;
}

/* REMOTE ISREMOTE: returns true if this object is Remote (it is). */
static sidl_bool
remote_gov_cca_ports__BuilderService__isRemote(
    struct gov_cca_ports__BuilderService__object* self, 
    struct sidl_BaseInterface__object* *_ex) {
  *_ex = NULL;
  return TRUE;
}

/* REMOTE METHOD STUB:_set_hooks */
static void
remote_gov_cca_ports__BuilderService__set_hooks(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ sidl_bool enable,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_hooks", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService._set_hooks.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_set_contracts */
static void
remote_gov_cca_ports__BuilderService__set_contracts(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ sidl_bool enable,
  /* in */ const char* enfFilename,
  /* in */ sidl_bool resetCounters,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_contracts", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packString( _inv, "enfFilename", enfFilename, 
      _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packBool( _inv, "resetCounters", resetCounters, 
      _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService._set_contracts.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_dump_stats */
static void
remote_gov_cca_ports__BuilderService__dump_stats(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ const char* filename,
  /* in */ const char* prefix,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_dump_stats", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "filename", filename, _ex);SIDL_CHECK(
      *_ex);
    sidl_rmi_Invocation_packString( _inv, "prefix", prefix, _ex);SIDL_CHECK(
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService._dump_stats.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE EXEC: call the exec function for the object. */
static void remote_gov_cca_ports__BuilderService__exec(
  struct gov_cca_ports__BuilderService__object* self,const char* methodName,
  sidl_rmi_Call inArgs,
  sidl_rmi_Return outArgs,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
}

/* REMOTE METHOD STUB:createInstance */
static struct gov_cca_ComponentID__object*
remote_gov_cca_ports__BuilderService_createInstance(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ const char* instanceName,
  /* in */ const char* className,
  /* in */ struct gov_cca_TypeMap__object* properties,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_ComponentID__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "createInstance", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "instanceName", instanceName, 
      _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packString( _inv, "className", className, 
      _ex);SIDL_CHECK(*_ex);
    if(properties){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)properties, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "properties", _url, _ex);SIDL_CHECK(
        *_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "properties", NULL, _ex);SIDL_CHECK(
        *_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.createInstance.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_ComponentID__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getComponentIDs */
static struct gov_cca_ComponentID__array*
remote_gov_cca_ports__BuilderService_getComponentIDs(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct gov_cca_ComponentID__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getComponentIDs", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getComponentIDs.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    SIDL_THROW(*_ex, sidl_NotImplementedException, "An array of type "
    "gov.cca.ComponentID"
    " cannot currently be passed through RMI.  That functionality"
    "is not implemented.");

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getComponentProperties */
static struct gov_cca_TypeMap__object*
remote_gov_cca_ports__BuilderService_getComponentProperties(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ComponentID__object* cid,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_TypeMap__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getComponentProperties", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(cid){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)cid, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "cid", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "cid", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getComponentProperties.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_TypeMap__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:setComponentProperties */
static void
remote_gov_cca_ports__BuilderService_setComponentProperties(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ComponentID__object* cid,
  /* in */ struct gov_cca_TypeMap__object* map,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "setComponentProperties", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(cid){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)cid, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "cid", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "cid", NULL, _ex);SIDL_CHECK(*_ex);
    }
    if(map){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)map, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "map", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "map", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.setComponentProperties.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:getDeserialization */
static struct gov_cca_ComponentID__object*
remote_gov_cca_ports__BuilderService_getDeserialization(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ const char* s,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_ComponentID__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getDeserialization", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "s", s, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getDeserialization.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_ComponentID__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getComponentID */
static struct gov_cca_ComponentID__object*
remote_gov_cca_ports__BuilderService_getComponentID(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ const char* componentInstanceName,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_ComponentID__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getComponentID", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "componentInstanceName", 
      componentInstanceName, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getComponentID.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_ComponentID__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:destroyInstance */
static void
remote_gov_cca_ports__BuilderService_destroyInstance(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ComponentID__object* toDie,
  /* in */ float timeout,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "destroyInstance", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(toDie){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)toDie, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "toDie", _url, _ex);SIDL_CHECK(
        *_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "toDie", NULL, _ex);SIDL_CHECK(
        *_ex);
    }
    sidl_rmi_Invocation_packFloat( _inv, "timeout", timeout, _ex);SIDL_CHECK(
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.destroyInstance.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:getProvidedPortNames */
static struct sidl_string__array*
remote_gov_cca_ports__BuilderService_getProvidedPortNames(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ComponentID__object* cid,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_string__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getProvidedPortNames", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(cid){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)cid, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "cid", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "cid", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getProvidedPortNames.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackStringArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getUsedPortNames */
static struct sidl_string__array*
remote_gov_cca_ports__BuilderService_getUsedPortNames(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ComponentID__object* cid,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_string__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getUsedPortNames", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(cid){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)cid, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "cid", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "cid", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getUsedPortNames.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackStringArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getPortProperties */
static struct gov_cca_TypeMap__object*
remote_gov_cca_ports__BuilderService_getPortProperties(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ComponentID__object* cid,
  /* in */ const char* portName,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_TypeMap__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getPortProperties", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(cid){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)cid, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "cid", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "cid", NULL, _ex);SIDL_CHECK(*_ex);
    }
    sidl_rmi_Invocation_packString( _inv, "portName", portName, _ex);SIDL_CHECK(
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getPortProperties.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_TypeMap__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:setPortProperties */
static void
remote_gov_cca_ports__BuilderService_setPortProperties(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ComponentID__object* cid,
  /* in */ const char* portName,
  /* in */ struct gov_cca_TypeMap__object* map,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "setPortProperties", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(cid){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)cid, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "cid", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "cid", NULL, _ex);SIDL_CHECK(*_ex);
    }
    sidl_rmi_Invocation_packString( _inv, "portName", portName, _ex);SIDL_CHECK(
      *_ex);
    if(map){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)map, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "map", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "map", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.setPortProperties.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:connect */
static struct gov_cca_ConnectionID__object*
remote_gov_cca_ports__BuilderService_connect(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ComponentID__object* user,
  /* in */ const char* usingPortName,
  /* in */ struct gov_cca_ComponentID__object* provider,
  /* in */ const char* providingPortName,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_ConnectionID__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "connect", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(user){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)user, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "user", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "user", NULL, _ex);SIDL_CHECK(*_ex);
    }
    sidl_rmi_Invocation_packString( _inv, "usingPortName", usingPortName, 
      _ex);SIDL_CHECK(*_ex);
    if(provider){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)provider, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "provider", _url, _ex);SIDL_CHECK(
        *_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "provider", NULL, _ex);SIDL_CHECK(
        *_ex);
    }
    sidl_rmi_Invocation_packString( _inv, "providingPortName", 
      providingPortName, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.connect.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_ConnectionID__connectI(_retval_str, FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getConnectionIDs */
static struct gov_cca_ConnectionID__array*
remote_gov_cca_ports__BuilderService_getConnectionIDs(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in array<gov.cca.ComponentID> */ struct gov_cca_ComponentID__array* 
    componentList,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct gov_cca_ConnectionID__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getConnectionIDs", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    SIDL_THROW(*_ex, sidl_NotImplementedException, "An array of type "
    "gov.cca.ComponentID"
    " cannot currently be passed through RMI.  That functionality"
    "is not implemented.");

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getConnectionIDs.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    SIDL_THROW(*_ex, sidl_NotImplementedException, "An array of type "
    "gov.cca.ConnectionID"
    " cannot currently be passed through RMI.  That functionality"
    "is not implemented.");

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getConnectionProperties */
static struct gov_cca_TypeMap__object*
remote_gov_cca_ports__BuilderService_getConnectionProperties(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ConnectionID__object* connID,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_TypeMap__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getConnectionProperties", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(connID){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)connID, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "connID", _url, _ex);SIDL_CHECK(
        *_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "connID", NULL, _ex);SIDL_CHECK(
        *_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getConnectionProperties.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_TypeMap__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:setConnectionProperties */
static void
remote_gov_cca_ports__BuilderService_setConnectionProperties(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ConnectionID__object* connID,
  /* in */ struct gov_cca_TypeMap__object* map,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "setConnectionProperties", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(connID){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)connID, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "connID", _url, _ex);SIDL_CHECK(
        *_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "connID", NULL, _ex);SIDL_CHECK(
        *_ex);
    }
    if(map){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)map, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "map", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "map", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.setConnectionProperties.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:disconnect */
static void
remote_gov_cca_ports__BuilderService_disconnect(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ConnectionID__object* connID,
  /* in */ float timeout,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "disconnect", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(connID){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)connID, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "connID", _url, _ex);SIDL_CHECK(
        *_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "connID", NULL, _ex);SIDL_CHECK(
        *_ex);
    }
    sidl_rmi_Invocation_packFloat( _inv, "timeout", timeout, _ex);SIDL_CHECK(
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.disconnect.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:disconnectAll */
static void
remote_gov_cca_ports__BuilderService_disconnectAll(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct gov_cca_ComponentID__object* id1,
  /* in */ struct gov_cca_ComponentID__object* id2,
  /* in */ float timeout,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "disconnectAll", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(id1){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)id1, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "id1", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "id1", NULL, _ex);SIDL_CHECK(*_ex);
    }
    if(id2){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)id2, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "id2", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "id2", NULL, _ex);SIDL_CHECK(*_ex);
    }
    sidl_rmi_Invocation_packFloat( _inv, "timeout", timeout, _ex);SIDL_CHECK(
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.disconnectAll.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:addRef */
static void
remote_gov_cca_ports__BuilderService_addRef(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct gov_cca_ports__BuilderService__remote* r_obj = (struct 
      gov_cca_ports__BuilderService__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount++;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: addRef %p new count %d (type %s)\n",
      r_obj, r_obj->d_refcount, 
      "gov.cca.ports._BuilderService Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:deleteRef */
static void
remote_gov_cca_ports__BuilderService_deleteRef(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct gov_cca_ports__BuilderService__remote* r_obj = (struct 
      gov_cca_ports__BuilderService__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount--;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: deleteRef %p new count %d (type %s)\n",r_obj, r_obj->d_refcount, "gov.cca.ports._BuilderService Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    if(r_obj->d_refcount == 0) {
      sidl_rmi_InstanceHandle_deleteRef(r_obj->d_ih, _ex);
      free(r_obj);
      free(self);
    }
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:isSame */
static sidl_bool
remote_gov_cca_ports__BuilderService_isSame(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ struct sidl_BaseInterface__object* iobj,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isSame", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(iobj){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)iobj, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "iobj", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "iobj", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.isSame.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:isType */
static sidl_bool
remote_gov_cca_ports__BuilderService_isType(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* in */ const char* name,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isType", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "name", name, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.isType.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getClassInfo */
static struct sidl_ClassInfo__object*
remote_gov_cca_ports__BuilderService_getClassInfo(
  /* in */ struct gov_cca_ports__BuilderService__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct sidl_ClassInfo__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__BuilderService__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getClassInfo", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._BuilderService.getClassInfo.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = sidl_ClassInfo__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE EPV: create remote entry point vectors (EPVs). */
static void gov_cca_ports__BuilderService__init_remote_epv(void)
{
  /* assert( HAVE_LOCKED_STATIC_GLOBALS ); */
  struct gov_cca_ports__BuilderService__epv* epv = 
    &s_rem_epv__gov_cca_ports__builderservice;
  struct gov_cca_Port__epv*                  e0  = &s_rem_epv__gov_cca_port;
  struct gov_cca_ports_BuilderService__epv*  e1  = 
    &s_rem_epv__gov_cca_ports_builderservice;
  struct sidl_BaseInterface__epv*            e2  = 
    &s_rem_epv__sidl_baseinterface;

  epv->f__cast                        = 
    remote_gov_cca_ports__BuilderService__cast;
  epv->f__delete                      = 
    remote_gov_cca_ports__BuilderService__delete;
  epv->f__exec                        = 
    remote_gov_cca_ports__BuilderService__exec;
  epv->f__getURL                      = 
    remote_gov_cca_ports__BuilderService__getURL;
  epv->f__raddRef                     = 
    remote_gov_cca_ports__BuilderService__raddRef;
  epv->f__isRemote                    = 
    remote_gov_cca_ports__BuilderService__isRemote;
  epv->f__set_hooks                   = 
    remote_gov_cca_ports__BuilderService__set_hooks;
  epv->f__set_contracts               = 
    remote_gov_cca_ports__BuilderService__set_contracts;
  epv->f__dump_stats                  = 
    remote_gov_cca_ports__BuilderService__dump_stats;
  epv->f__ctor                        = NULL;
  epv->f__ctor2                       = NULL;
  epv->f__dtor                        = NULL;
  epv->f_createInstance               = 
    remote_gov_cca_ports__BuilderService_createInstance;
  epv->f_getComponentIDs              = 
    remote_gov_cca_ports__BuilderService_getComponentIDs;
  epv->f_getComponentProperties       = 
    remote_gov_cca_ports__BuilderService_getComponentProperties;
  epv->f_setComponentProperties       = 
    remote_gov_cca_ports__BuilderService_setComponentProperties;
  epv->f_getDeserialization           = 
    remote_gov_cca_ports__BuilderService_getDeserialization;
  epv->f_getComponentID               = 
    remote_gov_cca_ports__BuilderService_getComponentID;
  epv->f_destroyInstance              = 
    remote_gov_cca_ports__BuilderService_destroyInstance;
  epv->f_getProvidedPortNames         = 
    remote_gov_cca_ports__BuilderService_getProvidedPortNames;
  epv->f_getUsedPortNames             = 
    remote_gov_cca_ports__BuilderService_getUsedPortNames;
  epv->f_getPortProperties            = 
    remote_gov_cca_ports__BuilderService_getPortProperties;
  epv->f_setPortProperties            = 
    remote_gov_cca_ports__BuilderService_setPortProperties;
  epv->f_connect                      = 
    remote_gov_cca_ports__BuilderService_connect;
  epv->f_getConnectionIDs             = 
    remote_gov_cca_ports__BuilderService_getConnectionIDs;
  epv->f_getConnectionProperties      = 
    remote_gov_cca_ports__BuilderService_getConnectionProperties;
  epv->f_setConnectionProperties      = 
    remote_gov_cca_ports__BuilderService_setConnectionProperties;
  epv->f_disconnect                   = 
    remote_gov_cca_ports__BuilderService_disconnect;
  epv->f_disconnectAll                = 
    remote_gov_cca_ports__BuilderService_disconnectAll;
  epv->f_addRef                       = 
    remote_gov_cca_ports__BuilderService_addRef;
  epv->f_deleteRef                    = 
    remote_gov_cca_ports__BuilderService_deleteRef;
  epv->f_isSame                       = 
    remote_gov_cca_ports__BuilderService_isSame;
  epv->f_isType                       = 
    remote_gov_cca_ports__BuilderService_isType;
  epv->f_getClassInfo                 = 
    remote_gov_cca_ports__BuilderService_getClassInfo;

  e0->f__cast          = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e0->f__delete        = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__delete;
  e0->f__getURL        = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e0->f__raddRef       = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__raddRef;
  e0->f__isRemote      = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e0->f__set_hooks     = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e0->f__set_contracts = (void (*)(void*, sidl_bool, const char*, sidl_bool, 
    struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e0->f__dump_stats    = (void (*)(void*, const char*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__dump_stats;
  e0->f__exec          = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e0->f_addRef         = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_addRef;
  e0->f_deleteRef      = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_deleteRef;
  e0->f_isSame         = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e0->f_isType         = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e0->f_getClassInfo   = (struct sidl_ClassInfo__object* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_getClassInfo;

  e1->f__cast                   = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e1->f__delete                 = (void (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__delete;
  e1->f__getURL                 = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e1->f__raddRef                = (void (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__raddRef;
  e1->f__isRemote               = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e1->f__set_hooks              = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e1->f__set_contracts          = (void (*)(void*, sidl_bool, const char*, 
    sidl_bool, struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e1->f__dump_stats             = (void (*)(void*, const char*, const char*, 
    struct sidl_BaseInterface__object**)) epv->f__dump_stats;
  e1->f__exec                   = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e1->f_createInstance          = (struct gov_cca_ComponentID__object* (*)(
    void*,const char*,const char*,struct gov_cca_TypeMap__object*,struct 
    sidl_BaseInterface__object **)) epv->f_createInstance;
  e1->f_getComponentIDs         = (struct gov_cca_ComponentID__array* (*)(void*,
    struct sidl_BaseInterface__object **)) epv->f_getComponentIDs;
  e1->f_getComponentProperties  = (struct gov_cca_TypeMap__object* (*)(void*,
    struct gov_cca_ComponentID__object*,struct sidl_BaseInterface__object **)) 
    epv->f_getComponentProperties;
  e1->f_setComponentProperties  = (void (*)(void*,struct 
    gov_cca_ComponentID__object*,struct gov_cca_TypeMap__object*,struct 
    sidl_BaseInterface__object **)) epv->f_setComponentProperties;
  e1->f_getDeserialization      = (struct gov_cca_ComponentID__object* (*)(
    void*,const char*,struct sidl_BaseInterface__object **)) 
    epv->f_getDeserialization;
  e1->f_getComponentID          = (struct gov_cca_ComponentID__object* (*)(
    void*,const char*,struct sidl_BaseInterface__object **)) 
    epv->f_getComponentID;
  e1->f_destroyInstance         = (void (*)(void*,struct 
    gov_cca_ComponentID__object*,float,struct sidl_BaseInterface__object **)) 
    epv->f_destroyInstance;
  e1->f_getProvidedPortNames    = (struct sidl_string__array* (*)(void*,struct 
    gov_cca_ComponentID__object*,struct sidl_BaseInterface__object **)) 
    epv->f_getProvidedPortNames;
  e1->f_getUsedPortNames        = (struct sidl_string__array* (*)(void*,struct 
    gov_cca_ComponentID__object*,struct sidl_BaseInterface__object **)) 
    epv->f_getUsedPortNames;
  e1->f_getPortProperties       = (struct gov_cca_TypeMap__object* (*)(void*,
    struct gov_cca_ComponentID__object*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_getPortProperties;
  e1->f_setPortProperties       = (void (*)(void*,struct 
    gov_cca_ComponentID__object*,const char*,struct gov_cca_TypeMap__object*,
    struct sidl_BaseInterface__object **)) epv->f_setPortProperties;
  e1->f_connect                 = (struct gov_cca_ConnectionID__object* (*)(
    void*,struct gov_cca_ComponentID__object*,const char*,struct 
    gov_cca_ComponentID__object*,const char*,struct sidl_BaseInterface__object 
    **)) epv->f_connect;
  e1->f_getConnectionIDs        = (struct gov_cca_ConnectionID__array* (*)(
    void*,struct gov_cca_ComponentID__array*,struct sidl_BaseInterface__object 
    **)) epv->f_getConnectionIDs;
  e1->f_getConnectionProperties = (struct gov_cca_TypeMap__object* (*)(void*,
    struct gov_cca_ConnectionID__object*,struct sidl_BaseInterface__object **)) 
    epv->f_getConnectionProperties;
  e1->f_setConnectionProperties = (void (*)(void*,struct 
    gov_cca_ConnectionID__object*,struct gov_cca_TypeMap__object*,struct 
    sidl_BaseInterface__object **)) epv->f_setConnectionProperties;
  e1->f_disconnect              = (void (*)(void*,struct 
    gov_cca_ConnectionID__object*,float,struct sidl_BaseInterface__object **)) 
    epv->f_disconnect;
  e1->f_disconnectAll           = (void (*)(void*,struct 
    gov_cca_ComponentID__object*,struct gov_cca_ComponentID__object*,float,
    struct sidl_BaseInterface__object **)) epv->f_disconnectAll;
  e1->f_addRef                  = (void (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_addRef;
  e1->f_deleteRef               = (void (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_deleteRef;
  e1->f_isSame                  = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e1->f_isType                  = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e1->f_getClassInfo            = (struct sidl_ClassInfo__object* (*)(void*,
    struct sidl_BaseInterface__object **)) epv->f_getClassInfo;

  e2->f__cast          = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e2->f__delete        = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__delete;
  e2->f__getURL        = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e2->f__raddRef       = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__raddRef;
  e2->f__isRemote      = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e2->f__set_hooks     = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e2->f__set_contracts = (void (*)(void*, sidl_bool, const char*, sidl_bool, 
    struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e2->f__dump_stats    = (void (*)(void*, const char*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__dump_stats;
  e2->f__exec          = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e2->f_addRef         = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_addRef;
  e2->f_deleteRef      = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_deleteRef;
  e2->f_isSame         = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e2->f_isType         = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e2->f_getClassInfo   = (struct sidl_ClassInfo__object* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_getClassInfo;

  s_remote_initialized = 1;
}

/* Create an instance that connects to an existing remote object. */
static struct gov_cca_ports_BuilderService__object*
gov_cca_ports_BuilderService__remoteConnect(const char *url, sidl_bool ar, 
  struct sidl_BaseInterface__object* *_ex)
{
  struct gov_cca_ports__BuilderService__object* self = NULL;

  struct gov_cca_ports__BuilderService__object* s0;

  struct gov_cca_ports__BuilderService__remote* r_obj = NULL;
  sidl_rmi_InstanceHandle instance = NULL;
  struct gov_cca_ports_BuilderService__object* ret_self = NULL;
  char* objectID = NULL;
  objectID = sidl_rmi_ServerRegistry_isLocalObject(url, _ex);
  if(objectID) {
    sidl_BaseInterface bi = (sidl_BaseInterface) 
      sidl_rmi_InstanceRegistry_getInstanceByString(objectID, _ex);
    return (struct gov_cca_ports_BuilderService__object*)(*bi->d_epv->f__cast)(
      bi->d_object, "gov.cca.ports.BuilderService", _ex);
  }
  instance = sidl_rmi_ProtocolFactory_connectInstance(url, 
    "gov.cca.ports.BuilderService", ar, _ex );
  if ( instance == NULL) { return NULL; }
  self =
    (struct gov_cca_ports__BuilderService__object*) malloc(
      sizeof(struct gov_cca_ports__BuilderService__object));

  r_obj =
    (struct gov_cca_ports__BuilderService__remote*) malloc(
      sizeof(struct gov_cca_ports__BuilderService__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "gov.cca.ports._BuilderService.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                                         self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    gov_cca_ports__BuilderService__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_gov_cca_port.d_epv    = &s_rem_epv__gov_cca_port;
  s0->d_gov_cca_port.d_object = (void*) self;

  s0->d_gov_cca_ports_builderservice.d_epv    = 
    &s_rem_epv__gov_cca_ports_builderservice;
  s0->d_gov_cca_ports_builderservice.d_object = (void*) self;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__gov_cca_ports__builderservice;

  self->d_data = (void*) r_obj;

  ret_self = (struct gov_cca_ports_BuilderService__object*) (
    *self->d_epv->f__cast)(self, "gov.cca.ports.BuilderService", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/* Create an instance that uses an already existing  */
/* InstanceHandel to connect to an existing remote object. */
static struct gov_cca_ports_BuilderService__object*
gov_cca_ports_BuilderService__IHConnect(sidl_rmi_InstanceHandle instance, 
  struct sidl_BaseInterface__object* *_ex)
{
  struct gov_cca_ports__BuilderService__object* self = NULL;

  struct gov_cca_ports__BuilderService__object* s0;

  struct gov_cca_ports__BuilderService__remote* r_obj = NULL;
  struct gov_cca_ports_BuilderService__object* ret_self = NULL;
  self =
    (struct gov_cca_ports__BuilderService__object*) malloc(
      sizeof(struct gov_cca_ports__BuilderService__object));

  r_obj =
    (struct gov_cca_ports__BuilderService__remote*) malloc(
      sizeof(struct gov_cca_ports__BuilderService__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "gov.cca.ports._BuilderService.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                                         self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    gov_cca_ports__BuilderService__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_gov_cca_port.d_epv    = &s_rem_epv__gov_cca_port;
  s0->d_gov_cca_port.d_object = (void*) self;

  s0->d_gov_cca_ports_builderservice.d_epv    = 
    &s_rem_epv__gov_cca_ports_builderservice;
  s0->d_gov_cca_ports_builderservice.d_object = (void*) self;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__gov_cca_ports__builderservice;

  self->d_data = (void*) r_obj;

  sidl_rmi_InstanceHandle_addRef(instance, _ex);

  ret_self = (struct gov_cca_ports_BuilderService__object*) (
    *self->d_epv->f__cast)(self, "gov.cca.ports.BuilderService", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/*
 * RMI connector function for the class.
 */

struct gov_cca_ports_BuilderService__object*
gov_cca_ports_BuilderService__connectI(const char* url, sidl_bool ar, struct 
  sidl_BaseInterface__object **_ex)
{
  return gov_cca_ports_BuilderService__remoteConnect(url, ar, _ex);
}


#endif /*WITH_RMI*/
