/*
 * File:          gov_cca_AbstractFramework_fStub.c
 * Symbol:        gov.cca.AbstractFramework-v0.8.5
 * Symbol Type:   interface
 * Babel Version: 1.4.0
 * Description:   Client-side glue code for gov.cca.AbstractFramework
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

/*
 * Symbol "gov.cca.AbstractFramework" (version 0.8.5)
 * 
 *  
 * This is an interface presented by a CCA-compliant framework to access its 
 * application framing capabilities. Most of the manipulation of the 
 * underlying framework is expected to be be done with the 
 * gov.cca.BuilderService Port. This class exists as a sort of bootstrap 
 * to get a Services object necessary to retrieve Port's, including 
 * BuilderService, from the underlying framework. How the interface and 
 * the underlying framework is created is entirely unspecified and is up 
 * to the devices of the programmer and the framework provider.
 * 
 * <p>Example</p>
 * <p>
 * Here it is assumed that an instance of AbstractFramework
 * is created in the main() from some hypothetical implementation.
 * The idea is to allow a complete swap of framework choice by 
 * changing out the specified implementation class of a framework.
 * </p>
 * 
 * <code><pre>
 * // java
 * main() {
 * cca.reference.Framework fwkimpl = new cca.reference.Framework();
 * // change fwkimpl above to use different cca implementations when
 * // AbstractFramework becomes part of the standard.
 * gov.cca.AbstractFramework fwk = (gov.cca.AbstractFramework)fwkimpl;
 * gov.cca.Services svc = 
 * fwk.getServices("instance0","AppDriver",null);
 * // From here on, access all services, components, etc
 * // through svc.
 * ...
 * // when done
 * fwk.releaseServices(svc);
 * fwk.shutdownFramework();
 * }
 * 
 * // c++
 * int functionName() {
 * ::gov::sandia::ccafe::Framework fwkimpl;
 * ::gov::cca::AbstractFrameworkPtr fwk;
 * 
 * fwk = fwkimpl.getStandardFramework();
 * ::gov::cca::Services_Interface  svc = 0;
 * svc = fwk->getServices("instance0","AppDriver",0);
 * // From here on, access all services, components, etc
 * // through svc.
 * ...
 * // when done
 * fwk->releaseServices(svc);
 * svc = 0;
 * fwk->shutdownFramework();
 * 
 * // at scope exit, all memory is automatically cleaned up.
 * }
 * </pre></code>
 */

#ifndef included_gov_cca_AbstractFramework_fStub_h
#include "gov_cca_AbstractFramework_fStub.h"
#endif
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "sidlfortran.h"
#ifndef included_sidl_io_Serializer_h
#include "sidl_io_Serializer.h"
#endif
#ifndef included_sidl_io_Deserializer_h
#include "sidl_io_Deserializer.h"
#endif
#include <stdio.h>
#ifndef included_sidlf90array_h
#include "sidlf90array.h"
#endif
#include "sidl_header.h"
#ifndef included_sidl_interface_IOR_h
#include "sidl_interface_IOR.h"
#endif
#ifndef included_sidl_Exception_h
#include "sidl_Exception.h"
#endif
#include "babel_config.h"
#ifdef SIDL_DYNAMIC_LIBRARY
#include "sidl_Loader.h"
#endif
#include "gov_cca_AbstractFramework_IOR.h"
#include "gov_cca_AbstractFramework_fAbbrev.h"
#include "gov_cca_CCAException_IOR.h"
#include "gov_cca_Services_IOR.h"
#include "gov_cca_TypeMap_IOR.h"
#include "sidl_BaseException_IOR.h"
#include "sidl_BaseInterface_IOR.h"
#include "sidl_ClassInfo_IOR.h"
#include "sidl_RuntimeException_IOR.h"
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidlOps_h
#include "sidlOps.h"
#endif
/*
 * Includes for all method dependencies.
 */

#ifndef included_gov_cca_AbstractFramework_fStub_h
#include "gov_cca_AbstractFramework_fStub.h"
#endif
#ifndef included_gov_cca_CCAException_fStub_h
#include "gov_cca_CCAException_fStub.h"
#endif
#ifndef included_gov_cca_Services_fStub_h
#include "gov_cca_Services_fStub.h"
#endif
#ifndef included_gov_cca_TypeMap_fStub_h
#include "gov_cca_TypeMap_fStub.h"
#endif
#ifndef included_sidl_BaseInterface_fStub_h
#include "sidl_BaseInterface_fStub.h"
#endif
#ifndef included_sidl_ClassInfo_fStub_h
#include "sidl_ClassInfo_fStub.h"
#endif
#ifndef included_sidl_RuntimeException_fStub_h
#include "sidl_RuntimeException_fStub.h"
#endif

#define LANG_SPECIFIC_INIT()
#ifdef WITH_RMI
static struct gov_cca_AbstractFramework__object* 
  gov_cca_AbstractFramework__remoteConnect(const char* url, sidl_bool ar, 
  sidl_BaseInterface *_ex);
static struct gov_cca_AbstractFramework__object* 
  gov_cca_AbstractFramework__IHConnect(struct sidl_rmi_InstanceHandle__object 
  *instance, struct sidl_BaseInterface__object **_ex);
#endif /*WITH_RMI*/
/*
 * Remote Connector for the class.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_rconnect_m,GOV_CCA_ABSTRACTFRAMEWORK_RCONNECT_M,gov_cca_AbstractFramework_rConnect_m)
(
  int64_t *self,
  SIDL_F90_String url
  SIDL_F90_STR_NEAR_LEN_DECL(url),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(url)
)
{
#ifdef WITH_RMI
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  char* _proxy_url = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_url =
    sidl_copy_fortran_str(SIDL_F90_STR(url),(ptrdiff_t)
      SIDL_F90_STR_LEN(url));
  _proxy_self = gov_cca_AbstractFramework__remoteConnect(_proxy_url, 1, 
    &_proxy_exception);
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *self = (ptrdiff_t)_proxy_self;
  }
  free((void *)_proxy_url);
#endif /*WITH_RMI*/
}
/*
 * Cast method for interface and type conversions.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework__cast_m,GOV_CCA_ABSTRACTFRAMEWORK__CAST_M,gov_cca_AbstractFramework__cast_m)
(
  int64_t *ref,
  int64_t *retval,
  int64_t *exception
)
{
#ifdef WITH_RMI
  static int connect_loaded = 0;
#endif /*WITH_RMI*/
  struct sidl_BaseInterface__object  *_base =
    (struct sidl_BaseInterface__object *)(ptrdiff_t)*ref;
  struct sidl_BaseInterface__object *proxy_exception;

  *retval = 0;

#ifdef WITH_RMI

  if(!connect_loaded) {
    sidl_rmi_ConnectRegistry_registerConnect("gov.cca.AbstractFramework", (
      void*)gov_cca_AbstractFramework__IHConnect, &proxy_exception);
    SIDL_CHECK(proxy_exception);
    connect_loaded = 1;
  }

#endif /*WITH_RMI*/

  if (_base) {
    *retval = (ptrdiff_t)(
      *_base->d_epv->f__cast)(
      _base->d_object,
      "gov.cca.AbstractFramework", &proxy_exception);
  } else {
    *retval = 0;
    proxy_exception = 0;
  }
#ifdef WITH_RMI
  EXIT:
#endif /*WITH_RMI*/
  *exception = (ptrdiff_t)proxy_exception;
}

/*
 * Cast method for interface and class type conversions.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework__cast2_m,GOV_CCA_ABSTRACTFRAMEWORK__CAST2_M,gov_cca_AbstractFramework__cast2_m)
(
  int64_t *self,
  SIDL_F90_String name
  SIDL_F90_STR_NEAR_LEN_DECL(name),
  int64_t *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(name)
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  char* _proxy_name = NULL;
  void* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _proxy_name =
    sidl_copy_fortran_str(SIDL_F90_STR(name),(ptrdiff_t)
      SIDL_F90_STR_LEN(name));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__cast))(
      _proxy_self->d_object,
      _proxy_name,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_name);
}


/*
 * Select and execute a method by name
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework__exec_m,GOV_CCA_ABSTRACTFRAMEWORK__EXEC_M,gov_cca_AbstractFramework__exec_m)
(
  int64_t *self,
  SIDL_F90_String methodName
  SIDL_F90_STR_NEAR_LEN_DECL(methodName),
  int64_t *inArgs,
  int64_t *outArgs,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(methodName)
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  char* _proxy_methodName = NULL;
  struct sidl_rmi_Call__object* _proxy_inArgs = NULL;
  struct sidl_rmi_Return__object* _proxy_outArgs = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _proxy_methodName =
    sidl_copy_fortran_str(SIDL_F90_STR(methodName),(ptrdiff_t)
      SIDL_F90_STR_LEN(methodName));
  _proxy_inArgs =
    (struct sidl_rmi_Call__object*)
    (ptrdiff_t)(*inArgs);
  _proxy_outArgs =
    (struct sidl_rmi_Return__object*)
    (ptrdiff_t)(*outArgs);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__exec))(
    _proxy_self->d_object,
    _proxy_methodName,
    _proxy_inArgs,
    _proxy_outArgs,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_methodName);
}


/*
 * Get the URL of the Implementation of this object (for RMI)
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework__geturl_m,GOV_CCA_ABSTRACTFRAMEWORK__GETURL_M,gov_cca_AbstractFramework__getURL_m)
(
  int64_t *self,
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__getURL))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
}


/*
 * TRUE if this object is remote, false if local
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework__isremote_m,GOV_CCA_ABSTRACTFRAMEWORK__ISREMOTE_M,gov_cca_AbstractFramework__isRemote_m)
(
  int64_t *self,
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__isRemote))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}


/*
 * TRUE if this object is remote, false if local
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework__islocal_m,GOV_CCA_ABSTRACTFRAMEWORK__ISLOCAL_M,gov_cca_AbstractFramework__isLocal_m)
(
  int64_t *self,
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    !(*(_epv->f__isRemote))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}


/*
 * Method to enable/disable method hooks invocation.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework__set_hooks_m,GOV_CCA_ABSTRACTFRAMEWORK__SET_HOOKS_M,gov_cca_AbstractFramework__set_hooks_m)
(
  int64_t *self,
  SIDL_F90_Bool *enable,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  sidl_bool _proxy_enable;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _proxy_enable = ((*enable == SIDL_F90_TRUE) ? TRUE : FALSE);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__set_hooks))(
    _proxy_self->d_object,
    _proxy_enable,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}


/*
 * Method to enable/disable interface contract enforcement.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework__set_contracts_m,GOV_CCA_ABSTRACTFRAMEWORK__SET_CONTRACTS_M,gov_cca_AbstractFramework__set_contracts_m)
(
  int64_t *self,
  SIDL_F90_Bool *enable,
  SIDL_F90_String enfFilename
  SIDL_F90_STR_NEAR_LEN_DECL(enfFilename),
  SIDL_F90_Bool *resetCounters,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(enfFilename)
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  sidl_bool _proxy_enable;
  char* _proxy_enfFilename = NULL;
  sidl_bool _proxy_resetCounters;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _proxy_enable = ((*enable == SIDL_F90_TRUE) ? TRUE : FALSE);
  _proxy_enfFilename =
    sidl_copy_fortran_str(SIDL_F90_STR(enfFilename),(ptrdiff_t)
      SIDL_F90_STR_LEN(enfFilename));
  _proxy_resetCounters = ((*resetCounters == SIDL_F90_TRUE) ? TRUE : FALSE);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__set_contracts))(
    _proxy_self->d_object,
    _proxy_enable,
    _proxy_enfFilename,
    _proxy_resetCounters,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_enfFilename);
}


/*
 * Method to dump contract enforcement statistics.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework__dump_stats_m,GOV_CCA_ABSTRACTFRAMEWORK__DUMP_STATS_M,gov_cca_AbstractFramework__dump_stats_m)
(
  int64_t *self,
  SIDL_F90_String filename
  SIDL_F90_STR_NEAR_LEN_DECL(filename),
  SIDL_F90_String prefix
  SIDL_F90_STR_NEAR_LEN_DECL(prefix),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(filename)
  SIDL_F90_STR_FAR_LEN_DECL(prefix)
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  char* _proxy_filename = NULL;
  char* _proxy_prefix = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _proxy_filename =
    sidl_copy_fortran_str(SIDL_F90_STR(filename),(ptrdiff_t)
      SIDL_F90_STR_LEN(filename));
  _proxy_prefix =
    sidl_copy_fortran_str(SIDL_F90_STR(prefix),(ptrdiff_t)
      SIDL_F90_STR_LEN(prefix));
  _epv = _proxy_self->d_epv;
  (*(_epv->f__dump_stats))(
    _proxy_self->d_object,
    _proxy_filename,
    _proxy_prefix,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_filename);
  free((void *)_proxy_prefix);
}

/*
 *  
 * Create an empty TypeMap. Presumably this would be used in 
 * an ensuing call to <code>getServices()</code>. The "normal" method of
 * creating typemaps is found in the <code>Services</code> interface. It
 * is duplicated here to break the "chicken and egg" problem.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_createtypemap_m,GOV_CCA_ABSTRACTFRAMEWORK_CREATETYPEMAP_M,gov_cca_AbstractFramework_createTypeMap_m)
(
  int64_t *self,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  struct gov_cca_TypeMap__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_createTypeMap))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 *  
 * Retrieve a Services handle to the underlying framework. 
 * This interface effectively causes the calling program to 
 * appear as the image of a component inside the framework.
 * This method may be called any number of times
 * with different arguments, creating a new component image 
 * each time. 
 * The only proper method to destroy a Services obtained 
 * from this interface is to pass it to releaseServices.
 * 
 * @param selfInstanceName the Component instance name,
 * as it will appear in the framework.
 * 
 * @param selfClassName the Component type of the 
 * calling program, as it will appear in the framework. 
 * 
 * @param selfProperties (which can be null) the properties 
 * of the component image to appear. 
 * 
 * @throws CCAException in the event that selfInstanceName 
 * is already in use by another component.
 * 
 * @return  A Services object that pertains to the
 * image of the this component. This is identical
 * to the object passed into Component.setServices() 
 * when a component is created.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_getservices_m,GOV_CCA_ABSTRACTFRAMEWORK_GETSERVICES_M,gov_cca_AbstractFramework_getServices_m)
(
  int64_t *self,
  SIDL_F90_String selfInstanceName
  SIDL_F90_STR_NEAR_LEN_DECL(selfInstanceName),
  SIDL_F90_String selfClassName
  SIDL_F90_STR_NEAR_LEN_DECL(selfClassName),
  int64_t *selfProperties,
  int64_t *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(selfInstanceName)
  SIDL_F90_STR_FAR_LEN_DECL(selfClassName)
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  char* _proxy_selfInstanceName = NULL;
  char* _proxy_selfClassName = NULL;
  struct gov_cca_TypeMap__object* _proxy_selfProperties = NULL;
  struct gov_cca_Services__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _proxy_selfInstanceName =
    sidl_copy_fortran_str(SIDL_F90_STR(selfInstanceName),(ptrdiff_t)
      SIDL_F90_STR_LEN(selfInstanceName));
  _proxy_selfClassName =
    sidl_copy_fortran_str(SIDL_F90_STR(selfClassName),(ptrdiff_t)
      SIDL_F90_STR_LEN(selfClassName));
  _proxy_selfProperties =
    (struct gov_cca_TypeMap__object*)
    (ptrdiff_t)(*selfProperties);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getServices))(
      _proxy_self->d_object,
      _proxy_selfInstanceName,
      _proxy_selfClassName,
      _proxy_selfProperties,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_selfInstanceName);
  free((void *)_proxy_selfClassName);
}

/*
 *  
 * Inform framework that the <code>Services</code> handle is no longer needed by the 
 * caller and that the reference to its component image is to be
 * deleted from the context of the underlying framework. This invalidates
 * any <code>ComponentID</code>'s or <code>ConnectionID</code>'s associated 
 * with the given <code>Services</code>' component image. 
 * 
 * @param services The result of getServices earlier obtained.
 * 
 * @throws CCAException if the <code>Services</code>
 * handle has already been released or is otherwise rendered invalid 
 * or was not obtained from <code>getServices()</code>.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_releaseservices_m,GOV_CCA_ABSTRACTFRAMEWORK_RELEASESERVICES_M,gov_cca_AbstractFramework_releaseServices_m)
(
  int64_t *self,
  int64_t *services,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  struct gov_cca_Services__object* _proxy_services = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _proxy_services =
    (struct gov_cca_Services__object*)
    (ptrdiff_t)(*services);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_releaseServices))(
    _proxy_self->d_object,
    _proxy_services,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 *  
 * Tell the framework it is no longer needed and to clean up after itself. 
 * @throws CCAException if the framework has already been shutdown.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_shutdownframework_m,GOV_CCA_ABSTRACTFRAMEWORK_SHUTDOWNFRAMEWORK_M,gov_cca_AbstractFramework_shutdownFramework_m)
(
  int64_t *self,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_shutdownFramework))(
    _proxy_self->d_object,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 *  
 * Creates a new framework instance based on the same underlying 
 * framework implementation. This does not copy the existing 
 * framework, nor are any of the user-instantiated components in
 * the original framework available in the newly created 
 * <code>AbstractFramework</code>. 
 * 
 * @throws CCAException when one of the following conditions occur:
 * 
 * (1)the AbstractFramework previously had shutdownFramework() called on it, or 
 * (2)the underlying framework implementation does not permit creation 
 * of another instance.	 
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_createemptyframework_m,GOV_CCA_ABSTRACTFRAMEWORK_CREATEEMPTYFRAMEWORK_M,gov_cca_AbstractFramework_createEmptyFramework_m)
(
  int64_t *self,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_createEmptyFramework))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>sidl</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_addref_m,GOV_CCA_ABSTRACTFRAMEWORK_ADDREF_M,gov_cca_AbstractFramework_addRef_m)
(
  int64_t *self,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_addRef))(
    _proxy_self->d_object,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>sidl</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_deleteref_m,GOV_CCA_ABSTRACTFRAMEWORK_DELETEREF_M,gov_cca_AbstractFramework_deleteRef_m)
(
  int64_t *self,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_deleteRef))(
    _proxy_self->d_object,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_issame_m,GOV_CCA_ABSTRACTFRAMEWORK_ISSAME_M,gov_cca_AbstractFramework_isSame_m)
(
  int64_t *self,
  int64_t *iobj,
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_iobj = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _proxy_iobj =
    (struct sidl_BaseInterface__object*)
    (ptrdiff_t)(*iobj);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_isSame))(
      _proxy_self->d_object,
      _proxy_iobj,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}

/*
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_istype_m,GOV_CCA_ABSTRACTFRAMEWORK_ISTYPE_M,gov_cca_AbstractFramework_isType_m)
(
  int64_t *self,
  SIDL_F90_String name
  SIDL_F90_STR_NEAR_LEN_DECL(name),
  SIDL_F90_Bool *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(name)
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  char* _proxy_name = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _proxy_name =
    sidl_copy_fortran_str(SIDL_F90_STR(name),(ptrdiff_t)
      SIDL_F90_STR_LEN(name));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_isType))(
      _proxy_self->d_object,
      _proxy_name,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
  free((void *)_proxy_name);
}

/*
 * Return the meta-data about the class implementing this interface.
 */

void
SIDLFortran90Symbol(gov_cca_abstractframework_getclassinfo_m,GOV_CCA_ABSTRACTFRAMEWORK_GETCLASSINFO_M,gov_cca_AbstractFramework_getClassInfo_m)
(
  int64_t *self,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_AbstractFramework__epv *_epv = NULL;
  struct gov_cca_AbstractFramework__object* _proxy_self = NULL;
  struct sidl_ClassInfo__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_AbstractFramework__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getClassInfo))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_createcol_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_CREATECOL_M,
                  gov_cca_AbstractFramework__array_createCol_m)
  (int32_t *dimen,
   int32_t lower[],
   int32_t upper[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_createCol(*dimen, lower, upper);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_createrow_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_CREATEROW_M,
                  gov_cca_AbstractFramework__array_createRow_m)
  (int32_t *dimen,
   int32_t lower[],
   int32_t upper[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_createRow(*dimen, lower, upper);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_create1d_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_CREATE1D_M,
                  gov_cca_AbstractFramework__array_create1d_m)
  (int32_t *len, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create1d(*len);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_create2dcol_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_CREATE2DCOL_M,
                  gov_cca_AbstractFramework__array_create2dCol_m)
  (int32_t *m, int32_t *n, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create2dCol(*m, *n);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_create2drow_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_CREATE2DROW_M,
                  gov_cca_AbstractFramework__array_create2dRow_m)
  (int32_t *m, int32_t *n, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create2dRow(*m, *n);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_addref_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_ADDREF_M,
                  gov_cca_AbstractFramework__array_addRef_m)
  (int64_t *array)
{
  sidl_interface__array_addRef((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_deleteref_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_DELETEREF_M,
                  gov_cca_AbstractFramework__array_deleteRef_m)
  (int64_t *array)
{
  sidl_interface__array_deleteRef((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_get1_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_GET1_M,
                  gov_cca_AbstractFramework__array_get1_m)
  (int64_t *array, 
   int32_t *i1, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get1((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_get2_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_GET2_M,
                  gov_cca_AbstractFramework__array_get2_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get2((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_get3_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_GET3_M,
                  gov_cca_AbstractFramework__array_get3_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get3((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_get4_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_GET4_M,
                  gov_cca_AbstractFramework__array_get4_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get4((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_get5_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_GET5_M,
                  gov_cca_AbstractFramework__array_get5_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get5((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_get6_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_GET6_M,
                  gov_cca_AbstractFramework__array_get6_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int32_t *i6, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get6((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5, *i6);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_get7_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_GET7_M,
                  gov_cca_AbstractFramework__array_get7_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int32_t *i6, 
   int32_t *i7, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get7((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5, *i6, *i7);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_get_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_GET_M,
                  gov_cca_AbstractFramework__array_get_m)
  (int64_t *array,
   int32_t indices[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get((const struct sidl_interface__array *)(
      ptrdiff_t)*array, indices);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_set1_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SET1_M,
                  gov_cca_AbstractFramework__array_set1_m)
  (int64_t *array,
   int32_t *i1,
   int64_t *value)
{
  sidl_interface__array_set1((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_set2_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SET2_M,
                  gov_cca_AbstractFramework__array_set2_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int64_t *value)
{
  sidl_interface__array_set2((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_set3_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SET3_M,
                  gov_cca_AbstractFramework__array_set3_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int64_t *value)
{
  sidl_interface__array_set3((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_set4_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SET4_M,
                  gov_cca_AbstractFramework__array_set4_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int64_t *value)
{
  sidl_interface__array_set4((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_set5_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SET5_M,
                  gov_cca_AbstractFramework__array_set5_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int64_t *value)
{
  sidl_interface__array_set5((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_set6_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SET6_M,
                  gov_cca_AbstractFramework__array_set6_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int32_t *i6,
   int64_t *value)
{
  sidl_interface__array_set6((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, *i6, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_set7_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SET7_M,
                  gov_cca_AbstractFramework__array_set7_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int32_t *i6,
   int32_t *i7,
   int64_t *value)
{
  sidl_interface__array_set7((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, *i6, *i7, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_set_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SET_M,
                  gov_cca_AbstractFramework__array_set_m)
  (int64_t *array,
  int32_t indices[],
  int64_t *value)
{
  sidl_interface__array_set((struct sidl_interface__array *)(ptrdiff_t)*array, 
    indices, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_dimen_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_DIMEN_M,
                  gov_cca_AbstractFramework__array_dimen_m)
  (int64_t *array, int32_t *result)
{
  *result =
    sidl_interface__array_dimen((struct sidl_interface__array *)(
      ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_lower_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_LOWER_M,
                  gov_cca_AbstractFramework__array_lower_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_lower((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_upper_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_UPPER_M,
                  gov_cca_AbstractFramework__array_upper_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_upper((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_length_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_LENGTH_M,
                  gov_cca_AbstractFramework__array_length_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_length((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_stride_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_STRIDE_M,
                  gov_cca_AbstractFramework__array_stride_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_stride((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_iscolumnorder_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_ISCOLUMNORDER_M,
                  gov_cca_AbstractFramework__array_isColumnOrder_m)
  (int64_t *array,
   SIDL_F90_Bool *result)
{
  *result = sidl_interface__array_isColumnOrder((struct sidl_interface__array 
    *)(ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_isroworder_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_ISROWORDER_M,
                  gov_cca_AbstractFramework__array_isRowOrder_m)
  (int64_t *array,
   SIDL_F90_Bool *result)
{
  *result = sidl_interface__array_isRowOrder((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_copy_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_COPY_M,
                  gov_cca_AbstractFramework__array_copy_m)
  (int64_t *src,
   int64_t *dest)
{
  sidl_interface__array_copy((const struct sidl_interface__array *)(
    ptrdiff_t)*src,
                             (struct sidl_interface__array *)(ptrdiff_t)*dest);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_smartcopy_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SMARTCOPY_M,
                  gov_cca_AbstractFramework__array_smartCopy_m)
  (int64_t *src)
{
  sidl_interface__array_smartCopy((struct sidl_interface__array *)(
    ptrdiff_t)*src);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_slice_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_SLICE_M,
                  gov_cca_AbstractFramework__array_slice_m)
  (int64_t *src,
   int32_t *dimen,
   int32_t numElem[],
   int32_t srcStart[],
   int32_t srcStride[],
   int32_t newStart[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_slice((struct sidl_interface__array *)(ptrdiff_t)*src,
      *dimen, numElem, srcStart, srcStride, newStart);
}

void
SIDLFortran90Symbol(gov_cca_abstractframework__array_ensure_m,
                  GOV_CCA_ABSTRACTFRAMEWORK__ARRAY_ENSURE_M,
                  gov_cca_AbstractFramework__array_ensure_m)
  (int64_t *src,
   int32_t *dimen,
   int     *ordering,
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_ensure((struct sidl_interface__array *)(
      ptrdiff_t)*src,
    *dimen, *ordering);
}

#ifdef WITH_RMI

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#ifndef included_sidl_BaseClass_h
#include "sidl_BaseClass.h"
#endif
#ifndef included_sidl_ClassInfo_h
#include "sidl_ClassInfo.h"
#endif
#ifndef included_sidl_rmi_ProtocolFactory_h
#include "sidl_rmi_ProtocolFactory.h"
#endif
#ifndef included_sidl_rmi_InstanceRegistry_h
#include "sidl_rmi_InstanceRegistry.h"
#endif
#ifndef included_sidl_rmi_InstanceHandle_h
#include "sidl_rmi_InstanceHandle.h"
#endif
#ifndef included_sidl_rmi_Invocation_h
#include "sidl_rmi_Invocation.h"
#endif
#ifndef included_sidl_rmi_Response_h
#include "sidl_rmi_Response.h"
#endif
#ifndef included_sidl_rmi_ServerRegistry_h
#include "sidl_rmi_ServerRegistry.h"
#endif
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidl_io_Serializable_h
#include "sidl_io_Serializable.h"
#endif
#ifndef included_sidl_MemAllocException_h
#include "sidl_MemAllocException.h"
#endif
#ifndef included_sidl_NotImplementedException_h
#include "sidl_NotImplementedException.h"
#endif
#include "sidl_Exception.h"

#ifndef NULL
#define NULL 0
#endif

#include "sidl_thread.h"
#ifdef HAVE_PTHREAD
static struct sidl_recursive_mutex_t gov_cca__AbstractFramework__mutex= SIDL_RECURSIVE_MUTEX_INITIALIZER;
#define LOCK_STATIC_GLOBALS sidl_recursive_mutex_lock( &gov_cca__AbstractFramework__mutex )
#define UNLOCK_STATIC_GLOBALS sidl_recursive_mutex_unlock( &gov_cca__AbstractFramework__mutex )
/* #define HAVE_LOCKED_STATIC_GLOBALS (sidl_recursive_mutex_trylock( &gov_cca__AbstractFramework__mutex )==EDEADLOCK) */
#else
#define LOCK_STATIC_GLOBALS
#define UNLOCK_STATIC_GLOBALS
/* #define HAVE_LOCKED_STATIC_GLOBALS (1) */
#endif

/* Static variables to hold version of IOR */
static const int32_t s_IOR_MAJOR_VERSION = 2;
static const int32_t s_IOR_MINOR_VERSION = 0;

/* Static variables for managing EPV initialization. */
static int s_remote_initialized = 0;

static struct gov_cca__AbstractFramework__epv 
  s_rem_epv__gov_cca__abstractframework;

static struct gov_cca_AbstractFramework__epv 
  s_rem_epv__gov_cca_abstractframework;

static struct sidl_BaseInterface__epv s_rem_epv__sidl_baseinterface;


/* REMOTE CAST: dynamic type casting for remote objects. */
static void* remote_gov_cca__AbstractFramework__cast(
  struct gov_cca__AbstractFramework__object* self,
  const char* name, sidl_BaseInterface* _ex)
{
  int cmp;
  void* cast = NULL;
  *_ex = NULL; /* default to no exception */
  cmp = strcmp(name, "gov.cca._AbstractFramework");
  if (!cmp) {
    (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
    cast = ((struct gov_cca__AbstractFramework__object*)self);
    return cast;
  }
  else if (cmp < 0) {
    cmp = strcmp(name, "gov.cca.AbstractFramework");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = &((*self).d_gov_cca_abstractframework);
      return cast;
    }
  }
  else if (cmp > 0) {
    cmp = strcmp(name, "sidl.BaseInterface");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = &((*self).d_sidl_baseinterface);
      return cast;
    }
  }
  if ((*self->d_epv->f_isType)(self,name, _ex)) {
    void* (*func)(struct sidl_rmi_InstanceHandle__object*, struct 
      sidl_BaseInterface__object**) = 
      (void* (*)(struct sidl_rmi_InstanceHandle__object*, struct 
        sidl_BaseInterface__object**)) 
      sidl_rmi_ConnectRegistry_getConnect(name, _ex);SIDL_CHECK(*_ex);
    cast =  (*func)(((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih, _ex);
  }

  return cast;
  EXIT:
  return NULL;
}

/* REMOTE DELETE: call the remote destructor for the object. */
static void remote_gov_cca__AbstractFramework__delete(
  struct gov_cca__AbstractFramework__object* self,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
  free((void*) self);
}

/* REMOTE GETURL: call the getURL function for the object. */
static char* remote_gov_cca__AbstractFramework__getURL(
  struct gov_cca__AbstractFramework__object* self, struct 
    sidl_BaseInterface__object* *_ex)
{
  struct sidl_rmi_InstanceHandle__object *conn = ((struct 
    gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
  *_ex = NULL;
  if(conn != NULL) {
    return sidl_rmi_InstanceHandle_getObjectURL(conn, _ex);
  }
  return NULL;
}

/* REMOTE ADDREF: For internal babel use only! Remote addRef. */
static void remote_gov_cca__AbstractFramework__raddRef(
  struct gov_cca__AbstractFramework__object* self,struct 
    sidl_BaseInterface__object* *_ex)
{
  struct sidl_BaseException__object* netex = NULL;
  /* initialize a new invocation */
  struct sidl_BaseInterface__object* _throwaway = NULL;
  struct sidl_rmi_InstanceHandle__object *_conn = ((struct 
    gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
  sidl_rmi_Response _rsvp = NULL;
  sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
    "addRef", _ex ); SIDL_CHECK(*_ex);
  /* send actual RMI request */
  _rsvp = sidl_rmi_Invocation_invokeMethod(_inv,_ex);SIDL_CHECK(*_ex);
  /* Check for exceptions */
  netex = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);
  if(netex != NULL) {
    *_ex = (struct sidl_BaseInterface__object*)netex;
    return;
  }

  /* cleanup and return */
  EXIT:
  if(_inv) { sidl_rmi_Invocation_deleteRef(_inv,&_throwaway); }
  if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp,&_throwaway); }
  return;
}

/* REMOTE ISREMOTE: returns true if this object is Remote (it is). */
static sidl_bool
remote_gov_cca__AbstractFramework__isRemote(
    struct gov_cca__AbstractFramework__object* self, 
    struct sidl_BaseInterface__object* *_ex) {
  *_ex = NULL;
  return TRUE;
}

/* REMOTE METHOD STUB:_set_hooks */
static void
remote_gov_cca__AbstractFramework__set_hooks(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ sidl_bool enable,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_hooks", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework._set_hooks.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_set_contracts */
static void
remote_gov_cca__AbstractFramework__set_contracts(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ sidl_bool enable,
  /* in */ const char* enfFilename,
  /* in */ sidl_bool resetCounters,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_contracts", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packString( _inv, "enfFilename", enfFilename, 
      _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packBool( _inv, "resetCounters", resetCounters, 
      _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework._set_contracts.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_dump_stats */
static void
remote_gov_cca__AbstractFramework__dump_stats(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ const char* filename,
  /* in */ const char* prefix,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_dump_stats", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "filename", filename, _ex);SIDL_CHECK(
      *_ex);
    sidl_rmi_Invocation_packString( _inv, "prefix", prefix, _ex);SIDL_CHECK(
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework._dump_stats.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE EXEC: call the exec function for the object. */
static void remote_gov_cca__AbstractFramework__exec(
  struct gov_cca__AbstractFramework__object* self,const char* methodName,
  sidl_rmi_Call inArgs,
  sidl_rmi_Return outArgs,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
}

/* REMOTE METHOD STUB:createTypeMap */
static struct gov_cca_TypeMap__object*
remote_gov_cca__AbstractFramework_createTypeMap(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_TypeMap__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "createTypeMap", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.createTypeMap.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_TypeMap__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getServices */
static struct gov_cca_Services__object*
remote_gov_cca__AbstractFramework_getServices(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ const char* selfInstanceName,
  /* in */ const char* selfClassName,
  /* in */ struct gov_cca_TypeMap__object* selfProperties,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_Services__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getServices", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "selfInstanceName", selfInstanceName, 
      _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packString( _inv, "selfClassName", selfClassName, 
      _ex);SIDL_CHECK(*_ex);
    if(selfProperties){
      char* _url = sidl_BaseInterface__getURL((
        sidl_BaseInterface)selfProperties, _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "selfProperties", _url, 
        _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "selfProperties", NULL, 
        _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.getServices.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_Services__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:releaseServices */
static void
remote_gov_cca__AbstractFramework_releaseServices(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ struct gov_cca_Services__object* services,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "releaseServices", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(services){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)services, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "services", _url, _ex);SIDL_CHECK(
        *_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "services", NULL, _ex);SIDL_CHECK(
        *_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.releaseServices.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:shutdownFramework */
static void
remote_gov_cca__AbstractFramework_shutdownFramework(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "shutdownFramework", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.shutdownFramework.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:createEmptyFramework */
static struct gov_cca_AbstractFramework__object*
remote_gov_cca__AbstractFramework_createEmptyFramework(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_AbstractFramework__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "createEmptyFramework", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.createEmptyFramework.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_AbstractFramework__connectI(_retval_str, FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:addRef */
static void
remote_gov_cca__AbstractFramework_addRef(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct gov_cca__AbstractFramework__remote* r_obj = (struct 
      gov_cca__AbstractFramework__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount++;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: addRef %p new count %d (type %s)\n",
      r_obj, r_obj->d_refcount, 
      "gov.cca._AbstractFramework Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:deleteRef */
static void
remote_gov_cca__AbstractFramework_deleteRef(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct gov_cca__AbstractFramework__remote* r_obj = (struct 
      gov_cca__AbstractFramework__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount--;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: deleteRef %p new count %d (type %s)\n",r_obj, r_obj->d_refcount, "gov.cca._AbstractFramework Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    if(r_obj->d_refcount == 0) {
      sidl_rmi_InstanceHandle_deleteRef(r_obj->d_ih, _ex);
      free(r_obj);
      free(self);
    }
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:isSame */
static sidl_bool
remote_gov_cca__AbstractFramework_isSame(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ struct sidl_BaseInterface__object* iobj,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isSame", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(iobj){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)iobj, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "iobj", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "iobj", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.isSame.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:isType */
static sidl_bool
remote_gov_cca__AbstractFramework_isType(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ const char* name,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isType", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "name", name, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.isType.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getClassInfo */
static struct sidl_ClassInfo__object*
remote_gov_cca__AbstractFramework_getClassInfo(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct sidl_ClassInfo__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getClassInfo", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.getClassInfo.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = sidl_ClassInfo__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE EPV: create remote entry point vectors (EPVs). */
static void gov_cca__AbstractFramework__init_remote_epv(void)
{
  /* assert( HAVE_LOCKED_STATIC_GLOBALS ); */
  struct gov_cca__AbstractFramework__epv* epv = 
    &s_rem_epv__gov_cca__abstractframework;
  struct gov_cca_AbstractFramework__epv*  e0  = 
    &s_rem_epv__gov_cca_abstractframework;
  struct sidl_BaseInterface__epv*         e1  = &s_rem_epv__sidl_baseinterface;

  epv->f__cast                     = remote_gov_cca__AbstractFramework__cast;
  epv->f__delete                   = remote_gov_cca__AbstractFramework__delete;
  epv->f__exec                     = remote_gov_cca__AbstractFramework__exec;
  epv->f__getURL                   = remote_gov_cca__AbstractFramework__getURL;
  epv->f__raddRef                  = remote_gov_cca__AbstractFramework__raddRef;
  epv->f__isRemote                 = 
    remote_gov_cca__AbstractFramework__isRemote;
  epv->f__set_hooks                = 
    remote_gov_cca__AbstractFramework__set_hooks;
  epv->f__set_contracts            = 
    remote_gov_cca__AbstractFramework__set_contracts;
  epv->f__dump_stats               = 
    remote_gov_cca__AbstractFramework__dump_stats;
  epv->f__ctor                     = NULL;
  epv->f__ctor2                    = NULL;
  epv->f__dtor                     = NULL;
  epv->f_createTypeMap             = 
    remote_gov_cca__AbstractFramework_createTypeMap;
  epv->f_getServices               = 
    remote_gov_cca__AbstractFramework_getServices;
  epv->f_releaseServices           = 
    remote_gov_cca__AbstractFramework_releaseServices;
  epv->f_shutdownFramework         = 
    remote_gov_cca__AbstractFramework_shutdownFramework;
  epv->f_createEmptyFramework      = 
    remote_gov_cca__AbstractFramework_createEmptyFramework;
  epv->f_addRef                    = remote_gov_cca__AbstractFramework_addRef;
  epv->f_deleteRef                 = 
    remote_gov_cca__AbstractFramework_deleteRef;
  epv->f_isSame                    = remote_gov_cca__AbstractFramework_isSame;
  epv->f_isType                    = remote_gov_cca__AbstractFramework_isType;
  epv->f_getClassInfo              = 
    remote_gov_cca__AbstractFramework_getClassInfo;

  e0->f__cast                = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e0->f__delete              = (void (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__delete;
  e0->f__getURL              = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e0->f__raddRef             = (void (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__raddRef;
  e0->f__isRemote            = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e0->f__set_hooks           = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e0->f__set_contracts       = (void (*)(void*, sidl_bool, const char*, 
    sidl_bool, struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e0->f__dump_stats          = (void (*)(void*, const char*, const char*, 
    struct sidl_BaseInterface__object**)) epv->f__dump_stats;
  e0->f__exec                = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e0->f_createTypeMap        = (struct gov_cca_TypeMap__object* (*)(void*,
    struct sidl_BaseInterface__object **)) epv->f_createTypeMap;
  e0->f_getServices          = (struct gov_cca_Services__object* (*)(void*,
    const char*,const char*,struct gov_cca_TypeMap__object*,struct 
    sidl_BaseInterface__object **)) epv->f_getServices;
  e0->f_releaseServices      = (void (*)(void*,struct gov_cca_Services__object*,
    struct sidl_BaseInterface__object **)) epv->f_releaseServices;
  e0->f_shutdownFramework    = (void (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_shutdownFramework;
  e0->f_createEmptyFramework = (struct gov_cca_AbstractFramework__object* (*)(
    void*,struct sidl_BaseInterface__object **)) epv->f_createEmptyFramework;
  e0->f_addRef               = (void (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_addRef;
  e0->f_deleteRef            = (void (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_deleteRef;
  e0->f_isSame               = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e0->f_isType               = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e0->f_getClassInfo         = (struct sidl_ClassInfo__object* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_getClassInfo;

  e1->f__cast          = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e1->f__delete        = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__delete;
  e1->f__getURL        = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e1->f__raddRef       = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__raddRef;
  e1->f__isRemote      = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e1->f__set_hooks     = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e1->f__set_contracts = (void (*)(void*, sidl_bool, const char*, sidl_bool, 
    struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e1->f__dump_stats    = (void (*)(void*, const char*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__dump_stats;
  e1->f__exec          = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e1->f_addRef         = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_addRef;
  e1->f_deleteRef      = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_deleteRef;
  e1->f_isSame         = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e1->f_isType         = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e1->f_getClassInfo   = (struct sidl_ClassInfo__object* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_getClassInfo;

  s_remote_initialized = 1;
}

/* Create an instance that connects to an existing remote object. */
static struct gov_cca_AbstractFramework__object*
gov_cca_AbstractFramework__remoteConnect(const char *url, sidl_bool ar, struct 
  sidl_BaseInterface__object* *_ex)
{
  struct gov_cca__AbstractFramework__object* self = NULL;

  struct gov_cca__AbstractFramework__object* s0;

  struct gov_cca__AbstractFramework__remote* r_obj = NULL;
  sidl_rmi_InstanceHandle instance = NULL;
  struct gov_cca_AbstractFramework__object* ret_self = NULL;
  char* objectID = NULL;
  objectID = sidl_rmi_ServerRegistry_isLocalObject(url, _ex);
  if(objectID) {
    sidl_BaseInterface bi = (sidl_BaseInterface) 
      sidl_rmi_InstanceRegistry_getInstanceByString(objectID, _ex);
    return (struct gov_cca_AbstractFramework__object*)(*bi->d_epv->f__cast)(
      bi->d_object, "gov.cca.AbstractFramework", _ex);
  }
  instance = sidl_rmi_ProtocolFactory_connectInstance(url, 
    "gov.cca.AbstractFramework", ar, _ex );
  if ( instance == NULL) { return NULL; }
  self =
    (struct gov_cca__AbstractFramework__object*) malloc(
      sizeof(struct gov_cca__AbstractFramework__object));

  r_obj =
    (struct gov_cca__AbstractFramework__remote*) malloc(
      sizeof(struct gov_cca__AbstractFramework__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "gov.cca._AbstractFramework.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                                      self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    gov_cca__AbstractFramework__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_gov_cca_abstractframework.d_epv    = 
    &s_rem_epv__gov_cca_abstractframework;
  s0->d_gov_cca_abstractframework.d_object = (void*) self;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__gov_cca__abstractframework;

  self->d_data = (void*) r_obj;

  ret_self = (struct gov_cca_AbstractFramework__object*) (
    *self->d_epv->f__cast)(self, "gov.cca.AbstractFramework", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/* Create an instance that uses an already existing  */
/* InstanceHandel to connect to an existing remote object. */
static struct gov_cca_AbstractFramework__object*
gov_cca_AbstractFramework__IHConnect(sidl_rmi_InstanceHandle instance, struct 
  sidl_BaseInterface__object* *_ex)
{
  struct gov_cca__AbstractFramework__object* self = NULL;

  struct gov_cca__AbstractFramework__object* s0;

  struct gov_cca__AbstractFramework__remote* r_obj = NULL;
  struct gov_cca_AbstractFramework__object* ret_self = NULL;
  self =
    (struct gov_cca__AbstractFramework__object*) malloc(
      sizeof(struct gov_cca__AbstractFramework__object));

  r_obj =
    (struct gov_cca__AbstractFramework__remote*) malloc(
      sizeof(struct gov_cca__AbstractFramework__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "gov.cca._AbstractFramework.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                                      self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    gov_cca__AbstractFramework__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_gov_cca_abstractframework.d_epv    = 
    &s_rem_epv__gov_cca_abstractframework;
  s0->d_gov_cca_abstractframework.d_object = (void*) self;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__gov_cca__abstractframework;

  self->d_data = (void*) r_obj;

  sidl_rmi_InstanceHandle_addRef(instance, _ex);

  ret_self = (struct gov_cca_AbstractFramework__object*) (
    *self->d_epv->f__cast)(self, "gov.cca.AbstractFramework", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/*
 * RMI connector function for the class.
 */

struct gov_cca_AbstractFramework__object*
gov_cca_AbstractFramework__connectI(const char* url, sidl_bool ar, struct 
  sidl_BaseInterface__object **_ex)
{
  return gov_cca_AbstractFramework__remoteConnect(url, ar, _ex);
}


#endif /*WITH_RMI*/
