/*
 * File:          gov_cca_ports_ParameterPort_fStub.c
 * Symbol:        gov.cca.ports.ParameterPort-v0.8.5
 * Symbol Type:   interface
 * Babel Version: 1.4.0
 * Description:   Client-side glue code for gov.cca.ports.ParameterPort
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

/*
 * Symbol "gov.cca.ports.ParameterPort" (version 0.8.5)
 * 
 *  This type of interface is exported for manipulation by other
 * components or by a user-interface (UI) (text or graphic).
 * By using the port ParameterFactory the component
 * writer never actually has to implement this port directly.
 * The recommended instance name for this port type is "CONFIG",
 * if a component provides only one such port. 
 * Component assembly or user interface rendering agents might 
 * assume this name. However, clever agents will act based on
 * port type rather than port instance name.
 * 
 * Data types represented: Anything representable in a TypeMap.
 * The following auxiliary information is managed for the benefit
 * of component end-user, UI, and other agents. 
 * Per map:
 * - title -- a name suitable to a top level window frame.
 * - group names -- data items are put in subsets (groups)
 * as, for example, in tabbed dialogs.
 * - list of all published parameter keys, those defined
 * with the add functions of ParameterPortFactory. 
 * Per group name:
 * - group title -- ui-appropriate subset title, typically a tab heading.
 * - group keys -- list of data item keys in a named group.
 * Per data item key:
 * - default value 
 * - current value -- queryable directly from TypeMap by key name.
 * - help string -- potentially long-winded explanation of parameter use.
 * - prompt string -- shorter than help string and usually shown
 * in UI somehow while soliciting input.
 * - numeric bounds or value choice list. Where data type is
 * an array type, the choice or bound restrictions are applied
 * element-wise.
 * 
 * 
 * Special notes:
 * - The rendering of array-valued parameters in UI's poses a variety
 * of thorny problems in human-computer interaction. Use of
 * array parameters should be considered carefully. Not all UI
 * agents may be able to render array-valued parameters.
 * - Keys in the TypeMap with names starting with "gcpPPF." are
 * reserved for private use by the 
 * ParameterPortFactory implementation.
 */

#ifndef included_gov_cca_ports_ParameterPort_fStub_h
#include "gov_cca_ports_ParameterPort_fStub.h"
#endif
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "sidlfortran.h"
#ifndef included_sidl_io_Serializer_h
#include "sidl_io_Serializer.h"
#endif
#ifndef included_sidl_io_Deserializer_h
#include "sidl_io_Deserializer.h"
#endif
#include <stdio.h>
#ifndef included_sidlf90array_h
#include "sidlf90array.h"
#endif
#include "sidl_header.h"
#ifndef included_sidl_interface_IOR_h
#include "sidl_interface_IOR.h"
#endif
#ifndef included_sidl_Exception_h
#include "sidl_Exception.h"
#endif
#include "babel_config.h"
#ifdef SIDL_DYNAMIC_LIBRARY
#include "sidl_Loader.h"
#endif
#include "gov_cca_ports_ParameterPort_IOR.h"
#include "gov_cca_ports_ParameterPort_fAbbrev.h"
#include "gov_cca_CCAException_IOR.h"
#include "gov_cca_TypeMap_IOR.h"
#include "sidl_BaseException_IOR.h"
#include "sidl_BaseInterface_IOR.h"
#include "sidl_ClassInfo_IOR.h"
#include "sidl_RuntimeException_IOR.h"
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidlOps_h
#include "sidlOps.h"
#endif
/*
 * Includes for all method dependencies.
 */

#ifndef included_gov_cca_CCAException_fStub_h
#include "gov_cca_CCAException_fStub.h"
#endif
#ifndef included_gov_cca_Port_fStub_h
#include "gov_cca_Port_fStub.h"
#endif
#ifndef included_gov_cca_TypeMap_fStub_h
#include "gov_cca_TypeMap_fStub.h"
#endif
#ifndef included_gov_cca_ports_BasicParameterPort_fStub_h
#include "gov_cca_ports_BasicParameterPort_fStub.h"
#endif
#ifndef included_gov_cca_ports_ParameterPort_fStub_h
#include "gov_cca_ports_ParameterPort_fStub.h"
#endif
#ifndef included_sidl_BaseInterface_fStub_h
#include "sidl_BaseInterface_fStub.h"
#endif
#ifndef included_sidl_ClassInfo_fStub_h
#include "sidl_ClassInfo_fStub.h"
#endif
#ifndef included_sidl_RuntimeException_fStub_h
#include "sidl_RuntimeException_fStub.h"
#endif

#define LANG_SPECIFIC_INIT()
#ifdef WITH_RMI
static struct gov_cca_ports_ParameterPort__object* 
  gov_cca_ports_ParameterPort__remoteConnect(const char* url, sidl_bool ar, 
  sidl_BaseInterface *_ex);
static struct gov_cca_ports_ParameterPort__object* 
  gov_cca_ports_ParameterPort__IHConnect(struct sidl_rmi_InstanceHandle__object 
  *instance, struct sidl_BaseInterface__object **_ex);
#endif /*WITH_RMI*/
/*
 * Remote Connector for the class.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_rconnect_m,GOV_CCA_PORTS_PARAMETERPORT_RCONNECT_M,gov_cca_ports_ParameterPort_rConnect_m)
(
  int64_t *self,
  SIDL_F90_String url
  SIDL_F90_STR_NEAR_LEN_DECL(url),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(url)
)
{
#ifdef WITH_RMI
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_url = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_url =
    sidl_copy_fortran_str(SIDL_F90_STR(url),(ptrdiff_t)
      SIDL_F90_STR_LEN(url));
  _proxy_self = gov_cca_ports_ParameterPort__remoteConnect(_proxy_url, 1, 
    &_proxy_exception);
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *self = (ptrdiff_t)_proxy_self;
  }
  free((void *)_proxy_url);
#endif /*WITH_RMI*/
}
/*
 * Cast method for interface and type conversions.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__cast_m,GOV_CCA_PORTS_PARAMETERPORT__CAST_M,gov_cca_ports_ParameterPort__cast_m)
(
  int64_t *ref,
  int64_t *retval,
  int64_t *exception
)
{
#ifdef WITH_RMI
  static int connect_loaded = 0;
#endif /*WITH_RMI*/
  struct sidl_BaseInterface__object  *_base =
    (struct sidl_BaseInterface__object *)(ptrdiff_t)*ref;
  struct sidl_BaseInterface__object *proxy_exception;

  *retval = 0;

#ifdef WITH_RMI

  if(!connect_loaded) {
    sidl_rmi_ConnectRegistry_registerConnect("gov.cca.ports.ParameterPort", (
      void*)gov_cca_ports_ParameterPort__IHConnect, &proxy_exception);
    SIDL_CHECK(proxy_exception);
    connect_loaded = 1;
  }

#endif /*WITH_RMI*/

  if (_base) {
    *retval = (ptrdiff_t)(
      *_base->d_epv->f__cast)(
      _base->d_object,
      "gov.cca.ports.ParameterPort", &proxy_exception);
  } else {
    *retval = 0;
    proxy_exception = 0;
  }
#ifdef WITH_RMI
  EXIT:
#endif /*WITH_RMI*/
  *exception = (ptrdiff_t)proxy_exception;
}

/*
 * Cast method for interface and class type conversions.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__cast2_m,GOV_CCA_PORTS_PARAMETERPORT__CAST2_M,gov_cca_ports_ParameterPort__cast2_m)
(
  int64_t *self,
  SIDL_F90_String name
  SIDL_F90_STR_NEAR_LEN_DECL(name),
  int64_t *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(name)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_name = NULL;
  void* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_name =
    sidl_copy_fortran_str(SIDL_F90_STR(name),(ptrdiff_t)
      SIDL_F90_STR_LEN(name));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__cast))(
      _proxy_self->d_object,
      _proxy_name,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_name);
}


/*
 * Select and execute a method by name
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__exec_m,GOV_CCA_PORTS_PARAMETERPORT__EXEC_M,gov_cca_ports_ParameterPort__exec_m)
(
  int64_t *self,
  SIDL_F90_String methodName
  SIDL_F90_STR_NEAR_LEN_DECL(methodName),
  int64_t *inArgs,
  int64_t *outArgs,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(methodName)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_methodName = NULL;
  struct sidl_rmi_Call__object* _proxy_inArgs = NULL;
  struct sidl_rmi_Return__object* _proxy_outArgs = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_methodName =
    sidl_copy_fortran_str(SIDL_F90_STR(methodName),(ptrdiff_t)
      SIDL_F90_STR_LEN(methodName));
  _proxy_inArgs =
    (struct sidl_rmi_Call__object*)
    (ptrdiff_t)(*inArgs);
  _proxy_outArgs =
    (struct sidl_rmi_Return__object*)
    (ptrdiff_t)(*outArgs);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__exec))(
    _proxy_self->d_object,
    _proxy_methodName,
    _proxy_inArgs,
    _proxy_outArgs,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_methodName);
}


/*
 * Get the URL of the Implementation of this object (for RMI)
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__geturl_m,GOV_CCA_PORTS_PARAMETERPORT__GETURL_M,gov_cca_ports_ParameterPort__getURL_m)
(
  int64_t *self,
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__getURL))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
}


/*
 * TRUE if this object is remote, false if local
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__isremote_m,GOV_CCA_PORTS_PARAMETERPORT__ISREMOTE_M,gov_cca_ports_ParameterPort__isRemote_m)
(
  int64_t *self,
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__isRemote))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}


/*
 * TRUE if this object is remote, false if local
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__islocal_m,GOV_CCA_PORTS_PARAMETERPORT__ISLOCAL_M,gov_cca_ports_ParameterPort__isLocal_m)
(
  int64_t *self,
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    !(*(_epv->f__isRemote))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}


/*
 * Method to enable/disable method hooks invocation.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__set_hooks_m,GOV_CCA_PORTS_PARAMETERPORT__SET_HOOKS_M,gov_cca_ports_ParameterPort__set_hooks_m)
(
  int64_t *self,
  SIDL_F90_Bool *enable,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  sidl_bool _proxy_enable;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_enable = ((*enable == SIDL_F90_TRUE) ? TRUE : FALSE);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__set_hooks))(
    _proxy_self->d_object,
    _proxy_enable,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}


/*
 * Method to enable/disable interface contract enforcement.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__set_contracts_m,GOV_CCA_PORTS_PARAMETERPORT__SET_CONTRACTS_M,gov_cca_ports_ParameterPort__set_contracts_m)
(
  int64_t *self,
  SIDL_F90_Bool *enable,
  SIDL_F90_String enfFilename
  SIDL_F90_STR_NEAR_LEN_DECL(enfFilename),
  SIDL_F90_Bool *resetCounters,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(enfFilename)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  sidl_bool _proxy_enable;
  char* _proxy_enfFilename = NULL;
  sidl_bool _proxy_resetCounters;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_enable = ((*enable == SIDL_F90_TRUE) ? TRUE : FALSE);
  _proxy_enfFilename =
    sidl_copy_fortran_str(SIDL_F90_STR(enfFilename),(ptrdiff_t)
      SIDL_F90_STR_LEN(enfFilename));
  _proxy_resetCounters = ((*resetCounters == SIDL_F90_TRUE) ? TRUE : FALSE);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__set_contracts))(
    _proxy_self->d_object,
    _proxy_enable,
    _proxy_enfFilename,
    _proxy_resetCounters,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_enfFilename);
}


/*
 * Method to dump contract enforcement statistics.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__dump_stats_m,GOV_CCA_PORTS_PARAMETERPORT__DUMP_STATS_M,gov_cca_ports_ParameterPort__dump_stats_m)
(
  int64_t *self,
  SIDL_F90_String filename
  SIDL_F90_STR_NEAR_LEN_DECL(filename),
  SIDL_F90_String prefix
  SIDL_F90_STR_NEAR_LEN_DECL(prefix),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(filename)
  SIDL_F90_STR_FAR_LEN_DECL(prefix)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_filename = NULL;
  char* _proxy_prefix = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_filename =
    sidl_copy_fortran_str(SIDL_F90_STR(filename),(ptrdiff_t)
      SIDL_F90_STR_LEN(filename));
  _proxy_prefix =
    sidl_copy_fortran_str(SIDL_F90_STR(prefix),(ptrdiff_t)
      SIDL_F90_STR_LEN(prefix));
  _epv = _proxy_self->d_epv;
  (*(_epv->f__dump_stats))(
    _proxy_self->d_object,
    _proxy_filename,
    _proxy_prefix,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_filename);
  free((void *)_proxy_prefix);
}

/*
 *  Fetch configuration title. 
 * @return Description of data set.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readtitle_m,GOV_CCA_PORTS_PARAMETERPORT_READTITLE_M,gov_cca_ports_ParameterPort_readTitle_m)
(
  int64_t *self,
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readTitle))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
}

/*
 *  Fetch the names of groups. Each page in a tabbed dialog
 * goes with a group, for example. Group names should be
 * a simple word without whitespace.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readgroupnames_m,GOV_CCA_PORTS_PARAMETERPORT_READGROUPNAMES_M,gov_cca_ports_ParameterPort_readGroupNames_m)
(
  int64_t *self,
  struct sidl_fortran_array *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  struct sidl_string__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readGroupNames))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    retval->d_ior = (ptrdiff_t)_proxy_retval;
  }
}

/*
 *  Fetch UI-appropriate name for group.
 * Group name and group title may be the same, if simple.
 * Group title can be complex if desired.
 * @throws gov.cca.CCAException if groupName is unknown.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readgrouptitle_m,GOV_CCA_PORTS_PARAMETERPORT_READGROUPTITLE_M,gov_cca_ports_ParameterPort_readGroupTitle_m)
(
  int64_t *self,
  SIDL_F90_String groupName
  SIDL_F90_STR_NEAR_LEN_DECL(groupName),
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(groupName)
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_groupName = NULL;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_groupName =
    sidl_copy_fortran_str(SIDL_F90_STR(groupName),(ptrdiff_t)
      SIDL_F90_STR_LEN(groupName));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readGroupTitle))(
      _proxy_self->d_object,
      _proxy_groupName,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
  free((void *)_proxy_groupName);
}

/*
 *  Fetch data item keys associated with groupName.
 * Array order will be the same as the order in which
 * the additions were made in the ParameterPortFactory interface.
 * @throws gov.cca.CCAException if groupName is unknown.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readgroupkeys_m,GOV_CCA_PORTS_PARAMETERPORT_READGROUPKEYS_M,gov_cca_ports_ParameterPort_readGroupKeys_m)
(
  int64_t *self,
  SIDL_F90_String groupName
  SIDL_F90_STR_NEAR_LEN_DECL(groupName),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(groupName)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_groupName = NULL;
  struct sidl_string__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_groupName =
    sidl_copy_fortran_str(SIDL_F90_STR(groupName),(ptrdiff_t)
      SIDL_F90_STR_LEN(groupName));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readGroupKeys))(
      _proxy_self->d_object,
      _proxy_groupName,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    retval->d_ior = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_groupName);
}

/*
 *  Fetch the help string for key.
 * @throws gov.cca.CCAException if key is unknown.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readhelp_m,GOV_CCA_PORTS_PARAMETERPORT_READHELP_M,gov_cca_ports_ParameterPort_readHelp_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readHelp))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the prompt string for key.
 * @throws gov.cca.CCAException if key is unknown.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readprompt_m,GOV_CCA_PORTS_PARAMETERPORT_READPROMPT_M,gov_cca_ports_ParameterPort_readPrompt_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readPrompt))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
  free((void *)_proxy_key);
}

/*
 *  By default, bounds are defined except for complex numbers
 * booleans, and strings. On array types, bounds apply
 * element-wise. i.e.  low <= arr[i] <= high for all i.
 * @return true if simple bounds are defined for a key.
 * @throws gov.cca.CCAException if key is unknown.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_hasbounds_m,GOV_CCA_PORTS_PARAMETERPORT_HASBOUNDS_M,gov_cca_ports_ParameterPort_hasBounds_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  SIDL_F90_Bool *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_hasBounds))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
  free((void *)_proxy_key);
}

/*
 *  By default, lists of choices are not defined for scalars or arrays.
 * Choices are applied element-wise for array types.
 * I.e. (arr[i] IN choice-set) == true  for all i.
 * @return true if choice list is defined for a key.
 * @throws gov.cca.CCAException if key is unknown.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_haschoices_m,GOV_CCA_PORTS_PARAMETERPORT_HASCHOICES_M,gov_cca_ports_ParameterPort_hasChoices_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  SIDL_F90_Bool *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_hasChoices))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for boolean-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultboolean_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTBOOLEAN_M,gov_cca_ports_ParameterPort_readDefaultBoolean_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  SIDL_F90_Bool *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultBoolean))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for string-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultstring_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTSTRING_M,gov_cca_ports_ParameterPort_readDefaultString_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultString))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for integer-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultint_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTINT_M,gov_cca_ports_ParameterPort_readDefaultInt_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  int32_t *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  *retval = 
    (*(_epv->f_readDefaultInt))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for long-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultlong_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTLONG_M,gov_cca_ports_ParameterPort_readDefaultLong_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  int64_t *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  *retval = 
    (*(_epv->f_readDefaultLong))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for float-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultfloat_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTFLOAT_M,gov_cca_ports_ParameterPort_readDefaultFloat_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  float *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  *retval = 
    (*(_epv->f_readDefaultFloat))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for double-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultdouble_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTDOUBLE_M,gov_cca_ports_ParameterPort_readDefaultDouble_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  double *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  *retval = 
    (*(_epv->f_readDefaultDouble))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for fcomplex-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultfcomplex_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTFCOMPLEX_M,gov_cca_ports_ParameterPort_readDefaultFcomplex_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fcomplex *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  *retval = 
    (*(_epv->f_readDefaultFcomplex))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for dcomplex-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultdcomplex_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTDCOMPLEX_M,gov_cca_ports_ParameterPort_readDefaultDcomplex_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_dcomplex *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  *retval = 
    (*(_epv->f_readDefaultDcomplex))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for string-array-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultstringarray_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTSTRINGARRAY_M,gov_cca_ports_ParameterPort_readDefaultStringArray_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_string__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultStringArray))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    retval->d_ior = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for boolean-array-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultbooleanarray_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTBOOLEANARRAY_M,gov_cca_ports_ParameterPort_readDefaultBooleanArray_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_bool__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultBooleanArray))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    retval->d_ior = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for integer-array-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultintarray_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTINTARRAY_M,gov_cca_ports_ParameterPort_readDefaultIntArray_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_int__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultIntArray))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_int__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_int__array* _alt_retval =
        sidl_int__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_int__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for long-array-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultlongarray_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTLONGARRAY_M,gov_cca_ports_ParameterPort_readDefaultLongArray_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_long__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultLongArray))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_long__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_long__array* _alt_retval =
        sidl_long__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_long__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for float-array-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultfloatarray_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTFLOATARRAY_M,gov_cca_ports_ParameterPort_readDefaultFloatArray_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_float__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultFloatArray))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_float__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_float__array* _alt_retval =
        sidl_float__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_float__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for double-array-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultdoublearray_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTDOUBLEARRAY_M,gov_cca_ports_ParameterPort_readDefaultDoubleArray_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_double__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultDoubleArray))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_double__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_double__array* _alt_retval =
        sidl_double__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_double__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for fcomplex-array-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultfcomplexarray_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTFCOMPLEXARRAY_M,gov_cca_ports_ParameterPort_readDefaultFcomplexArray_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_fcomplex__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultFcomplexArray))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_fcomplex__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_fcomplex__array* _alt_retval =
        sidl_fcomplex__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_fcomplex__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for dcomplex-array-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readdefaultdcomplexarray_m,GOV_CCA_PORTS_PARAMETERPORT_READDEFAULTDCOMPLEXARRAY_M,gov_cca_ports_ParameterPort_readDefaultDcomplexArray_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_dcomplex__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readDefaultDcomplexArray))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_dcomplex__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_dcomplex__array* _alt_retval =
        sidl_dcomplex__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_dcomplex__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the bounds for integer-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readboundsint_m,GOV_CCA_PORTS_PARAMETERPORT_READBOUNDSINT_M,gov_cca_ports_ParameterPort_readBoundsInt_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  int32_t *low,
  int32_t *high,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  (*(_epv->f_readBoundsInt))(
    _proxy_self->d_object,
    _proxy_key,
    low,
    high,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the bounds for long-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readboundslong_m,GOV_CCA_PORTS_PARAMETERPORT_READBOUNDSLONG_M,gov_cca_ports_ParameterPort_readBoundsLong_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  int64_t *low,
  int64_t *high,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  (*(_epv->f_readBoundsLong))(
    _proxy_self->d_object,
    _proxy_key,
    low,
    high,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the bounds for float-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readboundsfloat_m,GOV_CCA_PORTS_PARAMETERPORT_READBOUNDSFLOAT_M,gov_cca_ports_ParameterPort_readBoundsFloat_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  float *low,
  float *high,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  (*(_epv->f_readBoundsFloat))(
    _proxy_self->d_object,
    _proxy_key,
    low,
    high,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the bounds for double-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readboundsdouble_m,GOV_CCA_PORTS_PARAMETERPORT_READBOUNDSDOUBLE_M,gov_cca_ports_ParameterPort_readBoundsDouble_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  double *low,
  double *high,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  (*(_epv->f_readBoundsDouble))(
    _proxy_self->d_object,
    _proxy_key,
    low,
    high,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the choices for string-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readchoicesstring_m,GOV_CCA_PORTS_PARAMETERPORT_READCHOICESSTRING_M,gov_cca_ports_ParameterPort_readChoicesString_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_string__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readChoicesString))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    retval->d_ior = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the choices for integer-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readchoicesint_m,GOV_CCA_PORTS_PARAMETERPORT_READCHOICESINT_M,gov_cca_ports_ParameterPort_readChoicesInt_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_int__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readChoicesInt))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_int__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_int__array* _alt_retval =
        sidl_int__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_int__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the choices for long-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readchoiceslong_m,GOV_CCA_PORTS_PARAMETERPORT_READCHOICESLONG_M,gov_cca_ports_ParameterPort_readChoicesLong_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_long__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readChoicesLong))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_long__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_long__array* _alt_retval =
        sidl_long__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_long__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the choices for float-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readchoicesfloat_m,GOV_CCA_PORTS_PARAMETERPORT_READCHOICESFLOAT_M,gov_cca_ports_ParameterPort_readChoicesFloat_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_float__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readChoicesFloat))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_float__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_float__array* _alt_retval =
        sidl_float__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_float__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the default for double-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readchoicesdouble_m,GOV_CCA_PORTS_PARAMETERPORT_READCHOICESDOUBLE_M,gov_cca_ports_ParameterPort_readChoicesDouble_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_double__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readChoicesDouble))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_double__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_double__array* _alt_retval =
        sidl_double__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_double__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the choices for fcomplex-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readchoicesfcomplex_m,GOV_CCA_PORTS_PARAMETERPORT_READCHOICESFCOMPLEX_M,gov_cca_ports_ParameterPort_readChoicesFcomplex_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_fcomplex__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readChoicesFcomplex))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_fcomplex__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_fcomplex__array* _alt_retval =
        sidl_fcomplex__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_fcomplex__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Fetch the choices for dcomplex-typed key. 
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readchoicesdcomplex_m,GOV_CCA_PORTS_PARAMETERPORT_READCHOICESDCOMPLEX_M,gov_cca_ports_ParameterPort_readChoicesDcomplex_m)
(
  int64_t *self,
  SIDL_F90_String key
  SIDL_F90_STR_NEAR_LEN_DECL(key),
  struct sidl_fortran_array *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(key)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_key = NULL;
  struct sidl_dcomplex__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_key =
    sidl_copy_fortran_str(SIDL_F90_STR(key),(ptrdiff_t)
      SIDL_F90_STR_LEN(key));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readChoicesDcomplex))(
      _proxy_self->d_object,
      _proxy_key,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    if (sidl_dcomplex__array_convert2f90(_proxy_retval, 1, retval)) {
      /* Copy to contiguous column-order */
      struct sidl_dcomplex__array* _alt_retval =
        sidl_dcomplex__array_ensure(_proxy_retval, 1,
          sidl_column_major_order);
      sidl__array_deleteRef((struct sidl__array *)_proxy_retval);
      if (sidl_dcomplex__array_convert2f90(_alt_retval, 1, retval)) {
        /* We're S.O.L. */
        fprintf(stderr, "convert2f90 failed: %p %d\n", (void*)_alt_retval, 1);
        exit(1); /*NOTREACHED*/
      }
    }
  }
  free((void *)_proxy_key);
}

/*
 *  Return a TypeMap of runtime configuration parameters. 
 * It is recommended that the map returned be a clone/copy of the
 * a privately held map, not a shared object reference.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readconfigurationmap_m,GOV_CCA_PORTS_PARAMETERPORT_READCONFIGURATIONMAP_M,gov_cca_ports_ParameterPort_readConfigurationMap_m)
(
  int64_t *self,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  struct gov_cca_TypeMap__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readConfigurationMap))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 *  Copy the parameter values given in map into the
 * internal map, for those parameters which
 * are already defined by the internal map.
 * The outsider does not get to cause arbitrary
 * keys to be copied into the internal map.
 * @throws gov.cca.CCAException if TypeMap operations fail.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_writeconfigurationmap_m,GOV_CCA_PORTS_PARAMETERPORT_WRITECONFIGURATIONMAP_M,gov_cca_ports_ParameterPort_writeConfigurationMap_m)
(
  int64_t *self,
  int64_t *map,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  struct gov_cca_TypeMap__object* _proxy_map = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_map =
    (struct gov_cca_TypeMap__object*)
    (ptrdiff_t)(*map);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_writeConfigurationMap))(
    _proxy_self->d_object,
    _proxy_map,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 *  Fetch the list of keys in the TypeMap that are
 * for public configuration purposes. Other values found in
 * the TypeMap must not be changed.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_readconfigurationkeys_m,GOV_CCA_PORTS_PARAMETERPORT_READCONFIGURATIONKEYS_M,gov_cca_ports_ParameterPort_readConfigurationKeys_m)
(
  int64_t *self,
  struct sidl_fortran_array *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  struct sidl_string__array* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_readConfigurationKeys))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    retval->d_ior = (ptrdiff_t)_proxy_retval;
  }
}

/*
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>sidl</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_addref_m,GOV_CCA_PORTS_PARAMETERPORT_ADDREF_M,gov_cca_ports_ParameterPort_addRef_m)
(
  int64_t *self,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_addRef))(
    _proxy_self->d_object,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>sidl</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_deleteref_m,GOV_CCA_PORTS_PARAMETERPORT_DELETEREF_M,gov_cca_ports_ParameterPort_deleteRef_m)
(
  int64_t *self,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_deleteRef))(
    _proxy_self->d_object,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_issame_m,GOV_CCA_PORTS_PARAMETERPORT_ISSAME_M,gov_cca_ports_ParameterPort_isSame_m)
(
  int64_t *self,
  int64_t *iobj,
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_iobj = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_iobj =
    (struct sidl_BaseInterface__object*)
    (ptrdiff_t)(*iobj);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_isSame))(
      _proxy_self->d_object,
      _proxy_iobj,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}

/*
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_istype_m,GOV_CCA_PORTS_PARAMETERPORT_ISTYPE_M,gov_cca_ports_ParameterPort_isType_m)
(
  int64_t *self,
  SIDL_F90_String name
  SIDL_F90_STR_NEAR_LEN_DECL(name),
  SIDL_F90_Bool *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(name)
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  char* _proxy_name = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _proxy_name =
    sidl_copy_fortran_str(SIDL_F90_STR(name),(ptrdiff_t)
      SIDL_F90_STR_LEN(name));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_isType))(
      _proxy_self->d_object,
      _proxy_name,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
  free((void *)_proxy_name);
}

/*
 * Return the meta-data about the class implementing this interface.
 */

void
SIDLFortran90Symbol(gov_cca_ports_parameterport_getclassinfo_m,GOV_CCA_PORTS_PARAMETERPORT_GETCLASSINFO_M,gov_cca_ports_ParameterPort_getClassInfo_m)
(
  int64_t *self,
  int64_t *retval,
  int64_t *exception
)
{
  struct gov_cca_ports_ParameterPort__epv *_epv = NULL;
  struct gov_cca_ports_ParameterPort__object* _proxy_self = NULL;
  struct sidl_ClassInfo__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct gov_cca_ports_ParameterPort__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getClassInfo))(
      _proxy_self->d_object,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_createcol_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_CREATECOL_M,
                  gov_cca_ports_ParameterPort__array_createCol_m)
  (int32_t *dimen,
   int32_t lower[],
   int32_t upper[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_createCol(*dimen, lower, upper);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_createrow_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_CREATEROW_M,
                  gov_cca_ports_ParameterPort__array_createRow_m)
  (int32_t *dimen,
   int32_t lower[],
   int32_t upper[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_createRow(*dimen, lower, upper);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_create1d_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_CREATE1D_M,
                  gov_cca_ports_ParameterPort__array_create1d_m)
  (int32_t *len, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create1d(*len);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_create2dcol_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_CREATE2DCOL_M,
                  gov_cca_ports_ParameterPort__array_create2dCol_m)
  (int32_t *m, int32_t *n, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create2dCol(*m, *n);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_create2drow_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_CREATE2DROW_M,
                  gov_cca_ports_ParameterPort__array_create2dRow_m)
  (int32_t *m, int32_t *n, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create2dRow(*m, *n);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_addref_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_ADDREF_M,
                  gov_cca_ports_ParameterPort__array_addRef_m)
  (int64_t *array)
{
  sidl_interface__array_addRef((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_deleteref_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_DELETEREF_M,
                  gov_cca_ports_ParameterPort__array_deleteRef_m)
  (int64_t *array)
{
  sidl_interface__array_deleteRef((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_get1_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_GET1_M,
                  gov_cca_ports_ParameterPort__array_get1_m)
  (int64_t *array, 
   int32_t *i1, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get1((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_get2_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_GET2_M,
                  gov_cca_ports_ParameterPort__array_get2_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get2((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_get3_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_GET3_M,
                  gov_cca_ports_ParameterPort__array_get3_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get3((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_get4_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_GET4_M,
                  gov_cca_ports_ParameterPort__array_get4_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get4((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_get5_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_GET5_M,
                  gov_cca_ports_ParameterPort__array_get5_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get5((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_get6_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_GET6_M,
                  gov_cca_ports_ParameterPort__array_get6_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int32_t *i6, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get6((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5, *i6);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_get7_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_GET7_M,
                  gov_cca_ports_ParameterPort__array_get7_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int32_t *i6, 
   int32_t *i7, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get7((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5, *i6, *i7);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_get_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_GET_M,
                  gov_cca_ports_ParameterPort__array_get_m)
  (int64_t *array,
   int32_t indices[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get((const struct sidl_interface__array *)(
      ptrdiff_t)*array, indices);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_set1_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SET1_M,
                  gov_cca_ports_ParameterPort__array_set1_m)
  (int64_t *array,
   int32_t *i1,
   int64_t *value)
{
  sidl_interface__array_set1((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_set2_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SET2_M,
                  gov_cca_ports_ParameterPort__array_set2_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int64_t *value)
{
  sidl_interface__array_set2((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_set3_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SET3_M,
                  gov_cca_ports_ParameterPort__array_set3_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int64_t *value)
{
  sidl_interface__array_set3((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_set4_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SET4_M,
                  gov_cca_ports_ParameterPort__array_set4_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int64_t *value)
{
  sidl_interface__array_set4((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_set5_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SET5_M,
                  gov_cca_ports_ParameterPort__array_set5_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int64_t *value)
{
  sidl_interface__array_set5((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_set6_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SET6_M,
                  gov_cca_ports_ParameterPort__array_set6_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int32_t *i6,
   int64_t *value)
{
  sidl_interface__array_set6((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, *i6, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_set7_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SET7_M,
                  gov_cca_ports_ParameterPort__array_set7_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int32_t *i6,
   int32_t *i7,
   int64_t *value)
{
  sidl_interface__array_set7((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, *i6, *i7, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_set_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SET_M,
                  gov_cca_ports_ParameterPort__array_set_m)
  (int64_t *array,
  int32_t indices[],
  int64_t *value)
{
  sidl_interface__array_set((struct sidl_interface__array *)(ptrdiff_t)*array, 
    indices, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_dimen_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_DIMEN_M,
                  gov_cca_ports_ParameterPort__array_dimen_m)
  (int64_t *array, int32_t *result)
{
  *result =
    sidl_interface__array_dimen((struct sidl_interface__array *)(
      ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_lower_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_LOWER_M,
                  gov_cca_ports_ParameterPort__array_lower_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_lower((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_upper_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_UPPER_M,
                  gov_cca_ports_ParameterPort__array_upper_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_upper((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_length_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_LENGTH_M,
                  gov_cca_ports_ParameterPort__array_length_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_length((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_stride_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_STRIDE_M,
                  gov_cca_ports_ParameterPort__array_stride_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_stride((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_iscolumnorder_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_ISCOLUMNORDER_M,
                  gov_cca_ports_ParameterPort__array_isColumnOrder_m)
  (int64_t *array,
   SIDL_F90_Bool *result)
{
  *result = sidl_interface__array_isColumnOrder((struct sidl_interface__array 
    *)(ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_isroworder_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_ISROWORDER_M,
                  gov_cca_ports_ParameterPort__array_isRowOrder_m)
  (int64_t *array,
   SIDL_F90_Bool *result)
{
  *result = sidl_interface__array_isRowOrder((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_copy_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_COPY_M,
                  gov_cca_ports_ParameterPort__array_copy_m)
  (int64_t *src,
   int64_t *dest)
{
  sidl_interface__array_copy((const struct sidl_interface__array *)(
    ptrdiff_t)*src,
                             (struct sidl_interface__array *)(ptrdiff_t)*dest);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_smartcopy_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SMARTCOPY_M,
                  gov_cca_ports_ParameterPort__array_smartCopy_m)
  (int64_t *src)
{
  sidl_interface__array_smartCopy((struct sidl_interface__array *)(
    ptrdiff_t)*src);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_slice_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_SLICE_M,
                  gov_cca_ports_ParameterPort__array_slice_m)
  (int64_t *src,
   int32_t *dimen,
   int32_t numElem[],
   int32_t srcStart[],
   int32_t srcStride[],
   int32_t newStart[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_slice((struct sidl_interface__array *)(ptrdiff_t)*src,
      *dimen, numElem, srcStart, srcStride, newStart);
}

void
SIDLFortran90Symbol(gov_cca_ports_parameterport__array_ensure_m,
                  GOV_CCA_PORTS_PARAMETERPORT__ARRAY_ENSURE_M,
                  gov_cca_ports_ParameterPort__array_ensure_m)
  (int64_t *src,
   int32_t *dimen,
   int     *ordering,
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_ensure((struct sidl_interface__array *)(
      ptrdiff_t)*src,
    *dimen, *ordering);
}

#ifdef WITH_RMI

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#ifndef included_sidl_BaseClass_h
#include "sidl_BaseClass.h"
#endif
#ifndef included_sidl_ClassInfo_h
#include "sidl_ClassInfo.h"
#endif
#ifndef included_sidl_rmi_ProtocolFactory_h
#include "sidl_rmi_ProtocolFactory.h"
#endif
#ifndef included_sidl_rmi_InstanceRegistry_h
#include "sidl_rmi_InstanceRegistry.h"
#endif
#ifndef included_sidl_rmi_InstanceHandle_h
#include "sidl_rmi_InstanceHandle.h"
#endif
#ifndef included_sidl_rmi_Invocation_h
#include "sidl_rmi_Invocation.h"
#endif
#ifndef included_sidl_rmi_Response_h
#include "sidl_rmi_Response.h"
#endif
#ifndef included_sidl_rmi_ServerRegistry_h
#include "sidl_rmi_ServerRegistry.h"
#endif
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidl_io_Serializable_h
#include "sidl_io_Serializable.h"
#endif
#ifndef included_sidl_MemAllocException_h
#include "sidl_MemAllocException.h"
#endif
#ifndef included_sidl_NotImplementedException_h
#include "sidl_NotImplementedException.h"
#endif
#include "sidl_Exception.h"

#ifndef NULL
#define NULL 0
#endif

#include "sidl_thread.h"
#ifdef HAVE_PTHREAD
static struct sidl_recursive_mutex_t gov_cca_ports__ParameterPort__mutex= SIDL_RECURSIVE_MUTEX_INITIALIZER;
#define LOCK_STATIC_GLOBALS sidl_recursive_mutex_lock( &gov_cca_ports__ParameterPort__mutex )
#define UNLOCK_STATIC_GLOBALS sidl_recursive_mutex_unlock( &gov_cca_ports__ParameterPort__mutex )
/* #define HAVE_LOCKED_STATIC_GLOBALS (sidl_recursive_mutex_trylock( &gov_cca_ports__ParameterPort__mutex )==EDEADLOCK) */
#else
#define LOCK_STATIC_GLOBALS
#define UNLOCK_STATIC_GLOBALS
/* #define HAVE_LOCKED_STATIC_GLOBALS (1) */
#endif

/* Static variables to hold version of IOR */
static const int32_t s_IOR_MAJOR_VERSION = 2;
static const int32_t s_IOR_MINOR_VERSION = 0;

/* Static variables for managing EPV initialization. */
static int s_remote_initialized = 0;

static struct gov_cca_ports__ParameterPort__epv 
  s_rem_epv__gov_cca_ports__parameterport;

static struct gov_cca_Port__epv s_rem_epv__gov_cca_port;

static struct gov_cca_ports_BasicParameterPort__epv 
  s_rem_epv__gov_cca_ports_basicparameterport;

static struct gov_cca_ports_ParameterPort__epv 
  s_rem_epv__gov_cca_ports_parameterport;

static struct sidl_BaseInterface__epv s_rem_epv__sidl_baseinterface;


/* REMOTE CAST: dynamic type casting for remote objects. */
static void* remote_gov_cca_ports__ParameterPort__cast(
  struct gov_cca_ports__ParameterPort__object* self,
  const char* name, sidl_BaseInterface* _ex)
{
  int cmp;
  void* cast = NULL;
  *_ex = NULL; /* default to no exception */
  cmp = strcmp(name, "gov.cca.ports.ParameterPort");
  if (!cmp) {
    (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
    cast = &((*self).d_gov_cca_ports_parameterport);
    return cast;
  }
  else if (cmp < 0) {
    cmp = strcmp(name, "gov.cca.ports.BasicParameterPort");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = &((*self).d_gov_cca_ports_basicparameterport);
      return cast;
    }
    else if (cmp < 0) {
      cmp = strcmp(name, "gov.cca.Port");
      if (!cmp) {
        (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
        cast = &((*self).d_gov_cca_port);
        return cast;
      }
    }
  }
  else if (cmp > 0) {
    cmp = strcmp(name, "sidl.BaseInterface");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = &((*self).d_sidl_baseinterface);
      return cast;
    }
    else if (cmp < 0) {
      cmp = strcmp(name, "gov.cca.ports._ParameterPort");
      if (!cmp) {
        (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
        cast = ((struct gov_cca_ports__ParameterPort__object*)self);
        return cast;
      }
    }
  }
  if ((*self->d_epv->f_isType)(self,name, _ex)) {
    void* (*func)(struct sidl_rmi_InstanceHandle__object*, struct 
      sidl_BaseInterface__object**) = 
      (void* (*)(struct sidl_rmi_InstanceHandle__object*, struct 
        sidl_BaseInterface__object**)) 
      sidl_rmi_ConnectRegistry_getConnect(name, _ex);SIDL_CHECK(*_ex);
    cast =  (*func)(((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih, _ex);
  }

  return cast;
  EXIT:
  return NULL;
}

/* REMOTE DELETE: call the remote destructor for the object. */
static void remote_gov_cca_ports__ParameterPort__delete(
  struct gov_cca_ports__ParameterPort__object* self,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
  free((void*) self);
}

/* REMOTE GETURL: call the getURL function for the object. */
static char* remote_gov_cca_ports__ParameterPort__getURL(
  struct gov_cca_ports__ParameterPort__object* self, struct 
    sidl_BaseInterface__object* *_ex)
{
  struct sidl_rmi_InstanceHandle__object *conn = ((struct 
    gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
  *_ex = NULL;
  if(conn != NULL) {
    return sidl_rmi_InstanceHandle_getObjectURL(conn, _ex);
  }
  return NULL;
}

/* REMOTE ADDREF: For internal babel use only! Remote addRef. */
static void remote_gov_cca_ports__ParameterPort__raddRef(
  struct gov_cca_ports__ParameterPort__object* self,struct 
    sidl_BaseInterface__object* *_ex)
{
  struct sidl_BaseException__object* netex = NULL;
  /* initialize a new invocation */
  struct sidl_BaseInterface__object* _throwaway = NULL;
  struct sidl_rmi_InstanceHandle__object *_conn = ((struct 
    gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
  sidl_rmi_Response _rsvp = NULL;
  sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
    "addRef", _ex ); SIDL_CHECK(*_ex);
  /* send actual RMI request */
  _rsvp = sidl_rmi_Invocation_invokeMethod(_inv,_ex);SIDL_CHECK(*_ex);
  /* Check for exceptions */
  netex = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);
  if(netex != NULL) {
    *_ex = (struct sidl_BaseInterface__object*)netex;
    return;
  }

  /* cleanup and return */
  EXIT:
  if(_inv) { sidl_rmi_Invocation_deleteRef(_inv,&_throwaway); }
  if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp,&_throwaway); }
  return;
}

/* REMOTE ISREMOTE: returns true if this object is Remote (it is). */
static sidl_bool
remote_gov_cca_ports__ParameterPort__isRemote(
    struct gov_cca_ports__ParameterPort__object* self, 
    struct sidl_BaseInterface__object* *_ex) {
  *_ex = NULL;
  return TRUE;
}

/* REMOTE METHOD STUB:_set_hooks */
static void
remote_gov_cca_ports__ParameterPort__set_hooks(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ sidl_bool enable,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_hooks", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort._set_hooks.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_set_contracts */
static void
remote_gov_cca_ports__ParameterPort__set_contracts(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ sidl_bool enable,
  /* in */ const char* enfFilename,
  /* in */ sidl_bool resetCounters,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_contracts", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packString( _inv, "enfFilename", enfFilename, 
      _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packBool( _inv, "resetCounters", resetCounters, 
      _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort._set_contracts.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_dump_stats */
static void
remote_gov_cca_ports__ParameterPort__dump_stats(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* filename,
  /* in */ const char* prefix,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_dump_stats", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "filename", filename, _ex);SIDL_CHECK(
      *_ex);
    sidl_rmi_Invocation_packString( _inv, "prefix", prefix, _ex);SIDL_CHECK(
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort._dump_stats.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE EXEC: call the exec function for the object. */
static void remote_gov_cca_ports__ParameterPort__exec(
  struct gov_cca_ports__ParameterPort__object* self,const char* methodName,
  sidl_rmi_Call inArgs,
  sidl_rmi_Return outArgs,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
}

/* REMOTE METHOD STUB:readTitle */
static char*
remote_gov_cca_ports__ParameterPort_readTitle(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readTitle", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readTitle.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readGroupNames */
static struct sidl_string__array*
remote_gov_cca_ports__ParameterPort_readGroupNames(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_string__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readGroupNames", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readGroupNames.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackStringArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readGroupTitle */
static char*
remote_gov_cca_ports__ParameterPort_readGroupTitle(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* groupName,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readGroupTitle", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "groupName", groupName, 
      _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readGroupTitle.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readGroupKeys */
static struct sidl_string__array*
remote_gov_cca_ports__ParameterPort_readGroupKeys(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* groupName,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_string__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readGroupKeys", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "groupName", groupName, 
      _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readGroupKeys.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackStringArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readHelp */
static char*
remote_gov_cca_ports__ParameterPort_readHelp(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readHelp", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readHelp.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readPrompt */
static char*
remote_gov_cca_ports__ParameterPort_readPrompt(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readPrompt", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readPrompt.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:hasBounds */
static sidl_bool
remote_gov_cca_ports__ParameterPort_hasBounds(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "hasBounds", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.hasBounds.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:hasChoices */
static sidl_bool
remote_gov_cca_ports__ParameterPort_hasChoices(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "hasChoices", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.hasChoices.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultBoolean */
static sidl_bool
remote_gov_cca_ports__ParameterPort_readDefaultBoolean(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultBoolean", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultBoolean.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultString */
static char*
remote_gov_cca_ports__ParameterPort_readDefaultString(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultString", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultString.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultInt */
static int32_t
remote_gov_cca_ports__ParameterPort_readDefaultInt(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    int32_t _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultInt", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultInt.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackInt( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultLong */
static int64_t
remote_gov_cca_ports__ParameterPort_readDefaultLong(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    int64_t _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultLong", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultLong.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackLong( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultFloat */
static float
remote_gov_cca_ports__ParameterPort_readDefaultFloat(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    float _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultFloat", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultFloat.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackFloat( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultDouble */
static double
remote_gov_cca_ports__ParameterPort_readDefaultDouble(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    double _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultDouble", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultDouble.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackDouble( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultFcomplex */
static struct sidl_fcomplex
remote_gov_cca_ports__ParameterPort_readDefaultFcomplex(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_fcomplex _retval = { 0, 0 };
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultFcomplex", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultFcomplex.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackFcomplex( _rsvp, "_retval", &_retval, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultDcomplex */
static struct sidl_dcomplex
remote_gov_cca_ports__ParameterPort_readDefaultDcomplex(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_dcomplex _retval = { 0, 0 };
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultDcomplex", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultDcomplex.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackDcomplex( _rsvp, "_retval", &_retval, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultStringArray */
static struct sidl_string__array*
remote_gov_cca_ports__ParameterPort_readDefaultStringArray(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_string__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultStringArray", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultStringArray.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackStringArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultBooleanArray */
static struct sidl_bool__array*
remote_gov_cca_ports__ParameterPort_readDefaultBooleanArray(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_bool__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultBooleanArray", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultBooleanArray.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBoolArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultIntArray */
static struct sidl_int__array*
remote_gov_cca_ports__ParameterPort_readDefaultIntArray(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_int__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultIntArray", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultIntArray.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackIntArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultLongArray */
static struct sidl_long__array*
remote_gov_cca_ports__ParameterPort_readDefaultLongArray(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_long__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultLongArray", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultLongArray.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackLongArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultFloatArray */
static struct sidl_float__array*
remote_gov_cca_ports__ParameterPort_readDefaultFloatArray(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_float__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultFloatArray", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultFloatArray.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackFloatArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultDoubleArray */
static struct sidl_double__array*
remote_gov_cca_ports__ParameterPort_readDefaultDoubleArray(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_double__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultDoubleArray", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultDoubleArray.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackDoubleArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultFcomplexArray */
static struct sidl_fcomplex__array*
remote_gov_cca_ports__ParameterPort_readDefaultFcomplexArray(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_fcomplex__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultFcomplexArray", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultFcomplexArray.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackFcomplexArray( _rsvp, "_retval", &_retval,0,0,FALSE,
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readDefaultDcomplexArray */
static struct sidl_dcomplex__array*
remote_gov_cca_ports__ParameterPort_readDefaultDcomplexArray(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_dcomplex__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readDefaultDcomplexArray", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readDefaultDcomplexArray.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackDcomplexArray( _rsvp, "_retval", &_retval,0,0,FALSE,
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readBoundsInt */
static void
remote_gov_cca_ports__ParameterPort_readBoundsInt(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ int32_t* low,
  /* out */ int32_t* high,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readBoundsInt", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readBoundsInt.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */
    sidl_rmi_Response_unpackInt( _rsvp, "low", low, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Response_unpackInt( _rsvp, "high", high, _ex);SIDL_CHECK(*_ex);

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:readBoundsLong */
static void
remote_gov_cca_ports__ParameterPort_readBoundsLong(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ int64_t* low,
  /* out */ int64_t* high,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readBoundsLong", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readBoundsLong.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */
    sidl_rmi_Response_unpackLong( _rsvp, "low", low, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Response_unpackLong( _rsvp, "high", high, _ex);SIDL_CHECK(*_ex);

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:readBoundsFloat */
static void
remote_gov_cca_ports__ParameterPort_readBoundsFloat(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ float* low,
  /* out */ float* high,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readBoundsFloat", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readBoundsFloat.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */
    sidl_rmi_Response_unpackFloat( _rsvp, "low", low, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Response_unpackFloat( _rsvp, "high", high, _ex);SIDL_CHECK(*_ex);

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:readBoundsDouble */
static void
remote_gov_cca_ports__ParameterPort_readBoundsDouble(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ double* low,
  /* out */ double* high,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readBoundsDouble", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readBoundsDouble.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */
    sidl_rmi_Response_unpackDouble( _rsvp, "low", low, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Response_unpackDouble( _rsvp, "high", high, _ex);SIDL_CHECK(*_ex);

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:readChoicesString */
static struct sidl_string__array*
remote_gov_cca_ports__ParameterPort_readChoicesString(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_string__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readChoicesString", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readChoicesString.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackStringArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readChoicesInt */
static struct sidl_int__array*
remote_gov_cca_ports__ParameterPort_readChoicesInt(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_int__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readChoicesInt", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readChoicesInt.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackIntArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readChoicesLong */
static struct sidl_long__array*
remote_gov_cca_ports__ParameterPort_readChoicesLong(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_long__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readChoicesLong", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readChoicesLong.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackLongArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readChoicesFloat */
static struct sidl_float__array*
remote_gov_cca_ports__ParameterPort_readChoicesFloat(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_float__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readChoicesFloat", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readChoicesFloat.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackFloatArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readChoicesDouble */
static struct sidl_double__array*
remote_gov_cca_ports__ParameterPort_readChoicesDouble(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_double__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readChoicesDouble", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readChoicesDouble.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackDoubleArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readChoicesFcomplex */
static struct sidl_fcomplex__array*
remote_gov_cca_ports__ParameterPort_readChoicesFcomplex(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_fcomplex__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readChoicesFcomplex", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readChoicesFcomplex.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackFcomplexArray( _rsvp, "_retval", &_retval,0,0,FALSE,
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readChoicesDcomplex */
static struct sidl_dcomplex__array*
remote_gov_cca_ports__ParameterPort_readChoicesDcomplex(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* key,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_dcomplex__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readChoicesDcomplex", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "key", key, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readChoicesDcomplex.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackDcomplexArray( _rsvp, "_retval", &_retval,0,0,FALSE,
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:readConfigurationMap */
static struct gov_cca_TypeMap__object*
remote_gov_cca_ports__ParameterPort_readConfigurationMap(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_TypeMap__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readConfigurationMap", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readConfigurationMap.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_TypeMap__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:writeConfigurationMap */
static void
remote_gov_cca_ports__ParameterPort_writeConfigurationMap(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ struct gov_cca_TypeMap__object* map,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "writeConfigurationMap", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(map){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)map, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "map", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "map", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.writeConfigurationMap.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:readConfigurationKeys */
static struct sidl_string__array*
remote_gov_cca_ports__ParameterPort_readConfigurationKeys(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_string__array* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "readConfigurationKeys", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.readConfigurationKeys.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackStringArray( _rsvp, "_retval", &_retval,0,0,FALSE, 
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:addRef */
static void
remote_gov_cca_ports__ParameterPort_addRef(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct gov_cca_ports__ParameterPort__remote* r_obj = (struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount++;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: addRef %p new count %d (type %s)\n",
      r_obj, r_obj->d_refcount, 
      "gov.cca.ports._ParameterPort Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:deleteRef */
static void
remote_gov_cca_ports__ParameterPort_deleteRef(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct gov_cca_ports__ParameterPort__remote* r_obj = (struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount--;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: deleteRef %p new count %d (type %s)\n",r_obj, r_obj->d_refcount, "gov.cca.ports._ParameterPort Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    if(r_obj->d_refcount == 0) {
      sidl_rmi_InstanceHandle_deleteRef(r_obj->d_ih, _ex);
      free(r_obj);
      free(self);
    }
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:isSame */
static sidl_bool
remote_gov_cca_ports__ParameterPort_isSame(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ struct sidl_BaseInterface__object* iobj,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isSame", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(iobj){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)iobj, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "iobj", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "iobj", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.isSame.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:isType */
static sidl_bool
remote_gov_cca_ports__ParameterPort_isType(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* in */ const char* name,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isType", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "name", name, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.isType.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getClassInfo */
static struct sidl_ClassInfo__object*
remote_gov_cca_ports__ParameterPort_getClassInfo(
  /* in */ struct gov_cca_ports__ParameterPort__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct sidl_ClassInfo__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      gov_cca_ports__ParameterPort__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getClassInfo", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca.ports._ParameterPort.getClassInfo.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = sidl_ClassInfo__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE EPV: create remote entry point vectors (EPVs). */
static void gov_cca_ports__ParameterPort__init_remote_epv(void)
{
  /* assert( HAVE_LOCKED_STATIC_GLOBALS ); */
  struct gov_cca_ports__ParameterPort__epv*     epv = 
    &s_rem_epv__gov_cca_ports__parameterport;
  struct gov_cca_Port__epv*                     e0  = &s_rem_epv__gov_cca_port;
  struct gov_cca_ports_BasicParameterPort__epv* e1  = 
    &s_rem_epv__gov_cca_ports_basicparameterport;
  struct gov_cca_ports_ParameterPort__epv*      e2  = 
    &s_rem_epv__gov_cca_ports_parameterport;
  struct sidl_BaseInterface__epv*               e3  = 
    &s_rem_epv__sidl_baseinterface;

  epv->f__cast                         = 
    remote_gov_cca_ports__ParameterPort__cast;
  epv->f__delete                       = 
    remote_gov_cca_ports__ParameterPort__delete;
  epv->f__exec                         = 
    remote_gov_cca_ports__ParameterPort__exec;
  epv->f__getURL                       = 
    remote_gov_cca_ports__ParameterPort__getURL;
  epv->f__raddRef                      = 
    remote_gov_cca_ports__ParameterPort__raddRef;
  epv->f__isRemote                     = 
    remote_gov_cca_ports__ParameterPort__isRemote;
  epv->f__set_hooks                    = 
    remote_gov_cca_ports__ParameterPort__set_hooks;
  epv->f__set_contracts                = 
    remote_gov_cca_ports__ParameterPort__set_contracts;
  epv->f__dump_stats                   = 
    remote_gov_cca_ports__ParameterPort__dump_stats;
  epv->f__ctor                         = NULL;
  epv->f__ctor2                        = NULL;
  epv->f__dtor                         = NULL;
  epv->f_readTitle                     = 
    remote_gov_cca_ports__ParameterPort_readTitle;
  epv->f_readGroupNames                = 
    remote_gov_cca_ports__ParameterPort_readGroupNames;
  epv->f_readGroupTitle                = 
    remote_gov_cca_ports__ParameterPort_readGroupTitle;
  epv->f_readGroupKeys                 = 
    remote_gov_cca_ports__ParameterPort_readGroupKeys;
  epv->f_readHelp                      = 
    remote_gov_cca_ports__ParameterPort_readHelp;
  epv->f_readPrompt                    = 
    remote_gov_cca_ports__ParameterPort_readPrompt;
  epv->f_hasBounds                     = 
    remote_gov_cca_ports__ParameterPort_hasBounds;
  epv->f_hasChoices                    = 
    remote_gov_cca_ports__ParameterPort_hasChoices;
  epv->f_readDefaultBoolean            = 
    remote_gov_cca_ports__ParameterPort_readDefaultBoolean;
  epv->f_readDefaultString             = 
    remote_gov_cca_ports__ParameterPort_readDefaultString;
  epv->f_readDefaultInt                = 
    remote_gov_cca_ports__ParameterPort_readDefaultInt;
  epv->f_readDefaultLong               = 
    remote_gov_cca_ports__ParameterPort_readDefaultLong;
  epv->f_readDefaultFloat              = 
    remote_gov_cca_ports__ParameterPort_readDefaultFloat;
  epv->f_readDefaultDouble             = 
    remote_gov_cca_ports__ParameterPort_readDefaultDouble;
  epv->f_readDefaultFcomplex           = 
    remote_gov_cca_ports__ParameterPort_readDefaultFcomplex;
  epv->f_readDefaultDcomplex           = 
    remote_gov_cca_ports__ParameterPort_readDefaultDcomplex;
  epv->f_readDefaultStringArray        = 
    remote_gov_cca_ports__ParameterPort_readDefaultStringArray;
  epv->f_readDefaultBooleanArray       = 
    remote_gov_cca_ports__ParameterPort_readDefaultBooleanArray;
  epv->f_readDefaultIntArray           = 
    remote_gov_cca_ports__ParameterPort_readDefaultIntArray;
  epv->f_readDefaultLongArray          = 
    remote_gov_cca_ports__ParameterPort_readDefaultLongArray;
  epv->f_readDefaultFloatArray         = 
    remote_gov_cca_ports__ParameterPort_readDefaultFloatArray;
  epv->f_readDefaultDoubleArray        = 
    remote_gov_cca_ports__ParameterPort_readDefaultDoubleArray;
  epv->f_readDefaultFcomplexArray      = 
    remote_gov_cca_ports__ParameterPort_readDefaultFcomplexArray;
  epv->f_readDefaultDcomplexArray      = 
    remote_gov_cca_ports__ParameterPort_readDefaultDcomplexArray;
  epv->f_readBoundsInt                 = 
    remote_gov_cca_ports__ParameterPort_readBoundsInt;
  epv->f_readBoundsLong                = 
    remote_gov_cca_ports__ParameterPort_readBoundsLong;
  epv->f_readBoundsFloat               = 
    remote_gov_cca_ports__ParameterPort_readBoundsFloat;
  epv->f_readBoundsDouble              = 
    remote_gov_cca_ports__ParameterPort_readBoundsDouble;
  epv->f_readChoicesString             = 
    remote_gov_cca_ports__ParameterPort_readChoicesString;
  epv->f_readChoicesInt                = 
    remote_gov_cca_ports__ParameterPort_readChoicesInt;
  epv->f_readChoicesLong               = 
    remote_gov_cca_ports__ParameterPort_readChoicesLong;
  epv->f_readChoicesFloat              = 
    remote_gov_cca_ports__ParameterPort_readChoicesFloat;
  epv->f_readChoicesDouble             = 
    remote_gov_cca_ports__ParameterPort_readChoicesDouble;
  epv->f_readChoicesFcomplex           = 
    remote_gov_cca_ports__ParameterPort_readChoicesFcomplex;
  epv->f_readChoicesDcomplex           = 
    remote_gov_cca_ports__ParameterPort_readChoicesDcomplex;
  epv->f_readConfigurationMap          = 
    remote_gov_cca_ports__ParameterPort_readConfigurationMap;
  epv->f_writeConfigurationMap         = 
    remote_gov_cca_ports__ParameterPort_writeConfigurationMap;
  epv->f_readConfigurationKeys         = 
    remote_gov_cca_ports__ParameterPort_readConfigurationKeys;
  epv->f_addRef                        = 
    remote_gov_cca_ports__ParameterPort_addRef;
  epv->f_deleteRef                     = 
    remote_gov_cca_ports__ParameterPort_deleteRef;
  epv->f_isSame                        = 
    remote_gov_cca_ports__ParameterPort_isSame;
  epv->f_isType                        = 
    remote_gov_cca_ports__ParameterPort_isType;
  epv->f_getClassInfo                  = 
    remote_gov_cca_ports__ParameterPort_getClassInfo;

  e0->f__cast          = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e0->f__delete        = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__delete;
  e0->f__getURL        = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e0->f__raddRef       = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__raddRef;
  e0->f__isRemote      = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e0->f__set_hooks     = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e0->f__set_contracts = (void (*)(void*, sidl_bool, const char*, sidl_bool, 
    struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e0->f__dump_stats    = (void (*)(void*, const char*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__dump_stats;
  e0->f__exec          = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e0->f_addRef         = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_addRef;
  e0->f_deleteRef      = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_deleteRef;
  e0->f_isSame         = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e0->f_isType         = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e0->f_getClassInfo   = (struct sidl_ClassInfo__object* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_getClassInfo;

  e1->f__cast                 = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e1->f__delete               = (void (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__delete;
  e1->f__getURL               = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e1->f__raddRef              = (void (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__raddRef;
  e1->f__isRemote             = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e1->f__set_hooks            = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e1->f__set_contracts        = (void (*)(void*, sidl_bool, const char*, 
    sidl_bool, struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e1->f__dump_stats           = (void (*)(void*, const char*, const char*, 
    struct sidl_BaseInterface__object**)) epv->f__dump_stats;
  e1->f__exec                 = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e1->f_readConfigurationMap  = (struct gov_cca_TypeMap__object* (*)(void*,
    struct sidl_BaseInterface__object **)) epv->f_readConfigurationMap;
  e1->f_writeConfigurationMap = (void (*)(void*,struct gov_cca_TypeMap__object*,
    struct sidl_BaseInterface__object **)) epv->f_writeConfigurationMap;
  e1->f_readConfigurationKeys = (struct sidl_string__array* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_readConfigurationKeys;
  e1->f_addRef                = (void (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_addRef;
  e1->f_deleteRef             = (void (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_deleteRef;
  e1->f_isSame                = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e1->f_isType                = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e1->f_getClassInfo          = (struct sidl_ClassInfo__object* (*)(void*,
    struct sidl_BaseInterface__object **)) epv->f_getClassInfo;

  e2->f__cast                    = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e2->f__delete                  = (void (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__delete;
  e2->f__getURL                  = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e2->f__raddRef                 = (void (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__raddRef;
  e2->f__isRemote                = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e2->f__set_hooks               = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e2->f__set_contracts           = (void (*)(void*, sidl_bool, const char*, 
    sidl_bool, struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e2->f__dump_stats              = (void (*)(void*, const char*, const char*, 
    struct sidl_BaseInterface__object**)) epv->f__dump_stats;
  e2->f__exec                    = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e2->f_readTitle                = (char* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_readTitle;
  e2->f_readGroupNames           = (struct sidl_string__array* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_readGroupNames;
  e2->f_readGroupTitle           = (char* (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_readGroupTitle;
  e2->f_readGroupKeys            = (struct sidl_string__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readGroupKeys;
  e2->f_readHelp                 = (char* (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_readHelp;
  e2->f_readPrompt               = (char* (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_readPrompt;
  e2->f_hasBounds                = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_hasBounds;
  e2->f_hasChoices               = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_hasChoices;
  e2->f_readDefaultBoolean       = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_readDefaultBoolean;
  e2->f_readDefaultString        = (char* (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_readDefaultString;
  e2->f_readDefaultInt           = (int32_t (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_readDefaultInt;
  e2->f_readDefaultLong          = (int64_t (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_readDefaultLong;
  e2->f_readDefaultFloat         = (float (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_readDefaultFloat;
  e2->f_readDefaultDouble        = (double (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_readDefaultDouble;
  e2->f_readDefaultFcomplex      = (struct sidl_fcomplex (*)(void*,const char*,
    struct sidl_BaseInterface__object **)) epv->f_readDefaultFcomplex;
  e2->f_readDefaultDcomplex      = (struct sidl_dcomplex (*)(void*,const char*,
    struct sidl_BaseInterface__object **)) epv->f_readDefaultDcomplex;
  e2->f_readDefaultStringArray   = (struct sidl_string__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readDefaultStringArray;
  e2->f_readDefaultBooleanArray  = (struct sidl_bool__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readDefaultBooleanArray;
  e2->f_readDefaultIntArray      = (struct sidl_int__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readDefaultIntArray;
  e2->f_readDefaultLongArray     = (struct sidl_long__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readDefaultLongArray;
  e2->f_readDefaultFloatArray    = (struct sidl_float__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readDefaultFloatArray;
  e2->f_readDefaultDoubleArray   = (struct sidl_double__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readDefaultDoubleArray;
  e2->f_readDefaultFcomplexArray = (struct sidl_fcomplex__array* (*)(void*,
    const char*,struct sidl_BaseInterface__object **)) 
    epv->f_readDefaultFcomplexArray;
  e2->f_readDefaultDcomplexArray = (struct sidl_dcomplex__array* (*)(void*,
    const char*,struct sidl_BaseInterface__object **)) 
    epv->f_readDefaultDcomplexArray;
  e2->f_readBoundsInt            = (void (*)(void*,const char*,int32_t*,
    int32_t*,struct sidl_BaseInterface__object **)) epv->f_readBoundsInt;
  e2->f_readBoundsLong           = (void (*)(void*,const char*,int64_t*,
    int64_t*,struct sidl_BaseInterface__object **)) epv->f_readBoundsLong;
  e2->f_readBoundsFloat          = (void (*)(void*,const char*,float*,float*,
    struct sidl_BaseInterface__object **)) epv->f_readBoundsFloat;
  e2->f_readBoundsDouble         = (void (*)(void*,const char*,double*,double*,
    struct sidl_BaseInterface__object **)) epv->f_readBoundsDouble;
  e2->f_readChoicesString        = (struct sidl_string__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readChoicesString;
  e2->f_readChoicesInt           = (struct sidl_int__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readChoicesInt;
  e2->f_readChoicesLong          = (struct sidl_long__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readChoicesLong;
  e2->f_readChoicesFloat         = (struct sidl_float__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readChoicesFloat;
  e2->f_readChoicesDouble        = (struct sidl_double__array* (*)(void*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_readChoicesDouble;
  e2->f_readChoicesFcomplex      = (struct sidl_fcomplex__array* (*)(void*,
    const char*,struct sidl_BaseInterface__object **)) 
    epv->f_readChoicesFcomplex;
  e2->f_readChoicesDcomplex      = (struct sidl_dcomplex__array* (*)(void*,
    const char*,struct sidl_BaseInterface__object **)) 
    epv->f_readChoicesDcomplex;
  e2->f_readConfigurationMap     = (struct gov_cca_TypeMap__object* (*)(void*,
    struct sidl_BaseInterface__object **)) epv->f_readConfigurationMap;
  e2->f_writeConfigurationMap    = (void (*)(void*,struct 
    gov_cca_TypeMap__object*,struct sidl_BaseInterface__object **)) 
    epv->f_writeConfigurationMap;
  e2->f_readConfigurationKeys    = (struct sidl_string__array* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_readConfigurationKeys;
  e2->f_addRef                   = (void (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_addRef;
  e2->f_deleteRef                = (void (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_deleteRef;
  e2->f_isSame                   = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e2->f_isType                   = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e2->f_getClassInfo             = (struct sidl_ClassInfo__object* (*)(void*,
    struct sidl_BaseInterface__object **)) epv->f_getClassInfo;

  e3->f__cast          = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e3->f__delete        = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__delete;
  e3->f__getURL        = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e3->f__raddRef       = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__raddRef;
  e3->f__isRemote      = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e3->f__set_hooks     = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e3->f__set_contracts = (void (*)(void*, sidl_bool, const char*, sidl_bool, 
    struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e3->f__dump_stats    = (void (*)(void*, const char*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__dump_stats;
  e3->f__exec          = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e3->f_addRef         = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_addRef;
  e3->f_deleteRef      = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_deleteRef;
  e3->f_isSame         = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e3->f_isType         = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e3->f_getClassInfo   = (struct sidl_ClassInfo__object* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_getClassInfo;

  s_remote_initialized = 1;
}

/* Create an instance that connects to an existing remote object. */
static struct gov_cca_ports_ParameterPort__object*
gov_cca_ports_ParameterPort__remoteConnect(const char *url, sidl_bool ar, 
  struct sidl_BaseInterface__object* *_ex)
{
  struct gov_cca_ports__ParameterPort__object* self = NULL;

  struct gov_cca_ports__ParameterPort__object* s0;

  struct gov_cca_ports__ParameterPort__remote* r_obj = NULL;
  sidl_rmi_InstanceHandle instance = NULL;
  struct gov_cca_ports_ParameterPort__object* ret_self = NULL;
  char* objectID = NULL;
  objectID = sidl_rmi_ServerRegistry_isLocalObject(url, _ex);
  if(objectID) {
    sidl_BaseInterface bi = (sidl_BaseInterface) 
      sidl_rmi_InstanceRegistry_getInstanceByString(objectID, _ex);
    return (struct gov_cca_ports_ParameterPort__object*)(*bi->d_epv->f__cast)(
      bi->d_object, "gov.cca.ports.ParameterPort", _ex);
  }
  instance = sidl_rmi_ProtocolFactory_connectInstance(url, 
    "gov.cca.ports.ParameterPort", ar, _ex );
  if ( instance == NULL) { return NULL; }
  self =
    (struct gov_cca_ports__ParameterPort__object*) malloc(
      sizeof(struct gov_cca_ports__ParameterPort__object));

  r_obj =
    (struct gov_cca_ports__ParameterPort__remote*) malloc(
      sizeof(struct gov_cca_ports__ParameterPort__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "gov.cca.ports._ParameterPort.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                                        self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    gov_cca_ports__ParameterPort__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_gov_cca_port.d_epv    = &s_rem_epv__gov_cca_port;
  s0->d_gov_cca_port.d_object = (void*) self;

  s0->d_gov_cca_ports_basicparameterport.d_epv    = 
    &s_rem_epv__gov_cca_ports_basicparameterport;
  s0->d_gov_cca_ports_basicparameterport.d_object = (void*) self;

  s0->d_gov_cca_ports_parameterport.d_epv    = 
    &s_rem_epv__gov_cca_ports_parameterport;
  s0->d_gov_cca_ports_parameterport.d_object = (void*) self;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__gov_cca_ports__parameterport;

  self->d_data = (void*) r_obj;

  ret_self = (struct gov_cca_ports_ParameterPort__object*) (
    *self->d_epv->f__cast)(self, "gov.cca.ports.ParameterPort", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/* Create an instance that uses an already existing  */
/* InstanceHandel to connect to an existing remote object. */
static struct gov_cca_ports_ParameterPort__object*
gov_cca_ports_ParameterPort__IHConnect(sidl_rmi_InstanceHandle instance, struct 
  sidl_BaseInterface__object* *_ex)
{
  struct gov_cca_ports__ParameterPort__object* self = NULL;

  struct gov_cca_ports__ParameterPort__object* s0;

  struct gov_cca_ports__ParameterPort__remote* r_obj = NULL;
  struct gov_cca_ports_ParameterPort__object* ret_self = NULL;
  self =
    (struct gov_cca_ports__ParameterPort__object*) malloc(
      sizeof(struct gov_cca_ports__ParameterPort__object));

  r_obj =
    (struct gov_cca_ports__ParameterPort__remote*) malloc(
      sizeof(struct gov_cca_ports__ParameterPort__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "gov.cca.ports._ParameterPort.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                                        self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    gov_cca_ports__ParameterPort__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_gov_cca_port.d_epv    = &s_rem_epv__gov_cca_port;
  s0->d_gov_cca_port.d_object = (void*) self;

  s0->d_gov_cca_ports_basicparameterport.d_epv    = 
    &s_rem_epv__gov_cca_ports_basicparameterport;
  s0->d_gov_cca_ports_basicparameterport.d_object = (void*) self;

  s0->d_gov_cca_ports_parameterport.d_epv    = 
    &s_rem_epv__gov_cca_ports_parameterport;
  s0->d_gov_cca_ports_parameterport.d_object = (void*) self;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__gov_cca_ports__parameterport;

  self->d_data = (void*) r_obj;

  sidl_rmi_InstanceHandle_addRef(instance, _ex);

  ret_self = (struct gov_cca_ports_ParameterPort__object*) (
    *self->d_epv->f__cast)(self, "gov.cca.ports.ParameterPort", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/*
 * RMI connector function for the class.
 */

struct gov_cca_ports_ParameterPort__object*
gov_cca_ports_ParameterPort__connectI(const char* url, sidl_bool ar, struct 
  sidl_BaseInterface__object **_ex)
{
  return gov_cca_ports_ParameterPort__remoteConnect(url, ar, _ex);
}


#endif /*WITH_RMI*/
